
// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyfalkon_python.h"

// main header
#include "history_historyentry_wrapper.h"

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_History_HistoryEntry_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::History::HistoryEntry >()))
        return -1;

    ::History::HistoryEntry *cptr{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PyFalkon.History.HistoryEntry.__init__";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "HistoryEntry", 0, 1, &(pyArgs[0])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: HistoryEntry::HistoryEntry()
    // 1: HistoryEntry::HistoryEntry(History::HistoryEntry)
    if (numArgs == 0) {
        overloadId = 0; // HistoryEntry()
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(SbkPyFalkonTypes[SBK_HISTORY_HISTORYENTRY_IDX], (pyArgs[0])))) {
        overloadId = 1; // HistoryEntry(History::HistoryEntry)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, fullName);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // HistoryEntry()
        {

            if (Shiboken::Errors::occurred() == nullptr) {
                // HistoryEntry()
                cptr = new ::History::HistoryEntry();
            }
            break;
        }
        case 1: // HistoryEntry(const History::HistoryEntry & HistoryEntry)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::History::HistoryEntry cppArg0_local;
            ::History::HistoryEntry *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // HistoryEntry(History::HistoryEntry)
                cptr = new ::History::HistoryEntry(*cppArg0);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::History::HistoryEntry >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_History_HistoryEntry__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::History::HistoryEntry *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_HISTORY_HISTORYENTRY_IDX], reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(SbkPyFalkonTypes[SBK_HISTORY_HISTORYENTRY_IDX], &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_History_HistoryEntry_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_History_HistoryEntry_methods[] = {
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_History_HistoryEntry__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

static PyObject *Sbk_History_HistoryEntry_get_id(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::History::HistoryEntry *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_HISTORY_HISTORYENTRY_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    int cppOut_local = cppSelf->id;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<int>(), &cppOut_local);
    return pyOut;
}
static int Sbk_History_HistoryEntry_set_id(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::History::HistoryEntry *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_HISTORY_HISTORYENTRY_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("id");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("id", "int");
        return -1;
    }

    auto cppOut_local = cppSelf->id;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->id = cppOut_local;

    return 0;
}

static PyObject *Sbk_History_HistoryEntry_get_count(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::History::HistoryEntry *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_HISTORY_HISTORYENTRY_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    int cppOut_local = cppSelf->count;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<int>(), &cppOut_local);
    return pyOut;
}
static int Sbk_History_HistoryEntry_set_count(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::History::HistoryEntry *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_HISTORY_HISTORYENTRY_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("count");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("count", "int");
        return -1;
    }

    auto cppOut_local = cppSelf->count;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->count = cppOut_local;

    return 0;
}

static PyObject *Sbk_History_HistoryEntry_get_date(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::History::HistoryEntry *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_HISTORY_HISTORYENTRY_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyOut = {};
    if (reinterpret_cast<void *>(&(cppSelf->date)) == reinterpret_cast<void *>(cppSelf)) {
        pyOut = reinterpret_cast<PyObject *>(Shiboken::Object::findColocatedChild(reinterpret_cast<SbkObject *>(self), SbkPySide6_QtCoreTypes[SBK_QDATETIME_IDX]));
        if (pyOut != nullptr) {
            Py_IncRef(pyOut);
            return pyOut;
        }
    } else if (Shiboken::BindingManager::instance().hasWrapper(&(cppSelf->date))) {
        pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(&(cppSelf->date)));
        Py_IncRef(pyOut);
        return pyOut;
    }
    pyOut = Shiboken::Object::newObject(SbkPySide6_QtCoreTypes[SBK_QDATETIME_IDX], &(cppSelf->date), false, true);
    Shiboken::Object::setParent(self, pyOut);
    return pyOut;
}
static int Sbk_History_HistoryEntry_set_date(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::History::HistoryEntry *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_HISTORY_HISTORYENTRY_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("date");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppValueConversion(SbkPySide6_QtCoreTypes[SBK_QDATETIME_IDX], (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("date", "QDateTime");
        return -1;
    }

    auto &cppOut_ptr = cppSelf->date;
    pythonToCpp(pyIn, &cppOut_ptr);

    return 0;
}

static PyObject *Sbk_History_HistoryEntry_get_url(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::History::HistoryEntry *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_HISTORY_HISTORYENTRY_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyOut = {};
    if (reinterpret_cast<void *>(&(cppSelf->url)) == reinterpret_cast<void *>(cppSelf)) {
        pyOut = reinterpret_cast<PyObject *>(Shiboken::Object::findColocatedChild(reinterpret_cast<SbkObject *>(self), SbkPySide6_QtCoreTypes[SBK_QURL_IDX]));
        if (pyOut != nullptr) {
            Py_IncRef(pyOut);
            return pyOut;
        }
    } else if (Shiboken::BindingManager::instance().hasWrapper(&(cppSelf->url))) {
        pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(&(cppSelf->url)));
        Py_IncRef(pyOut);
        return pyOut;
    }
    pyOut = Shiboken::Object::newObject(SbkPySide6_QtCoreTypes[SBK_QURL_IDX], &(cppSelf->url), false, true);
    Shiboken::Object::setParent(self, pyOut);
    return pyOut;
}
static int Sbk_History_HistoryEntry_set_url(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::History::HistoryEntry *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_HISTORY_HISTORYENTRY_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("url");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppValueConversion(SbkPySide6_QtCoreTypes[SBK_QURL_IDX], (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("url", "QUrl");
        return -1;
    }

    auto &cppOut_ptr = cppSelf->url;
    pythonToCpp(pyIn, &cppOut_ptr);

    return 0;
}

static PyObject *Sbk_History_HistoryEntry_get_urlString(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::History::HistoryEntry *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_HISTORY_HISTORYENTRY_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QSTRING_IDX], &cppSelf->urlString);
    return pyOut;
}
static int Sbk_History_HistoryEntry_set_urlString(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::History::HistoryEntry *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_HISTORY_HISTORYENTRY_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("urlString");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QSTRING_IDX], (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("urlString", "QString");
        return -1;
    }

    auto &cppOut_ptr = cppSelf->urlString;
    pythonToCpp(pyIn, &cppOut_ptr);

    return 0;
}

static PyObject *Sbk_History_HistoryEntry_get_title(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::History::HistoryEntry *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_HISTORY_HISTORYENTRY_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QSTRING_IDX], &cppSelf->title);
    return pyOut;
}
static int Sbk_History_HistoryEntry_set_title(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::History::HistoryEntry *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_HISTORY_HISTORYENTRY_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("title");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QSTRING_IDX], (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("title", "QString");
        return -1;
    }

    auto &cppOut_ptr = cppSelf->title;
    pythonToCpp(pyIn, &cppOut_ptr);

    return 0;
}

// Getters and Setters for HistoryEntry
static PyGetSetDef Sbk_History_HistoryEntry_getsetlist[] = {
    {const_cast<char *>("id"), Sbk_History_HistoryEntry_get_id, Sbk_History_HistoryEntry_set_id, nullptr, nullptr},
    {const_cast<char *>("count"), Sbk_History_HistoryEntry_get_count, Sbk_History_HistoryEntry_set_count, nullptr, nullptr},
    {const_cast<char *>("date"), Sbk_History_HistoryEntry_get_date, Sbk_History_HistoryEntry_set_date, nullptr, nullptr},
    {const_cast<char *>("url"), Sbk_History_HistoryEntry_get_url, Sbk_History_HistoryEntry_set_url, nullptr, nullptr},
    {const_cast<char *>("urlString"), Sbk_History_HistoryEntry_get_urlString, Sbk_History_HistoryEntry_set_urlString, nullptr, nullptr},
    {const_cast<char *>("title"), Sbk_History_HistoryEntry_get_title, Sbk_History_HistoryEntry_set_title, nullptr, nullptr},
    {nullptr, nullptr, nullptr, nullptr, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_History_HistoryEntry_traverse(PyObject *self, visitproc visit, void *arg)
{
    return SbkObject_TypeF()->tp_traverse(self, visit, arg);
}
static int Sbk_History_HistoryEntry_clear(PyObject *self)
{
    return reinterpret_cast<PyTypeObject *>(SbkObject_TypeF())->tp_clear(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_History_HistoryEntry_Type = nullptr;
static PyTypeObject *Sbk_History_HistoryEntry_TypeF(void)
{
    return _Sbk_History_HistoryEntry_Type;
}

static PyType_Slot Sbk_History_HistoryEntry_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_History_HistoryEntry_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_History_HistoryEntry_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_History_HistoryEntry_methods)},
    {Py_tp_getset,      reinterpret_cast<void *>(Sbk_History_HistoryEntry_getsetlist)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_History_HistoryEntry_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_History_HistoryEntry_spec = {
    "1:PyFalkon.History.HistoryEntry",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_History_HistoryEntry_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void HistoryEntry_PythonToCpp_HistoryEntry_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_History_HistoryEntry_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_HistoryEntry_PythonToCpp_HistoryEntry_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_History_HistoryEntry_TypeF()))
        return HistoryEntry_PythonToCpp_HistoryEntry_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *HistoryEntry_PTR_CppToPython_HistoryEntry(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    bool changedTypeName = false;
    auto *tCppIn = reinterpret_cast<const ::History::HistoryEntry *>(cppIn);
    const char *typeName = typeid(*tCppIn).name();
    auto *sbkType = Shiboken::ObjectType::typeForTypeName(typeName);
    if (sbkType != nullptr && Shiboken::ObjectType::hasSpecialCastFunction(sbkType)) {
        typeName = Shiboken::typeNameOf(typeid(*tCppIn).name());
        changedTypeName = true;
    }
    PyObject *result = Shiboken::Object::newObject(Sbk_History_HistoryEntry_TypeF(), const_cast<void *>(cppIn), false, /* exactType */ changedTypeName, typeName);
    if (changedTypeName)
        delete [] typeName;
    return result;
}

// C++ to Python copy conversion.
static PyObject *HistoryEntry_COPY_CppToPython_HistoryEntry(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::History::HistoryEntry *>(cppIn);
    return Shiboken::Object::newObject(Sbk_History_HistoryEntry_TypeF(), new ::History::HistoryEntry(*source), true, true);
}

// Python to C++ copy conversion.
static void HistoryEntry_PythonToCpp_HistoryEntry_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::History::HistoryEntry *>(cppOut) = *reinterpret_cast< ::History::HistoryEntry *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_HISTORY_HISTORYENTRY_IDX], reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_HistoryEntry_PythonToCpp_HistoryEntry_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_History_HistoryEntry_TypeF()))
        return HistoryEntry_PythonToCpp_HistoryEntry_COPY;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *History_HistoryEntry_SignatureStrings[] = {
    "1:PyFalkon.History.HistoryEntry(self)",
    "0:PyFalkon.History.HistoryEntry(self,HistoryEntry:PyFalkon.History.HistoryEntry)",
    "PyFalkon.History.HistoryEntry.__copy__()",
    nullptr}; // Sentinel

void init_History_HistoryEntry(PyObject *enclosingClass)
{
    _Sbk_History_HistoryEntry_Type = Shiboken::ObjectType::introduceWrapperType(
        enclosingClass,
        "HistoryEntry",
        "History::HistoryEntry",
        &Sbk_History_HistoryEntry_spec,
        &Shiboken::callCppDestructor< ::History::HistoryEntry >,
        nullptr,
        0,
        Shiboken::ObjectType::WrapperFlags::InnerClass);
    auto *pyType = Sbk_History_HistoryEntry_TypeF(); // references _Sbk_History_HistoryEntry_Type
    InitSignatureStrings(pyType, History_HistoryEntry_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_History_HistoryEntry_PropertyStrings);
    SbkPyFalkonTypes[SBK_HISTORY_HISTORYENTRY_IDX] = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        HistoryEntry_PythonToCpp_HistoryEntry_PTR,
        is_HistoryEntry_PythonToCpp_HistoryEntry_PTR_Convertible,
        HistoryEntry_PTR_CppToPython_HistoryEntry,
        HistoryEntry_COPY_CppToPython_HistoryEntry);

    Shiboken::Conversions::registerConverterName(converter, "History::HistoryEntry");
    Shiboken::Conversions::registerConverterName(converter, "History::HistoryEntry*");
    Shiboken::Conversions::registerConverterName(converter, "History::HistoryEntry&");
    Shiboken::Conversions::registerConverterName(converter, "HistoryEntry");
    Shiboken::Conversions::registerConverterName(converter, "HistoryEntry*");
    Shiboken::Conversions::registerConverterName(converter, "HistoryEntry&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::History::HistoryEntry).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        HistoryEntry_PythonToCpp_HistoryEntry_COPY,
        is_HistoryEntry_PythonToCpp_HistoryEntry_COPY_Convertible);

    qRegisterMetaType< ::History::HistoryEntry >("HistoryEntry");
    qRegisterMetaType< ::History::HistoryEntry >("History::HistoryEntry");
}
