
// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyfalkon_python.h"

// main header
#include "historyitem_wrapper.h"

// Argument includes
#include <historyitem.h>
#include <qicon.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_HistoryItem_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::HistoryItem >()))
        return -1;

    ::HistoryItem *cptr{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PyFalkon.HistoryItem.__init__";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths
    errInfo.reset(Shiboken::checkInvalidArgumentCount(numArgs, 0, 1));
    if (!errInfo.isNull())
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);

    if (PyArg_ParseTuple(args, "|O:HistoryItem", &(pyArgs[0])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: HistoryItem::HistoryItem(HistoryItem*)
    if (numArgs == 0) {
        overloadId = 0; // HistoryItem(HistoryItem*)
    } else if (numArgs >= 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppPointerConversion(SbkPyFalkonTypes[SBK_HISTORYITEM_IDX], (pyArgs[0])))) {
        overloadId = 0; // HistoryItem(HistoryItem*)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, fullName);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    {
        if (kwds && PyDict_Size(kwds) > 0) {
            PyObject *value{};
            Shiboken::AutoDecRef kwds_dup(PyDict_Copy(kwds));
            static PyObject *const key_parent = Shiboken::String::createStaticString("parent");
            if (PyDict_Contains(kwds, key_parent) != 0) {
                value = PyDict_GetItem(kwds, key_parent);
                if (value != nullptr && pyArgs[0] != nullptr ) {
                    errInfo.reset(key_parent);
                    Py_INCREF(errInfo.object());
                    return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);
                }
                if (value != nullptr) {
                    pyArgs[0] = value;
                    if (!(pythonToCpp[0] = Shiboken::Conversions::pythonToCppPointerConversion(SbkPyFalkonTypes[SBK_HISTORYITEM_IDX], (pyArgs[0]))))
                        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);
                }
                PyDict_DelItem(kwds_dup, key_parent);
            }
            if (PyDict_Size(kwds_dup) > 0) {
                errInfo.reset(kwds_dup.release());
                return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);
            }
        }
        if (!Shiboken::Object::isValid(pyArgs[0]))
            return -1;
        ::HistoryItem *cppArg0 = nullptr;
        if (pythonToCpp[0])
            pythonToCpp[0](pyArgs[0], &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // HistoryItem(HistoryItem*)
            cptr = new ::HistoryItem(cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::HistoryItem >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_HistoryItemFunc_appendChild(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::HistoryItem *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_HISTORYITEM_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PyFalkon.HistoryItem.appendChild";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: HistoryItem::appendChild(HistoryItem*)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppPointerConversion(SbkPyFalkonTypes[SBK_HISTORYITEM_IDX], (pyArg)))) {
        overloadId = 0; // appendChild(HistoryItem*)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        if (!Shiboken::Object::isValid(pyArg))
            return {};
        ::HistoryItem *cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // appendChild(HistoryItem*)
            cppSelf->appendChild(cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_HistoryItemFunc_changeParent(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::HistoryItem *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_HISTORYITEM_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PyFalkon.HistoryItem.changeParent";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: HistoryItem::changeParent(HistoryItem*)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppPointerConversion(SbkPyFalkonTypes[SBK_HISTORYITEM_IDX], (pyArg)))) {
        overloadId = 0; // changeParent(HistoryItem*)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        if (!Shiboken::Object::isValid(pyArg))
            return {};
        ::HistoryItem *cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // changeParent(HistoryItem*)
            cppSelf->changeParent(cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_HistoryItemFunc_child(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::HistoryItem *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_HISTORYITEM_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PyFalkon.HistoryItem.child";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: HistoryItem::child(int)const->HistoryItem*
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArg)))) {
        overloadId = 0; // child(int)const
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        int cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // child(int)const
            HistoryItem * cppResult = const_cast<const ::HistoryItem *>(cppSelf)->child(cppArg0);
            pyResult = Shiboken::Conversions::pointerToPython(SbkPyFalkonTypes[SBK_HISTORYITEM_IDX], cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_HistoryItemFunc_childCount(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::HistoryItem *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_HISTORYITEM_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PyFalkon.HistoryItem.childCount";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // childCount()const
            int cppResult = const_cast<const ::HistoryItem *>(cppSelf)->childCount();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<int>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_HistoryItemFunc_endTimestamp(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::HistoryItem *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_HISTORYITEM_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PyFalkon.HistoryItem.endTimestamp";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // endTimestamp()const
            qint64 cppResult = const_cast<const ::HistoryItem *>(cppSelf)->endTimestamp();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<qint64>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_HistoryItemFunc_icon(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::HistoryItem *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_HISTORYITEM_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PyFalkon.HistoryItem.icon";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // icon()const
            QIcon cppResult = const_cast<const ::HistoryItem *>(cppSelf)->icon();
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtGuiTypes[SBK_QICON_IDX], &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_HistoryItemFunc_indexOfChild(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::HistoryItem *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_HISTORYITEM_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PyFalkon.HistoryItem.indexOfChild";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: HistoryItem::indexOfChild(HistoryItem*)->int
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppPointerConversion(SbkPyFalkonTypes[SBK_HISTORYITEM_IDX], (pyArg)))) {
        overloadId = 0; // indexOfChild(HistoryItem*)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        if (!Shiboken::Object::isValid(pyArg))
            return {};
        ::HistoryItem *cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // indexOfChild(HistoryItem*)
            int cppResult = cppSelf->indexOfChild(cppArg0);
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<int>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_HistoryItemFunc_insertChild(PyObject *self, PyObject *args)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::HistoryItem *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_HISTORYITEM_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PyFalkon.HistoryItem.insertChild";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[2];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr, nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "insertChild", 2, 2, &(pyArgs[0]), &(pyArgs[1])) == 0)
        return {};


    // Overloaded function decisor
    // 0: HistoryItem::insertChild(int,HistoryItem*)
    if (numArgs == 2
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArgs[0])))
        && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppPointerConversion(SbkPyFalkonTypes[SBK_HISTORYITEM_IDX], (pyArgs[1])))) {
        overloadId = 0; // insertChild(int,HistoryItem*)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(args, fullName, errInfo);

    // Call function/method
    {
        int cppArg0;
        pythonToCpp[0](pyArgs[0], &cppArg0);
        if (!Shiboken::Object::isValid(pyArgs[1]))
            return {};
        ::HistoryItem *cppArg1;
        pythonToCpp[1](pyArgs[1], &cppArg1);

        if (Shiboken::Errors::occurred() == nullptr) {
            // insertChild(int,HistoryItem*)
            cppSelf->insertChild(cppArg0, cppArg1);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_HistoryItemFunc_isTopLevel(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::HistoryItem *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_HISTORYITEM_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PyFalkon.HistoryItem.isTopLevel";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // isTopLevel()const
            bool cppResult = const_cast<const ::HistoryItem *>(cppSelf)->isTopLevel();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_HistoryItemFunc_parent(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::HistoryItem *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_HISTORYITEM_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PyFalkon.HistoryItem.parent";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // parent()const
            HistoryItem * cppResult = const_cast<const ::HistoryItem *>(cppSelf)->parent();
            pyResult = Shiboken::Conversions::pointerToPython(SbkPyFalkonTypes[SBK_HISTORYITEM_IDX], cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_HistoryItemFunc_prependChild(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::HistoryItem *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_HISTORYITEM_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PyFalkon.HistoryItem.prependChild";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: HistoryItem::prependChild(HistoryItem*)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppPointerConversion(SbkPyFalkonTypes[SBK_HISTORYITEM_IDX], (pyArg)))) {
        overloadId = 0; // prependChild(HistoryItem*)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        if (!Shiboken::Object::isValid(pyArg))
            return {};
        ::HistoryItem *cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // prependChild(HistoryItem*)
            cppSelf->prependChild(cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_HistoryItemFunc_removeChild(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::HistoryItem *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_HISTORYITEM_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PyFalkon.HistoryItem.removeChild";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: HistoryItem::removeChild(HistoryItem*)
    // 1: HistoryItem::removeChild(int)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArg)))) {
        overloadId = 1; // removeChild(int)
    } else if ((pythonToCpp = Shiboken::Conversions::pythonToCppPointerConversion(SbkPyFalkonTypes[SBK_HISTORYITEM_IDX], (pyArg)))) {
        overloadId = 0; // removeChild(HistoryItem*)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    switch (overloadId) {
        case 0: // removeChild(HistoryItem * child)
        {
            if (!Shiboken::Object::isValid(pyArg))
                return {};
            ::HistoryItem *cppArg0;
            pythonToCpp(pyArg, &cppArg0);

            if (Shiboken::Errors::occurred() == nullptr) {
                // removeChild(HistoryItem*)
                cppSelf->removeChild(cppArg0);
            }
            break;
        }
        case 1: // removeChild(int row)
        {
            int cppArg0;
            pythonToCpp(pyArg, &cppArg0);

            if (Shiboken::Errors::occurred() == nullptr) {
                // removeChild(int)
                cppSelf->removeChild(cppArg0);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_HistoryItemFunc_row(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::HistoryItem *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_HISTORYITEM_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PyFalkon.HistoryItem.row";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // row()
            int cppResult = cppSelf->row();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<int>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_HistoryItemFunc_setEndTimestamp(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::HistoryItem *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_HISTORYITEM_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PyFalkon.HistoryItem.setEndTimestamp";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: HistoryItem::setEndTimestamp(qint64)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<qint64>(), (pyArg)))) {
        overloadId = 0; // setEndTimestamp(qint64)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        qint64 cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // setEndTimestamp(qint64)
            cppSelf->setEndTimestamp(cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_HistoryItemFunc_setIcon(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::HistoryItem *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_HISTORYITEM_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PyFalkon.HistoryItem.setIcon";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: HistoryItem::setIcon(QIcon)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(SbkPySide6_QtGuiTypes[SBK_QICON_IDX], (pyArg)))) {
        overloadId = 0; // setIcon(QIcon)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        if (!Shiboken::Object::isValid(pyArg))
            return {};
        ::QIcon cppArg0_local;
        ::QIcon *cppArg0 = &cppArg0_local;
        if (pythonToCpp.isValue())
            pythonToCpp(pyArg, &cppArg0_local);
        else
            pythonToCpp(pyArg, &cppArg0);


        if (Shiboken::Errors::occurred() == nullptr) {
            // setIcon(QIcon)
            cppSelf->setIcon(*cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_HistoryItemFunc_setStartTimestamp(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::HistoryItem *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_HISTORYITEM_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PyFalkon.HistoryItem.setStartTimestamp";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: HistoryItem::setStartTimestamp(qint64)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<qint64>(), (pyArg)))) {
        overloadId = 0; // setStartTimestamp(qint64)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        qint64 cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // setStartTimestamp(qint64)
            cppSelf->setStartTimestamp(cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_HistoryItemFunc_startTimestamp(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::HistoryItem *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_HISTORYITEM_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PyFalkon.HistoryItem.startTimestamp";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // startTimestamp()const
            qint64 cppResult = const_cast<const ::HistoryItem *>(cppSelf)->startTimestamp();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<qint64>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_HistoryItem_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_HistoryItem_methods[] = {
    {"appendChild", reinterpret_cast<PyCFunction>(Sbk_HistoryItemFunc_appendChild), METH_O, nullptr},
    {"changeParent", reinterpret_cast<PyCFunction>(Sbk_HistoryItemFunc_changeParent), METH_O, nullptr},
    {"child", reinterpret_cast<PyCFunction>(Sbk_HistoryItemFunc_child), METH_O, nullptr},
    {"childCount", reinterpret_cast<PyCFunction>(Sbk_HistoryItemFunc_childCount), METH_NOARGS, nullptr},
    {"endTimestamp", reinterpret_cast<PyCFunction>(Sbk_HistoryItemFunc_endTimestamp), METH_NOARGS, nullptr},
    {"icon", reinterpret_cast<PyCFunction>(Sbk_HistoryItemFunc_icon), METH_NOARGS, nullptr},
    {"indexOfChild", reinterpret_cast<PyCFunction>(Sbk_HistoryItemFunc_indexOfChild), METH_O, nullptr},
    {"insertChild", reinterpret_cast<PyCFunction>(Sbk_HistoryItemFunc_insertChild), METH_VARARGS, nullptr},
    {"isTopLevel", reinterpret_cast<PyCFunction>(Sbk_HistoryItemFunc_isTopLevel), METH_NOARGS, nullptr},
    {"parent", reinterpret_cast<PyCFunction>(Sbk_HistoryItemFunc_parent), METH_NOARGS, nullptr},
    {"prependChild", reinterpret_cast<PyCFunction>(Sbk_HistoryItemFunc_prependChild), METH_O, nullptr},
    {"removeChild", reinterpret_cast<PyCFunction>(Sbk_HistoryItemFunc_removeChild), METH_O, nullptr},
    {"row", reinterpret_cast<PyCFunction>(Sbk_HistoryItemFunc_row), METH_NOARGS, nullptr},
    {"setEndTimestamp", reinterpret_cast<PyCFunction>(Sbk_HistoryItemFunc_setEndTimestamp), METH_O, nullptr},
    {"setIcon", reinterpret_cast<PyCFunction>(Sbk_HistoryItemFunc_setIcon), METH_O, nullptr},
    {"setStartTimestamp", reinterpret_cast<PyCFunction>(Sbk_HistoryItemFunc_setStartTimestamp), METH_O, nullptr},
    {"startTimestamp", reinterpret_cast<PyCFunction>(Sbk_HistoryItemFunc_startTimestamp), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

static PyObject *Sbk_HistoryItem_get_historyEntry(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::HistoryItem *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_HISTORYITEM_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyOut = {};
    if (reinterpret_cast<void *>(&(cppSelf->historyEntry)) == reinterpret_cast<void *>(cppSelf)) {
        pyOut = reinterpret_cast<PyObject *>(Shiboken::Object::findColocatedChild(reinterpret_cast<SbkObject *>(self), SbkPyFalkonTypes[SBK_HISTORY_HISTORYENTRY_IDX]));
        if (pyOut != nullptr) {
            Py_IncRef(pyOut);
            return pyOut;
        }
    } else if (Shiboken::BindingManager::instance().hasWrapper(&(cppSelf->historyEntry))) {
        pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(&(cppSelf->historyEntry)));
        Py_IncRef(pyOut);
        return pyOut;
    }
    pyOut = Shiboken::Object::newObject(SbkPyFalkonTypes[SBK_HISTORY_HISTORYENTRY_IDX], &(cppSelf->historyEntry), false, true);
    Shiboken::Object::setParent(self, pyOut);
    return pyOut;
}
static int Sbk_HistoryItem_set_historyEntry(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::HistoryItem *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_HISTORYITEM_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("historyEntry");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppValueConversion(SbkPyFalkonTypes[SBK_HISTORY_HISTORYENTRY_IDX], (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("historyEntry", "HistoryEntry");
        return -1;
    }

    auto &cppOut_ptr = cppSelf->historyEntry;
    pythonToCpp(pyIn, &cppOut_ptr);

    return 0;
}

static PyObject *Sbk_HistoryItem_get_title(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::HistoryItem *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_HISTORYITEM_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QSTRING_IDX], &cppSelf->title);
    return pyOut;
}
static int Sbk_HistoryItem_set_title(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::HistoryItem *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_HISTORYITEM_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("title");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QSTRING_IDX], (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("title", "QString");
        return -1;
    }

    auto &cppOut_ptr = cppSelf->title;
    pythonToCpp(pyIn, &cppOut_ptr);

    return 0;
}

static PyObject *Sbk_HistoryItem_get_canFetchMore(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::HistoryItem *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_HISTORYITEM_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    bool cppOut_local = cppSelf->canFetchMore;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppOut_local);
    return pyOut;
}
static int Sbk_HistoryItem_set_canFetchMore(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::HistoryItem *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_HISTORYITEM_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("canFetchMore");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("canFetchMore", "bool");
        return -1;
    }

    auto cppOut_local = cppSelf->canFetchMore;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->canFetchMore = cppOut_local;

    return 0;
}

// Getters and Setters for HistoryItem
static PyGetSetDef Sbk_HistoryItem_getsetlist[] = {
    {const_cast<char *>("historyEntry"), Sbk_HistoryItem_get_historyEntry, Sbk_HistoryItem_set_historyEntry, nullptr, nullptr},
    {const_cast<char *>("title"), Sbk_HistoryItem_get_title, Sbk_HistoryItem_set_title, nullptr, nullptr},
    {const_cast<char *>("canFetchMore"), Sbk_HistoryItem_get_canFetchMore, Sbk_HistoryItem_set_canFetchMore, nullptr, nullptr},
    {nullptr, nullptr, nullptr, nullptr, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_HistoryItem_traverse(PyObject *self, visitproc visit, void *arg)
{
    return SbkObject_TypeF()->tp_traverse(self, visit, arg);
}
static int Sbk_HistoryItem_clear(PyObject *self)
{
    return reinterpret_cast<PyTypeObject *>(SbkObject_TypeF())->tp_clear(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_HistoryItem_Type = nullptr;
static PyTypeObject *Sbk_HistoryItem_TypeF(void)
{
    return _Sbk_HistoryItem_Type;
}

static PyType_Slot Sbk_HistoryItem_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_HistoryItem_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_HistoryItem_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_HistoryItem_methods)},
    {Py_tp_getset,      reinterpret_cast<void *>(Sbk_HistoryItem_getsetlist)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_HistoryItem_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_HistoryItem_spec = {
    "1:PyFalkon.HistoryItem",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_HistoryItem_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void HistoryItem_PythonToCpp_HistoryItem_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_HistoryItem_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_HistoryItem_PythonToCpp_HistoryItem_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_HistoryItem_TypeF()))
        return HistoryItem_PythonToCpp_HistoryItem_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *HistoryItem_PTR_CppToPython_HistoryItem(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    bool changedTypeName = false;
    auto *tCppIn = reinterpret_cast<const ::HistoryItem *>(cppIn);
    const char *typeName = typeid(*tCppIn).name();
    auto *sbkType = Shiboken::ObjectType::typeForTypeName(typeName);
    if (sbkType != nullptr && Shiboken::ObjectType::hasSpecialCastFunction(sbkType)) {
        typeName = Shiboken::typeNameOf(typeid(*tCppIn).name());
        changedTypeName = true;
    }
    PyObject *result = Shiboken::Object::newObject(Sbk_HistoryItem_TypeF(), const_cast<void *>(cppIn), false, /* exactType */ changedTypeName, typeName);
    if (changedTypeName)
        delete [] typeName;
    return result;
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *HistoryItem_SignatureStrings[] = {
    "PyFalkon.HistoryItem(self,parent:PyFalkon.HistoryItem=nullptr)",
    "PyFalkon.HistoryItem.appendChild(self,child:PyFalkon.HistoryItem)",
    "PyFalkon.HistoryItem.changeParent(self,parent:PyFalkon.HistoryItem)",
    "PyFalkon.HistoryItem.child(self,row:int)->PyFalkon.HistoryItem",
    "PyFalkon.HistoryItem.childCount(self)->int",
    "PyFalkon.HistoryItem.endTimestamp(self)->qint64",
    "PyFalkon.HistoryItem.icon(self)->PySide6.QtGui.QIcon",
    "PyFalkon.HistoryItem.indexOfChild(self,child:PyFalkon.HistoryItem)->int",
    "PyFalkon.HistoryItem.insertChild(self,row:int,child:PyFalkon.HistoryItem)",
    "PyFalkon.HistoryItem.isTopLevel(self)->bool",
    "PyFalkon.HistoryItem.parent(self)->PyFalkon.HistoryItem",
    "PyFalkon.HistoryItem.prependChild(self,child:PyFalkon.HistoryItem)",
    "1:PyFalkon.HistoryItem.removeChild(self,child:PyFalkon.HistoryItem)",
    "0:PyFalkon.HistoryItem.removeChild(self,row:int)",
    "PyFalkon.HistoryItem.row(self)->int",
    "PyFalkon.HistoryItem.setEndTimestamp(self,end:qint64)",
    "PyFalkon.HistoryItem.setIcon(self,icon:typing.Union[PySide6.QtGui.QIcon, PySide6.QtGui.QPixmap])",
    "PyFalkon.HistoryItem.setStartTimestamp(self,start:qint64)",
    "PyFalkon.HistoryItem.startTimestamp(self)->qint64",
    nullptr}; // Sentinel

void init_HistoryItem(PyObject *module)
{
    _Sbk_HistoryItem_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "HistoryItem",
        "HistoryItem*",
        &Sbk_HistoryItem_spec,
        &Shiboken::callCppDestructor< ::HistoryItem >,
        nullptr,
        0,
        0);
    auto *pyType = Sbk_HistoryItem_TypeF(); // references _Sbk_HistoryItem_Type
    InitSignatureStrings(pyType, HistoryItem_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_HistoryItem_PropertyStrings);
    SbkPyFalkonTypes[SBK_HISTORYITEM_IDX] = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        HistoryItem_PythonToCpp_HistoryItem_PTR,
        is_HistoryItem_PythonToCpp_HistoryItem_PTR_Convertible,
        HistoryItem_PTR_CppToPython_HistoryItem);

    Shiboken::Conversions::registerConverterName(converter, "HistoryItem");
    Shiboken::Conversions::registerConverterName(converter, "HistoryItem*");
    Shiboken::Conversions::registerConverterName(converter, "HistoryItem&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::HistoryItem).name());

    qRegisterMetaType< ::HistoryItem *>();
}
