
// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyfalkon_python.h"

// main header
#include "loadrequest_wrapper.h"

// Argument includes
#include <QString>
#include <loadrequest.h>
#include <qbytearray.h>
#include <qurl.h>
#include <qwebenginehttprequest.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_LoadRequest_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::LoadRequest >()))
        return -1;

    ::LoadRequest *cptr{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PyFalkon.LoadRequest.__init__";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[3];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr, nullptr, nullptr};

    // invalid argument lengths
    errInfo.reset(Shiboken::checkInvalidArgumentCount(numArgs, 0, 3));
    if (!errInfo.isNull())
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);

    if (PyArg_ParseTuple(args, "|OOO:LoadRequest", &(pyArgs[0]), &(pyArgs[1]), &(pyArgs[2])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: LoadRequest::LoadRequest()
    // 1: LoadRequest::LoadRequest(LoadRequest)
    // 2: LoadRequest::LoadRequest(QUrl,LoadRequest::Operation,QByteArray)
    if (numArgs == 0) {
        overloadId = 0; // LoadRequest()
    } else if (numArgs >= 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(SbkPySide6_QtCoreTypes[SBK_QURL_IDX], (pyArgs[0])))) {
        if (numArgs == 1) {
            overloadId = 2; // LoadRequest(QUrl,LoadRequest::Operation,QByteArray)
        } else if (numArgs >= 2
            && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(SbkPyFalkonTypes[SBK_LOADREQUEST_OPERATION_IDX]))->converter, (pyArgs[1])))) {
            if (numArgs == 2) {
                overloadId = 2; // LoadRequest(QUrl,LoadRequest::Operation,QByteArray)
            } else if (numArgs >= 3
                && (pythonToCpp[2] = Shiboken::Conversions::pythonToCppReferenceConversion(SbkPySide6_QtCoreTypes[SBK_QBYTEARRAY_IDX], (pyArgs[2])))) {
                overloadId = 2; // LoadRequest(QUrl,LoadRequest::Operation,QByteArray)
            }
        }
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(SbkPyFalkonTypes[SBK_LOADREQUEST_IDX], (pyArgs[0])))) {
        overloadId = 1; // LoadRequest(LoadRequest)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, fullName);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // LoadRequest()
        {
            if (kwds != nullptr && PyDict_Size(kwds) > 0) {
                errInfo.reset(kwds);
                Py_INCREF(errInfo.object());
                return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);
            }

            if (Shiboken::Errors::occurred() == nullptr) {
                // LoadRequest()
                cptr = new ::LoadRequest();
            }
            break;
        }
        case 1: // LoadRequest(const LoadRequest & other)
        {
            if (kwds != nullptr && PyDict_Size(kwds) > 0) {
                errInfo.reset(kwds);
                Py_INCREF(errInfo.object());
                return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);
            }
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::LoadRequest cppArg0_local;
            ::LoadRequest *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // LoadRequest(LoadRequest)
                cptr = new ::LoadRequest(*cppArg0);
            }
            break;
        }
        case 2: // LoadRequest(const QUrl & url, LoadRequest::Operation op, const QByteArray & data)
        {
            if (kwds && PyDict_Size(kwds) > 0) {
                PyObject *value{};
                Shiboken::AutoDecRef kwds_dup(PyDict_Copy(kwds));
                static PyObject *const key_op = Shiboken::String::createStaticString("op");
                if (PyDict_Contains(kwds, key_op) != 0) {
                    value = PyDict_GetItem(kwds, key_op);
                    if (value != nullptr && pyArgs[1] != nullptr ) {
                        errInfo.reset(key_op);
                        Py_INCREF(errInfo.object());
                        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);
                    }
                    if (value != nullptr) {
                        pyArgs[1] = value;
                        if (!(pythonToCpp[1] = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(SbkPyFalkonTypes[SBK_LOADREQUEST_OPERATION_IDX]))->converter, (pyArgs[1]))))
                            return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);
                    }
                    PyDict_DelItem(kwds_dup, key_op);
                }
                static PyObject *const key_data = Shiboken::String::createStaticString("data");
                if (PyDict_Contains(kwds, key_data) != 0) {
                    value = PyDict_GetItem(kwds, key_data);
                    if (value != nullptr && pyArgs[2] != nullptr ) {
                        errInfo.reset(key_data);
                        Py_INCREF(errInfo.object());
                        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);
                    }
                    if (value != nullptr) {
                        pyArgs[2] = value;
                        if (!(pythonToCpp[2] = Shiboken::Conversions::pythonToCppReferenceConversion(SbkPySide6_QtCoreTypes[SBK_QBYTEARRAY_IDX], (pyArgs[2]))))
                            return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);
                    }
                    PyDict_DelItem(kwds_dup, key_data);
                }
                if (PyDict_Size(kwds_dup) > 0) {
                    errInfo.reset(kwds_dup.release());
                    return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);
                }
            }
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QUrl cppArg0_local;
            ::QUrl *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);

            ::LoadRequest::Operation cppArg1(LoadRequest::Operation::GetOperation);
            if (pythonToCpp[1])
                pythonToCpp[1](pyArgs[1], &cppArg1);
            if (!Shiboken::Object::isValid(pyArgs[2]))
                return -1;
            ::QByteArray cppArg2_local = QByteArray();
            ::QByteArray *cppArg2 = &cppArg2_local;
            if (pythonToCpp[2]) {
                if (pythonToCpp[2].isValue())
                    pythonToCpp[2](pyArgs[2], &cppArg2_local);
                else
                    pythonToCpp[2](pyArgs[2], &cppArg2);
                }

            if (Shiboken::Errors::occurred() == nullptr) {
                // LoadRequest(QUrl,LoadRequest::Operation,QByteArray)
                cptr = new ::LoadRequest(*cppArg0, cppArg1, *cppArg2);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::LoadRequest >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_LoadRequestFunc_data(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::LoadRequest *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_LOADREQUEST_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PyFalkon.LoadRequest.data";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // data()const
            QByteArray cppResult = const_cast<const ::LoadRequest *>(cppSelf)->data();
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypes[SBK_QBYTEARRAY_IDX], &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_LoadRequestFunc_isValid(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::LoadRequest *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_LOADREQUEST_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PyFalkon.LoadRequest.isValid";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // isValid()const
            bool cppResult = const_cast<const ::LoadRequest *>(cppSelf)->isValid();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_LoadRequestFunc_operation(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::LoadRequest *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_LOADREQUEST_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PyFalkon.LoadRequest.operation";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // operation()const
            LoadRequest::Operation cppResult = LoadRequest::Operation(const_cast<const ::LoadRequest *>(cppSelf)->operation());
            pyResult = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(SbkPyFalkonTypes[SBK_LOADREQUEST_OPERATION_IDX]))->converter, &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_LoadRequestFunc_setData(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::LoadRequest *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_LOADREQUEST_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PyFalkon.LoadRequest.setData";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: LoadRequest::setData(QByteArray)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(SbkPySide6_QtCoreTypes[SBK_QBYTEARRAY_IDX], (pyArg)))) {
        overloadId = 0; // setData(QByteArray)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        if (!Shiboken::Object::isValid(pyArg))
            return {};
        ::QByteArray cppArg0_local;
        ::QByteArray *cppArg0 = &cppArg0_local;
        if (pythonToCpp.isValue())
            pythonToCpp(pyArg, &cppArg0_local);
        else
            pythonToCpp(pyArg, &cppArg0);


        if (Shiboken::Errors::occurred() == nullptr) {
            // setData(QByteArray)
            cppSelf->setData(*cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_LoadRequestFunc_setOperation(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::LoadRequest *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_LOADREQUEST_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PyFalkon.LoadRequest.setOperation";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: LoadRequest::setOperation(LoadRequest::Operation)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(SbkPyFalkonTypes[SBK_LOADREQUEST_OPERATION_IDX]))->converter, (pyArg)))) {
        overloadId = 0; // setOperation(LoadRequest::Operation)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        ::LoadRequest::Operation cppArg0{LoadRequest::GetOperation};
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // setOperation(LoadRequest::Operation)
            cppSelf->setOperation(cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_LoadRequestFunc_setUrl(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::LoadRequest *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_LOADREQUEST_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PyFalkon.LoadRequest.setUrl";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: LoadRequest::setUrl(QUrl)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(SbkPySide6_QtCoreTypes[SBK_QURL_IDX], (pyArg)))) {
        overloadId = 0; // setUrl(QUrl)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        if (!Shiboken::Object::isValid(pyArg))
            return {};
        ::QUrl cppArg0_local;
        ::QUrl *cppArg0 = &cppArg0_local;
        if (pythonToCpp.isValue())
            pythonToCpp(pyArg, &cppArg0_local);
        else
            pythonToCpp(pyArg, &cppArg0);


        if (Shiboken::Errors::occurred() == nullptr) {
            // setUrl(QUrl)
            cppSelf->setUrl(*cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_LoadRequestFunc_url(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::LoadRequest *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_LOADREQUEST_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PyFalkon.LoadRequest.url";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // url()const
            QUrl cppResult = const_cast<const ::LoadRequest *>(cppSelf)->url();
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypes[SBK_QURL_IDX], &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_LoadRequestFunc_urlString(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::LoadRequest *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_LOADREQUEST_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PyFalkon.LoadRequest.urlString";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // urlString()const
            QString cppResult = const_cast<const ::LoadRequest *>(cppSelf)->urlString();
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QSTRING_IDX], &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_LoadRequestFunc_webRequest(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::LoadRequest *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_LOADREQUEST_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PyFalkon.LoadRequest.webRequest";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // webRequest()const
            QWebEngineHttpRequest* cppResult = new QWebEngineHttpRequest(const_cast<const ::LoadRequest *>(cppSelf)->webRequest());
            pyResult = Shiboken::Object::newObject(SbkPySide6_QtWebEngineCoreTypes[SBK_QWEBENGINEHTTPREQUEST_IDX], cppResult, true, true);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_LoadRequest__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::LoadRequest *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_LOADREQUEST_IDX], reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(SbkPyFalkonTypes[SBK_LOADREQUEST_IDX], &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_LoadRequest_PropertyStrings[] = {
    nullptr // Sentinel
};

static const char *Sbk_LoadRequest_EnumFlagInfo[] = {
    "Operation:IntEnum",
    nullptr // Sentinel
};

static PyMethodDef Sbk_LoadRequest_methods[] = {
    {"data", reinterpret_cast<PyCFunction>(Sbk_LoadRequestFunc_data), METH_NOARGS, nullptr},
    {"isValid", reinterpret_cast<PyCFunction>(Sbk_LoadRequestFunc_isValid), METH_NOARGS, nullptr},
    {"operation", reinterpret_cast<PyCFunction>(Sbk_LoadRequestFunc_operation), METH_NOARGS, nullptr},
    {"setData", reinterpret_cast<PyCFunction>(Sbk_LoadRequestFunc_setData), METH_O, nullptr},
    {"setOperation", reinterpret_cast<PyCFunction>(Sbk_LoadRequestFunc_setOperation), METH_O, nullptr},
    {"setUrl", reinterpret_cast<PyCFunction>(Sbk_LoadRequestFunc_setUrl), METH_O, nullptr},
    {"url", reinterpret_cast<PyCFunction>(Sbk_LoadRequestFunc_url), METH_NOARGS, nullptr},
    {"urlString", reinterpret_cast<PyCFunction>(Sbk_LoadRequestFunc_urlString), METH_NOARGS, nullptr},
    {"webRequest", reinterpret_cast<PyCFunction>(Sbk_LoadRequestFunc_webRequest), METH_NOARGS, nullptr},
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_LoadRequest__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_LoadRequest_traverse(PyObject *self, visitproc visit, void *arg)
{
    return SbkObject_TypeF()->tp_traverse(self, visit, arg);
}
static int Sbk_LoadRequest_clear(PyObject *self)
{
    return reinterpret_cast<PyTypeObject *>(SbkObject_TypeF())->tp_clear(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_LoadRequest_Type = nullptr;
static PyTypeObject *Sbk_LoadRequest_TypeF(void)
{
    return _Sbk_LoadRequest_Type;
}

static PyType_Slot Sbk_LoadRequest_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_LoadRequest_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_LoadRequest_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_LoadRequest_methods)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_LoadRequest_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_LoadRequest_spec = {
    "1:PyFalkon.LoadRequest",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_LoadRequest_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ enum conversion.
static void LoadRequest_Operation_PythonToCpp_LoadRequest_Operation(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::LoadRequest::Operation>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::LoadRequest::Operation *>(cppOut) = value;

}
static PythonToCppFunc is_LoadRequest_Operation_PythonToCpp_LoadRequest_Operation_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, SbkPyFalkonTypes[SBK_LOADREQUEST_OPERATION_IDX]))
        return LoadRequest_Operation_PythonToCpp_LoadRequest_Operation;
    return {};
}
static PyObject *LoadRequest_Operation_CppToPython_LoadRequest_Operation(const void *cppIn)
{
    const int castCppIn = int(*reinterpret_cast<const ::LoadRequest::Operation *>(cppIn));
    return Shiboken::Enum::newItem(SbkPyFalkonTypes[SBK_LOADREQUEST_OPERATION_IDX], castCppIn);

}

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void LoadRequest_PythonToCpp_LoadRequest_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_LoadRequest_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_LoadRequest_PythonToCpp_LoadRequest_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_LoadRequest_TypeF()))
        return LoadRequest_PythonToCpp_LoadRequest_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *LoadRequest_PTR_CppToPython_LoadRequest(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    bool changedTypeName = false;
    auto *tCppIn = reinterpret_cast<const ::LoadRequest *>(cppIn);
    const char *typeName = typeid(*tCppIn).name();
    auto *sbkType = Shiboken::ObjectType::typeForTypeName(typeName);
    if (sbkType != nullptr && Shiboken::ObjectType::hasSpecialCastFunction(sbkType)) {
        typeName = Shiboken::typeNameOf(typeid(*tCppIn).name());
        changedTypeName = true;
    }
    PyObject *result = Shiboken::Object::newObject(Sbk_LoadRequest_TypeF(), const_cast<void *>(cppIn), false, /* exactType */ changedTypeName, typeName);
    if (changedTypeName)
        delete [] typeName;
    return result;
}

// C++ to Python copy conversion.
static PyObject *LoadRequest_COPY_CppToPython_LoadRequest(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::LoadRequest *>(cppIn);
    return Shiboken::Object::newObject(Sbk_LoadRequest_TypeF(), new ::LoadRequest(*source), true, true);
}

// Python to C++ copy conversion.
static void LoadRequest_PythonToCpp_LoadRequest_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::LoadRequest *>(cppOut) = *reinterpret_cast< ::LoadRequest *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_LOADREQUEST_IDX], reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_LoadRequest_PythonToCpp_LoadRequest_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_LoadRequest_TypeF()))
        return LoadRequest_PythonToCpp_LoadRequest_COPY;
    return {};
}

// Implicit conversions.
static void PySide6_QtCore_constQUrlREF_PythonToCpp_LoadRequest(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::LoadRequest *>(cppOut) = ::LoadRequest( *reinterpret_cast< ::QUrl *>(Shiboken::Conversions::cppPointer(SbkPySide6_QtCoreTypes[SBK_QURL_IDX], reinterpret_cast<SbkObject *>(pyIn))));
}
static PythonToCppFunc is_PySide6_QtCore_constQUrlREF_PythonToCpp_LoadRequest_Convertible(PyObject *pyIn)
{
    if (SbkObject_TypeCheck(SbkPySide6_QtCoreTypes[SBK_QURL_IDX], pyIn))
        return PySide6_QtCore_constQUrlREF_PythonToCpp_LoadRequest;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *LoadRequest_SignatureStrings[] = {
    "2:PyFalkon.LoadRequest(self)",
    "1:PyFalkon.LoadRequest(self,other:typing.Union[PyFalkon.LoadRequest, PySide6.QtCore.QUrl])",
    "0:PyFalkon.LoadRequest(self,url:typing.Union[PySide6.QtCore.QUrl, QString],op:PyFalkon.LoadRequest.Operation=LoadRequest.Operation.GetOperation,data:typing.Union[PySide6.QtCore.QByteArray, char*]=QByteArray())",
    "PyFalkon.LoadRequest.data(self)->PySide6.QtCore.QByteArray",
    "PyFalkon.LoadRequest.isValid(self)->bool",
    "PyFalkon.LoadRequest.operation(self)->PyFalkon.LoadRequest.Operation",
    "PyFalkon.LoadRequest.setData(self,data:typing.Union[PySide6.QtCore.QByteArray, char*])",
    "PyFalkon.LoadRequest.setOperation(self,op:PyFalkon.LoadRequest.Operation)",
    "PyFalkon.LoadRequest.setUrl(self,url:typing.Union[PySide6.QtCore.QUrl, QString])",
    "PyFalkon.LoadRequest.url(self)->PySide6.QtCore.QUrl",
    "PyFalkon.LoadRequest.urlString(self)->QString",
    "PyFalkon.LoadRequest.webRequest(self)->PySide6.QtWebEngineCore.QWebEngineHttpRequest",
    "PyFalkon.LoadRequest.__copy__()",
    nullptr}; // Sentinel

void init_LoadRequest(PyObject *module)
{
    _Sbk_LoadRequest_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "LoadRequest",
        "LoadRequest",
        &Sbk_LoadRequest_spec,
        &Shiboken::callCppDestructor< ::LoadRequest >,
        nullptr,
        0,
        0);
    auto *pyType = Sbk_LoadRequest_TypeF(); // references _Sbk_LoadRequest_Type
    InitSignatureStrings(pyType, LoadRequest_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_LoadRequest_PropertyStrings);
    SbkPyFalkonTypes[SBK_LOADREQUEST_IDX] = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        LoadRequest_PythonToCpp_LoadRequest_PTR,
        is_LoadRequest_PythonToCpp_LoadRequest_PTR_Convertible,
        LoadRequest_PTR_CppToPython_LoadRequest,
        LoadRequest_COPY_CppToPython_LoadRequest);

    Shiboken::Conversions::registerConverterName(converter, "LoadRequest");
    Shiboken::Conversions::registerConverterName(converter, "LoadRequest*");
    Shiboken::Conversions::registerConverterName(converter, "LoadRequest&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::LoadRequest).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        LoadRequest_PythonToCpp_LoadRequest_COPY,
        is_LoadRequest_PythonToCpp_LoadRequest_COPY_Convertible);
    // Add implicit conversions to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        PySide6_QtCore_constQUrlREF_PythonToCpp_LoadRequest,
        is_PySide6_QtCore_constQUrlREF_PythonToCpp_LoadRequest_Convertible);

    // Pass the ..._EnumFlagInfo to the class.
    SbkObjectType_SetEnumFlagInfo(pyType, Sbk_LoadRequest_EnumFlagInfo);

    // Initialization of enums.
    Shiboken::AutoDecRef tpDict{};
    PyTypeObject *EType{};

    // Initialization of enum 'Operation'.
    const char *Operation_Initializer[] = {
        "GetOperation",
        "PostOperation",
        nullptr};
    // "uint8_t" used instead of "unsigned int"
    constexpr uint8_t Operation_InitializerValues[] = {
        uint8_t(LoadRequest::Operation::GetOperation), //  0x00  0
        uint8_t(LoadRequest::Operation::PostOperation) //  0x01  1
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_LoadRequest_TypeF(),
        "1:PyFalkon.LoadRequest.Operation",
        Operation_Initializer, Operation_InitializerValues);
    SbkPyFalkonTypes[SBK_LOADREQUEST_OPERATION_IDX] = EType;
    // Register converter for enum 'LoadRequest::Operation'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            LoadRequest_Operation_CppToPython_LoadRequest_Operation);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            LoadRequest_Operation_PythonToCpp_LoadRequest_Operation,
            is_LoadRequest_Operation_PythonToCpp_LoadRequest_Operation_Convertible);
        Shiboken::Enum::setTypeConverter(EType, converter);
        Shiboken::Conversions::registerConverterName(converter, "LoadRequest::Operation");
        Shiboken::Conversions::registerConverterName(converter, "Operation");
    }
    // End of 'Operation' enum.

    qRegisterMetaType< ::LoadRequest >("LoadRequest");
    qRegisterMetaType< ::LoadRequest::Operation >("LoadRequest::Operation");
}
