
// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyfalkon_python.h"

// main header
#include "locationbar_loadaction_wrapper.h"

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_LocationBar_LoadAction_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::LocationBar::LoadAction >()))
        return -1;

    ::LocationBar::LoadAction *cptr{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PyFalkon.LocationBar.LoadAction.__init__";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "LoadAction", 0, 1, &(pyArgs[0])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: LoadAction::LoadAction()
    // 1: LoadAction::LoadAction(LocationBar::LoadAction)
    if (numArgs == 0) {
        overloadId = 0; // LoadAction()
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(SbkPyFalkonTypes[SBK_LOCATIONBAR_LOADACTION_IDX], (pyArgs[0])))) {
        overloadId = 1; // LoadAction(LocationBar::LoadAction)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, fullName);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // LoadAction()
        {

            if (Shiboken::Errors::occurred() == nullptr) {
                // LoadAction()
                cptr = new ::LocationBar::LoadAction();
            }
            break;
        }
        case 1: // LoadAction(const LocationBar::LoadAction & LoadAction)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::LocationBar::LoadAction cppArg0_local;
            ::LocationBar::LoadAction *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // LoadAction(LocationBar::LoadAction)
                cptr = new ::LocationBar::LoadAction(*cppArg0);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::LocationBar::LoadAction >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_LocationBar_LoadAction__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::LocationBar::LoadAction *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_LOCATIONBAR_LOADACTION_IDX], reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(SbkPyFalkonTypes[SBK_LOCATIONBAR_LOADACTION_IDX], &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_LocationBar_LoadAction_PropertyStrings[] = {
    nullptr // Sentinel
};

static const char *Sbk_LocationBar_LoadAction_EnumFlagInfo[] = {
    "Type:IntEnum",
    nullptr // Sentinel
};

static PyMethodDef Sbk_LocationBar_LoadAction_methods[] = {
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_LocationBar_LoadAction__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

static PyObject *Sbk_LocationBar_LoadAction_get_type(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::LocationBar::LoadAction *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_LOCATIONBAR_LOADACTION_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    ::LocationBar::LoadAction::Type cppOut_local = cppSelf->type;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(SbkPyFalkonTypes[SBK_LOCATIONBAR_LOADACTION_TYPE_IDX]))->converter, &cppOut_local);
    return pyOut;
}
static int Sbk_LocationBar_LoadAction_set_type(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::LocationBar::LoadAction *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_LOCATIONBAR_LOADACTION_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("type");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(SbkPyFalkonTypes[SBK_LOCATIONBAR_LOADACTION_TYPE_IDX]))->converter, (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("type", "Type");
        return -1;
    }

    auto cppOut_local = cppSelf->type;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->type = cppOut_local;

    return 0;
}

static PyObject *Sbk_LocationBar_LoadAction_get_searchEngine(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::LocationBar::LoadAction *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_LOCATIONBAR_LOADACTION_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyOut = {};
    if (reinterpret_cast<void *>(&(cppSelf->searchEngine)) == reinterpret_cast<void *>(cppSelf)) {
        pyOut = reinterpret_cast<PyObject *>(Shiboken::Object::findColocatedChild(reinterpret_cast<SbkObject *>(self), SbkPyFalkonTypes[SBK_SEARCHENGINESMANAGER_ENGINE_IDX]));
        if (pyOut != nullptr) {
            Py_IncRef(pyOut);
            return pyOut;
        }
    } else if (Shiboken::BindingManager::instance().hasWrapper(&(cppSelf->searchEngine))) {
        pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(&(cppSelf->searchEngine)));
        Py_IncRef(pyOut);
        return pyOut;
    }
    pyOut = Shiboken::Object::newObject(SbkPyFalkonTypes[SBK_SEARCHENGINESMANAGER_ENGINE_IDX], &(cppSelf->searchEngine), false, true);
    Shiboken::Object::setParent(self, pyOut);
    return pyOut;
}
static int Sbk_LocationBar_LoadAction_set_searchEngine(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::LocationBar::LoadAction *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_LOCATIONBAR_LOADACTION_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("searchEngine");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppValueConversion(SbkPyFalkonTypes[SBK_SEARCHENGINESMANAGER_ENGINE_IDX], (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("searchEngine", "Engine");
        return -1;
    }

    auto &cppOut_ptr = cppSelf->searchEngine;
    pythonToCpp(pyIn, &cppOut_ptr);

    return 0;
}

static PyObject *Sbk_LocationBar_LoadAction_get_bookmark(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::LocationBar::LoadAction *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_LOCATIONBAR_LOADACTION_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::pointerToPython(SbkPyFalkonTypes[SBK_BOOKMARKITEM_IDX], cppSelf->bookmark);
    return pyOut;
}
static int Sbk_LocationBar_LoadAction_set_bookmark(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::LocationBar::LoadAction *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_LOCATIONBAR_LOADACTION_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("bookmark");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppPointerConversion(SbkPyFalkonTypes[SBK_BOOKMARKITEM_IDX], (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("bookmark", "BookmarkItem");
        return -1;
    }

    auto *&cppOut_ptr = cppSelf->bookmark;
    pythonToCpp(pyIn, &cppOut_ptr);

    Shiboken::Object::keepReference(reinterpret_cast<SbkObject *>(self), "bookmark", pyIn);
    return 0;
}

static PyObject *Sbk_LocationBar_LoadAction_get_loadRequest(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::LocationBar::LoadAction *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_LOCATIONBAR_LOADACTION_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyOut = {};
    if (reinterpret_cast<void *>(&(cppSelf->loadRequest)) == reinterpret_cast<void *>(cppSelf)) {
        pyOut = reinterpret_cast<PyObject *>(Shiboken::Object::findColocatedChild(reinterpret_cast<SbkObject *>(self), SbkPyFalkonTypes[SBK_LOADREQUEST_IDX]));
        if (pyOut != nullptr) {
            Py_IncRef(pyOut);
            return pyOut;
        }
    } else if (Shiboken::BindingManager::instance().hasWrapper(&(cppSelf->loadRequest))) {
        pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(&(cppSelf->loadRequest)));
        Py_IncRef(pyOut);
        return pyOut;
    }
    pyOut = Shiboken::Object::newObject(SbkPyFalkonTypes[SBK_LOADREQUEST_IDX], &(cppSelf->loadRequest), false, true);
    Shiboken::Object::setParent(self, pyOut);
    return pyOut;
}
static int Sbk_LocationBar_LoadAction_set_loadRequest(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::LocationBar::LoadAction *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_LOCATIONBAR_LOADACTION_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("loadRequest");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppValueConversion(SbkPyFalkonTypes[SBK_LOADREQUEST_IDX], (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("loadRequest", "LoadRequest");
        return -1;
    }

    auto &cppOut_ptr = cppSelf->loadRequest;
    pythonToCpp(pyIn, &cppOut_ptr);

    return 0;
}

// Getters and Setters for LoadAction
static PyGetSetDef Sbk_LocationBar_LoadAction_getsetlist[] = {
    {const_cast<char *>("type"), Sbk_LocationBar_LoadAction_get_type, Sbk_LocationBar_LoadAction_set_type, nullptr, nullptr},
    {const_cast<char *>("searchEngine"), Sbk_LocationBar_LoadAction_get_searchEngine, Sbk_LocationBar_LoadAction_set_searchEngine, nullptr, nullptr},
    {const_cast<char *>("bookmark"), Sbk_LocationBar_LoadAction_get_bookmark, Sbk_LocationBar_LoadAction_set_bookmark, nullptr, nullptr},
    {const_cast<char *>("loadRequest"), Sbk_LocationBar_LoadAction_get_loadRequest, Sbk_LocationBar_LoadAction_set_loadRequest, nullptr, nullptr},
    {nullptr, nullptr, nullptr, nullptr, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_LocationBar_LoadAction_traverse(PyObject *self, visitproc visit, void *arg)
{
    return SbkObject_TypeF()->tp_traverse(self, visit, arg);
}
static int Sbk_LocationBar_LoadAction_clear(PyObject *self)
{
    return reinterpret_cast<PyTypeObject *>(SbkObject_TypeF())->tp_clear(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_LocationBar_LoadAction_Type = nullptr;
static PyTypeObject *Sbk_LocationBar_LoadAction_TypeF(void)
{
    return _Sbk_LocationBar_LoadAction_Type;
}

static PyType_Slot Sbk_LocationBar_LoadAction_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_LocationBar_LoadAction_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_LocationBar_LoadAction_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_LocationBar_LoadAction_methods)},
    {Py_tp_getset,      reinterpret_cast<void *>(Sbk_LocationBar_LoadAction_getsetlist)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_LocationBar_LoadAction_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_LocationBar_LoadAction_spec = {
    "1:PyFalkon.LocationBar.LoadAction",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_LocationBar_LoadAction_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ enum conversion.
static void LocationBar_LoadAction_Type_PythonToCpp_LocationBar_LoadAction_Type(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::LocationBar::LoadAction::Type>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::LocationBar::LoadAction::Type *>(cppOut) = value;

}
static PythonToCppFunc is_LocationBar_LoadAction_Type_PythonToCpp_LocationBar_LoadAction_Type_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, SbkPyFalkonTypes[SBK_LOCATIONBAR_LOADACTION_TYPE_IDX]))
        return LocationBar_LoadAction_Type_PythonToCpp_LocationBar_LoadAction_Type;
    return {};
}
static PyObject *LocationBar_LoadAction_Type_CppToPython_LocationBar_LoadAction_Type(const void *cppIn)
{
    const int castCppIn = int(*reinterpret_cast<const ::LocationBar::LoadAction::Type *>(cppIn));
    return Shiboken::Enum::newItem(SbkPyFalkonTypes[SBK_LOCATIONBAR_LOADACTION_TYPE_IDX], castCppIn);

}

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void LoadAction_PythonToCpp_LoadAction_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_LocationBar_LoadAction_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_LoadAction_PythonToCpp_LoadAction_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_LocationBar_LoadAction_TypeF()))
        return LoadAction_PythonToCpp_LoadAction_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *LoadAction_PTR_CppToPython_LoadAction(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    bool changedTypeName = false;
    auto *tCppIn = reinterpret_cast<const ::LocationBar::LoadAction *>(cppIn);
    const char *typeName = typeid(*tCppIn).name();
    auto *sbkType = Shiboken::ObjectType::typeForTypeName(typeName);
    if (sbkType != nullptr && Shiboken::ObjectType::hasSpecialCastFunction(sbkType)) {
        typeName = Shiboken::typeNameOf(typeid(*tCppIn).name());
        changedTypeName = true;
    }
    PyObject *result = Shiboken::Object::newObject(Sbk_LocationBar_LoadAction_TypeF(), const_cast<void *>(cppIn), false, /* exactType */ changedTypeName, typeName);
    if (changedTypeName)
        delete [] typeName;
    return result;
}

// C++ to Python copy conversion.
static PyObject *LoadAction_COPY_CppToPython_LoadAction(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::LocationBar::LoadAction *>(cppIn);
    return Shiboken::Object::newObject(Sbk_LocationBar_LoadAction_TypeF(), new ::LocationBar::LoadAction(*source), true, true);
}

// Python to C++ copy conversion.
static void LoadAction_PythonToCpp_LoadAction_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::LocationBar::LoadAction *>(cppOut) = *reinterpret_cast< ::LocationBar::LoadAction *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_LOCATIONBAR_LOADACTION_IDX], reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_LoadAction_PythonToCpp_LoadAction_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_LocationBar_LoadAction_TypeF()))
        return LoadAction_PythonToCpp_LoadAction_COPY;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *LocationBar_LoadAction_SignatureStrings[] = {
    "1:PyFalkon.LocationBar.LoadAction(self)",
    "0:PyFalkon.LocationBar.LoadAction(self,LoadAction:PyFalkon.LocationBar.LoadAction)",
    "PyFalkon.LocationBar.LoadAction.__copy__()",
    nullptr}; // Sentinel

void init_LocationBar_LoadAction(PyObject *enclosingClass)
{
    _Sbk_LocationBar_LoadAction_Type = Shiboken::ObjectType::introduceWrapperType(
        enclosingClass,
        "LoadAction",
        "LocationBar::LoadAction",
        &Sbk_LocationBar_LoadAction_spec,
        &Shiboken::callCppDestructor< ::LocationBar::LoadAction >,
        nullptr,
        0,
        Shiboken::ObjectType::WrapperFlags::InnerClass);
    auto *pyType = Sbk_LocationBar_LoadAction_TypeF(); // references _Sbk_LocationBar_LoadAction_Type
    InitSignatureStrings(pyType, LocationBar_LoadAction_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_LocationBar_LoadAction_PropertyStrings);
    SbkPyFalkonTypes[SBK_LOCATIONBAR_LOADACTION_IDX] = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        LoadAction_PythonToCpp_LoadAction_PTR,
        is_LoadAction_PythonToCpp_LoadAction_PTR_Convertible,
        LoadAction_PTR_CppToPython_LoadAction,
        LoadAction_COPY_CppToPython_LoadAction);

    Shiboken::Conversions::registerConverterName(converter, "LocationBar::LoadAction");
    Shiboken::Conversions::registerConverterName(converter, "LocationBar::LoadAction*");
    Shiboken::Conversions::registerConverterName(converter, "LocationBar::LoadAction&");
    Shiboken::Conversions::registerConverterName(converter, "LoadAction");
    Shiboken::Conversions::registerConverterName(converter, "LoadAction*");
    Shiboken::Conversions::registerConverterName(converter, "LoadAction&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::LocationBar::LoadAction).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        LoadAction_PythonToCpp_LoadAction_COPY,
        is_LoadAction_PythonToCpp_LoadAction_COPY_Convertible);

    // Pass the ..._EnumFlagInfo to the class.
    SbkObjectType_SetEnumFlagInfo(pyType, Sbk_LocationBar_LoadAction_EnumFlagInfo);

    // Initialization of enums.
    Shiboken::AutoDecRef tpDict{};
    PyTypeObject *EType{};

    // Initialization of enum 'Type'.
    const char *Type_Initializer[] = {
        "Invalid",
        "Search",
        "Bookmark",
        "Url",
        nullptr};
    // "uint8_t" used instead of "unsigned int"
    constexpr uint8_t Type_InitializerValues[] = {
        uint8_t(LocationBar::LoadAction::Type::Invalid),  //  0x00  0
        uint8_t(LocationBar::LoadAction::Type::Search),   //  0x01  1
        uint8_t(LocationBar::LoadAction::Type::Bookmark), //  0x02  2
        uint8_t(LocationBar::LoadAction::Type::Url)       //  0x03  3
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_LocationBar_LoadAction_TypeF(),
        "1:PyFalkon.LocationBar.LoadAction.Type",
        Type_Initializer, Type_InitializerValues);
    SbkPyFalkonTypes[SBK_LOCATIONBAR_LOADACTION_TYPE_IDX] = EType;
    // Register converter for enum 'LocationBar::LoadAction::Type'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            LocationBar_LoadAction_Type_CppToPython_LocationBar_LoadAction_Type);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            LocationBar_LoadAction_Type_PythonToCpp_LocationBar_LoadAction_Type,
            is_LocationBar_LoadAction_Type_PythonToCpp_LocationBar_LoadAction_Type_Convertible);
        Shiboken::Enum::setTypeConverter(EType, converter);
        Shiboken::Conversions::registerConverterName(converter, "LocationBar::LoadAction::Type");
        Shiboken::Conversions::registerConverterName(converter, "LoadAction::Type");
        Shiboken::Conversions::registerConverterName(converter, "Type");
    }
    // End of 'Type' enum.

    qRegisterMetaType< ::LocationBar::LoadAction >("LoadAction");
    qRegisterMetaType< ::LocationBar::LoadAction >("LocationBar::LoadAction");
    qRegisterMetaType< ::LocationBar::LoadAction::Type >("LoadAction::Type");
    qRegisterMetaType< ::LocationBar::LoadAction::Type >("LocationBar::LoadAction::Type");
}
