
// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqobject.h>
#include <pysidesignal.h>
#include <pysideproperty.h>
#include <signalmanager.h>
#include <pysidemetafunction.h>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyfalkon_python.h"

// main header
#include "mainapplication_wrapper.h"

// Wrappers
#include "qtsingleapplication_wrapper.h"

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>

// Native ---------------------------------------------------------

void MainApplicationWrapper::pysideInitQtMetaTypes()
{
    qRegisterMetaType< ::MainApplication::AfterLaunch >("MainApplication::AfterLaunch");
}

void MainApplicationWrapper::resetPyMethodCache()
{
    std::fill_n(m_PyMethodCache, sizeof(m_PyMethodCache) / sizeof(m_PyMethodCache[0]), false);
}

void MainApplicationWrapper::childEvent(::QChildEvent * event)
{
    if (m_PyMethodCache[0]) {
        return this->::QObject::childEvent(event);
    }
    Shiboken::GilState gil;
    if (Shiboken::Errors::occurred() != nullptr)
        return;
    static PyObject *nameCache[2] = {};
    static const char *funcName = "childEvent";
    Shiboken::AutoDecRef pyOverride(Shiboken::BindingManager::instance().getOverride(this, nameCache, funcName));
    if (pyOverride.isNull()) {
        m_PyMethodCache[0] = true;
        gil.release();
        return this->::QObject::childEvent(event);
    }

#if !defined(PYPY_VERSION) && !defined(Py_LIMITED_API) && PY_VERSION_HEX >= 0x03090000
    PyObject *pyArgArray[1] = {
        Shiboken::Conversions::pointerToPython(SbkPySide6_QtCoreTypes[SBK_QCHILDEVENT_IDX], event)
    };

    const bool invalidateArg1 = Py_REFCNT(pyArgArray[0]) == 1;
#else
    Shiboken::AutoDecRef pyArgs(Py_BuildValue("(N)",
        Shiboken::Conversions::pointerToPython(SbkPySide6_QtCoreTypes[SBK_QCHILDEVENT_IDX], event)
    ));
    bool invalidateArg1 = Py_REFCNT(PyTuple_GET_ITEM(pyArgs, 0)) == 1;
#endif

#if !defined(PYPY_VERSION) && !defined(Py_LIMITED_API) && PY_VERSION_HEX >= 0x03090000
    Shiboken::AutoDecRef pyResult(PyObject_Vectorcall(pyOverride, pyArgArray, 1, nullptr));
    if (invalidateArg1)
        Shiboken::Object::invalidate(pyArgArray[0]);
    Py_DECREF(pyArgArray[0]);
#else
    Shiboken::AutoDecRef pyResult(PyObject_Call(pyOverride, pyArgs, nullptr));
    if (invalidateArg1)
        Shiboken::Object::invalidate(PyTuple_GET_ITEM(pyArgs, 0));
#endif
    if (pyResult.isNull()) {
        // An error happened in python code!
        Shiboken::Errors::storeErrorOrPrint();
        return;
    }
}

void MainApplicationWrapper::connectNotify(const ::QMetaMethod & signal)
{
    if (m_PyMethodCache[1]) {
        return this->::QObject::connectNotify(signal);
    }
    Shiboken::GilState gil;
    if (Shiboken::Errors::occurred() != nullptr)
        return;
    static PyObject *nameCache[2] = {};
    static const char *funcName = "connectNotify";
    Shiboken::AutoDecRef pyOverride(Shiboken::BindingManager::instance().getOverride(this, nameCache, funcName));
    if (pyOverride.isNull()) {
        m_PyMethodCache[1] = true;
        gil.release();
        return this->::QObject::connectNotify(signal);
    }

#if !defined(PYPY_VERSION) && !defined(Py_LIMITED_API) && PY_VERSION_HEX >= 0x03090000
    PyObject *pyArgArray[1] = {
        Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypes[SBK_QMETAMETHOD_IDX], &signal)
    };
#else
    Shiboken::AutoDecRef pyArgs(Py_BuildValue("(N)",
        Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypes[SBK_QMETAMETHOD_IDX], &signal)
    ));
#endif

#if !defined(PYPY_VERSION) && !defined(Py_LIMITED_API) && PY_VERSION_HEX >= 0x03090000
    Shiboken::AutoDecRef pyResult(PyObject_Vectorcall(pyOverride, pyArgArray, 1, nullptr));
    Py_DECREF(pyArgArray[0]);
#else
    Shiboken::AutoDecRef pyResult(PyObject_Call(pyOverride, pyArgs, nullptr));
#endif
    if (pyResult.isNull()) {
        // An error happened in python code!
        Shiboken::Errors::storeErrorOrPrint();
        return;
    }
}

void MainApplicationWrapper::customEvent(::QEvent * event)
{
    if (m_PyMethodCache[2]) {
        return this->::QObject::customEvent(event);
    }
    Shiboken::GilState gil;
    if (Shiboken::Errors::occurred() != nullptr)
        return;
    static PyObject *nameCache[2] = {};
    static const char *funcName = "customEvent";
    Shiboken::AutoDecRef pyOverride(Shiboken::BindingManager::instance().getOverride(this, nameCache, funcName));
    if (pyOverride.isNull()) {
        m_PyMethodCache[2] = true;
        gil.release();
        return this->::QObject::customEvent(event);
    }

#if !defined(PYPY_VERSION) && !defined(Py_LIMITED_API) && PY_VERSION_HEX >= 0x03090000
    PyObject *pyArgArray[1] = {
        Shiboken::Conversions::pointerToPython(SbkPySide6_QtCoreTypes[SBK_QEVENT_IDX], event)
    };

    const bool invalidateArg1 = Py_REFCNT(pyArgArray[0]) == 1;
#else
    Shiboken::AutoDecRef pyArgs(Py_BuildValue("(N)",
        Shiboken::Conversions::pointerToPython(SbkPySide6_QtCoreTypes[SBK_QEVENT_IDX], event)
    ));
    bool invalidateArg1 = Py_REFCNT(PyTuple_GET_ITEM(pyArgs, 0)) == 1;
#endif

#if !defined(PYPY_VERSION) && !defined(Py_LIMITED_API) && PY_VERSION_HEX >= 0x03090000
    Shiboken::AutoDecRef pyResult(PyObject_Vectorcall(pyOverride, pyArgArray, 1, nullptr));
    if (invalidateArg1)
        Shiboken::Object::invalidate(pyArgArray[0]);
    Py_DECREF(pyArgArray[0]);
#else
    Shiboken::AutoDecRef pyResult(PyObject_Call(pyOverride, pyArgs, nullptr));
    if (invalidateArg1)
        Shiboken::Object::invalidate(PyTuple_GET_ITEM(pyArgs, 0));
#endif
    if (pyResult.isNull()) {
        // An error happened in python code!
        Shiboken::Errors::storeErrorOrPrint();
        return;
    }
}

void MainApplicationWrapper::disconnectNotify(const ::QMetaMethod & signal)
{
    if (m_PyMethodCache[3]) {
        return this->::QObject::disconnectNotify(signal);
    }
    Shiboken::GilState gil;
    if (Shiboken::Errors::occurred() != nullptr)
        return;
    static PyObject *nameCache[2] = {};
    static const char *funcName = "disconnectNotify";
    Shiboken::AutoDecRef pyOverride(Shiboken::BindingManager::instance().getOverride(this, nameCache, funcName));
    if (pyOverride.isNull()) {
        m_PyMethodCache[3] = true;
        gil.release();
        return this->::QObject::disconnectNotify(signal);
    }

#if !defined(PYPY_VERSION) && !defined(Py_LIMITED_API) && PY_VERSION_HEX >= 0x03090000
    PyObject *pyArgArray[1] = {
        Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypes[SBK_QMETAMETHOD_IDX], &signal)
    };
#else
    Shiboken::AutoDecRef pyArgs(Py_BuildValue("(N)",
        Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypes[SBK_QMETAMETHOD_IDX], &signal)
    ));
#endif

#if !defined(PYPY_VERSION) && !defined(Py_LIMITED_API) && PY_VERSION_HEX >= 0x03090000
    Shiboken::AutoDecRef pyResult(PyObject_Vectorcall(pyOverride, pyArgArray, 1, nullptr));
    Py_DECREF(pyArgArray[0]);
#else
    Shiboken::AutoDecRef pyResult(PyObject_Call(pyOverride, pyArgs, nullptr));
#endif
    if (pyResult.isNull()) {
        // An error happened in python code!
        Shiboken::Errors::storeErrorOrPrint();
        return;
    }
}

bool MainApplicationWrapper::event(::QEvent * arg__1)
{
    if (m_PyMethodCache[4])
        return this->::QApplication::event(arg__1);
    Shiboken::GilState gil;
    if (Shiboken::Errors::occurred() != nullptr)
        return false;
    static PyObject *nameCache[2] = {};
    static const char *funcName = "event";
    Shiboken::AutoDecRef pyOverride(Shiboken::BindingManager::instance().getOverride(this, nameCache, funcName));
    if (pyOverride.isNull()) {
        m_PyMethodCache[4] = true;
        gil.release();
        return this->::QApplication::event(arg__1);
    }

#if !defined(PYPY_VERSION) && !defined(Py_LIMITED_API) && PY_VERSION_HEX >= 0x03090000
    PyObject *pyArgArray[1] = {
        Shiboken::Conversions::pointerToPython(SbkPySide6_QtCoreTypes[SBK_QEVENT_IDX], arg__1)
    };

    const bool invalidateArg1 = Py_REFCNT(pyArgArray[0]) == 1;
#else
    Shiboken::AutoDecRef pyArgs(Py_BuildValue("(N)",
        Shiboken::Conversions::pointerToPython(SbkPySide6_QtCoreTypes[SBK_QEVENT_IDX], arg__1)
    ));
    bool invalidateArg1 = Py_REFCNT(PyTuple_GET_ITEM(pyArgs, 0)) == 1;
#endif

#if !defined(PYPY_VERSION) && !defined(Py_LIMITED_API) && PY_VERSION_HEX >= 0x03090000
    Shiboken::AutoDecRef pyResult(PyObject_Vectorcall(pyOverride, pyArgArray, 1, nullptr));
    if (invalidateArg1)
        Shiboken::Object::invalidate(pyArgArray[0]);
    Py_DECREF(pyArgArray[0]);
#else
    Shiboken::AutoDecRef pyResult(PyObject_Call(pyOverride, pyArgs, nullptr));
    if (invalidateArg1)
        Shiboken::Object::invalidate(PyTuple_GET_ITEM(pyArgs, 0));
#endif
    if (pyResult.isNull()) {
        // An error happened in python code!
        Shiboken::Errors::storeErrorOrPrint();
        return false;
    }
    // Check return type
    Shiboken::Conversions::PythonToCppConversion pythonToCpp =
        Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), pyResult);
    if (!pythonToCpp) {
        Shiboken::Warnings::warnInvalidReturnValue("MainApplication", funcName, "bool", Py_TYPE(pyResult)->tp_name);
        return false;
    }
    bool cppResult;
    pythonToCpp(pyResult, &cppResult);
    return cppResult;
}

bool MainApplicationWrapper::eventFilter(::QObject * watched, ::QEvent * event)
{
    if (m_PyMethodCache[5])
        return this->::QObject::eventFilter(watched, event);
    Shiboken::GilState gil;
    if (Shiboken::Errors::occurred() != nullptr)
        return false;
    static PyObject *nameCache[2] = {};
    static const char *funcName = "eventFilter";
    Shiboken::AutoDecRef pyOverride(Shiboken::BindingManager::instance().getOverride(this, nameCache, funcName));
    if (pyOverride.isNull()) {
        m_PyMethodCache[5] = true;
        gil.release();
        return this->::QObject::eventFilter(watched, event);
    }

#if !defined(PYPY_VERSION) && !defined(Py_LIMITED_API) && PY_VERSION_HEX >= 0x03090000
    PyObject *pyArgArray[2] = {
        Shiboken::Conversions::pointerToPython(SbkPySide6_QtCoreTypes[SBK_QOBJECT_IDX], watched),
        Shiboken::Conversions::pointerToPython(SbkPySide6_QtCoreTypes[SBK_QEVENT_IDX], event)
    };

    const bool invalidateArg2 = Py_REFCNT(pyArgArray[1]) == 1;
#else
    Shiboken::AutoDecRef pyArgs(Py_BuildValue("(NN)",
        Shiboken::Conversions::pointerToPython(SbkPySide6_QtCoreTypes[SBK_QOBJECT_IDX], watched),
        Shiboken::Conversions::pointerToPython(SbkPySide6_QtCoreTypes[SBK_QEVENT_IDX], event)
    ));
    bool invalidateArg2 = Py_REFCNT(PyTuple_GET_ITEM(pyArgs, 1)) == 1;
#endif

#if !defined(PYPY_VERSION) && !defined(Py_LIMITED_API) && PY_VERSION_HEX >= 0x03090000
    Shiboken::AutoDecRef pyResult(PyObject_Vectorcall(pyOverride, pyArgArray, 2, nullptr));
    if (invalidateArg2)
        Shiboken::Object::invalidate(pyArgArray[1]);
    Py_DECREF(pyArgArray[0]);
    Py_DECREF(pyArgArray[1]);
#else
    Shiboken::AutoDecRef pyResult(PyObject_Call(pyOverride, pyArgs, nullptr));
    if (invalidateArg2)
        Shiboken::Object::invalidate(PyTuple_GET_ITEM(pyArgs, 1));
#endif
    if (pyResult.isNull()) {
        // An error happened in python code!
        Shiboken::Errors::storeErrorOrPrint();
        return false;
    }
    // Check return type
    Shiboken::Conversions::PythonToCppConversion pythonToCpp =
        Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), pyResult);
    if (!pythonToCpp) {
        Shiboken::Warnings::warnInvalidReturnValue("MainApplication", funcName, "bool", Py_TYPE(pyResult)->tp_name);
        return false;
    }
    bool cppResult;
    pythonToCpp(pyResult, &cppResult);
    return cppResult;
}

bool MainApplicationWrapper::notify(::QObject * arg__1, ::QEvent * arg__2)
{
    if (m_PyMethodCache[6])
        return this->::QApplication::notify(arg__1, arg__2);
    Shiboken::GilState gil;
    if (Shiboken::Errors::occurred() != nullptr)
        return false;
    static PyObject *nameCache[2] = {};
    static const char *funcName = "notify";
    Shiboken::AutoDecRef pyOverride(Shiboken::BindingManager::instance().getOverride(this, nameCache, funcName));
    if (pyOverride.isNull()) {
        m_PyMethodCache[6] = true;
        gil.release();
        return this->::QApplication::notify(arg__1, arg__2);
    }

#if !defined(PYPY_VERSION) && !defined(Py_LIMITED_API) && PY_VERSION_HEX >= 0x03090000
    PyObject *pyArgArray[2] = {
        Shiboken::Conversions::pointerToPython(SbkPySide6_QtCoreTypes[SBK_QOBJECT_IDX], arg__1),
        Shiboken::Conversions::pointerToPython(SbkPySide6_QtCoreTypes[SBK_QEVENT_IDX], arg__2)
    };
#else
    Shiboken::AutoDecRef pyArgs(Py_BuildValue("(NN)",
        Shiboken::Conversions::pointerToPython(SbkPySide6_QtCoreTypes[SBK_QOBJECT_IDX], arg__1),
        Shiboken::Conversions::pointerToPython(SbkPySide6_QtCoreTypes[SBK_QEVENT_IDX], arg__2)
    ));
#endif

#if !defined(PYPY_VERSION) && !defined(Py_LIMITED_API) && PY_VERSION_HEX >= 0x03090000
    Shiboken::AutoDecRef pyResult(PyObject_Vectorcall(pyOverride, pyArgArray, 2, nullptr));
    Py_DECREF(pyArgArray[0]);
    Py_DECREF(pyArgArray[1]);
#else
    Shiboken::AutoDecRef pyResult(PyObject_Call(pyOverride, pyArgs, nullptr));
#endif
    if (pyResult.isNull()) {
        // An error happened in python code!
        Shiboken::Errors::storeErrorOrPrint();
        return false;
    }
    // Check return type
    Shiboken::Conversions::PythonToCppConversion pythonToCpp =
        Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), pyResult);
    if (!pythonToCpp) {
        Shiboken::Warnings::warnInvalidReturnValue("MainApplication", funcName, "bool", Py_TYPE(pyResult)->tp_name);
        return false;
    }
    bool cppResult;
    pythonToCpp(pyResult, &cppResult);
    return cppResult;
}

void MainApplicationWrapper::timerEvent(::QTimerEvent * event)
{
    if (m_PyMethodCache[7]) {
        return this->::QObject::timerEvent(event);
    }
    Shiboken::GilState gil;
    if (Shiboken::Errors::occurred() != nullptr)
        return;
    static PyObject *nameCache[2] = {};
    static const char *funcName = "timerEvent";
    Shiboken::AutoDecRef pyOverride(Shiboken::BindingManager::instance().getOverride(this, nameCache, funcName));
    if (pyOverride.isNull()) {
        m_PyMethodCache[7] = true;
        gil.release();
        return this->::QObject::timerEvent(event);
    }

#if !defined(PYPY_VERSION) && !defined(Py_LIMITED_API) && PY_VERSION_HEX >= 0x03090000
    PyObject *pyArgArray[1] = {
        Shiboken::Conversions::pointerToPython(SbkPySide6_QtCoreTypes[SBK_QTIMEREVENT_IDX], event)
    };

    const bool invalidateArg1 = Py_REFCNT(pyArgArray[0]) == 1;
#else
    Shiboken::AutoDecRef pyArgs(Py_BuildValue("(N)",
        Shiboken::Conversions::pointerToPython(SbkPySide6_QtCoreTypes[SBK_QTIMEREVENT_IDX], event)
    ));
    bool invalidateArg1 = Py_REFCNT(PyTuple_GET_ITEM(pyArgs, 0)) == 1;
#endif

#if !defined(PYPY_VERSION) && !defined(Py_LIMITED_API) && PY_VERSION_HEX >= 0x03090000
    Shiboken::AutoDecRef pyResult(PyObject_Vectorcall(pyOverride, pyArgArray, 1, nullptr));
    if (invalidateArg1)
        Shiboken::Object::invalidate(pyArgArray[0]);
    Py_DECREF(pyArgArray[0]);
#else
    Shiboken::AutoDecRef pyResult(PyObject_Call(pyOverride, pyArgs, nullptr));
    if (invalidateArg1)
        Shiboken::Object::invalidate(PyTuple_GET_ITEM(pyArgs, 0));
#endif
    if (pyResult.isNull()) {
        // An error happened in python code!
        Shiboken::Errors::storeErrorOrPrint();
        return;
    }
}

const QMetaObject *MainApplicationWrapper::metaObject() const
{
    if (QObject::d_ptr->metaObject != nullptr)
        return QObject::d_ptr->dynamicMetaObject();
    SbkObject *pySelf = Shiboken::BindingManager::instance().retrieveWrapper(this);
    if (pySelf == nullptr)
        return MainApplication::metaObject();
    return PySide::SignalManager::retrieveMetaObject(reinterpret_cast<PyObject *>(pySelf));
}

int MainApplicationWrapper::qt_metacall(QMetaObject::Call call, int id, void **args)
{
    int result = MainApplication::qt_metacall(call, id, args);
    return result < 0 ? result : PySide::SignalManager::qt_metacall(this, call, id, args);
}

void *MainApplicationWrapper::qt_metacast(const char *_clname)
{
    if (_clname == nullptr)
        return {};
    SbkObject *pySelf = Shiboken::BindingManager::instance().retrieveWrapper(this);
    if (pySelf != nullptr && PySide::inherits(Py_TYPE(pySelf), _clname))
        return static_cast<void *>(const_cast< MainApplicationWrapper *>(this));
    return MainApplication::qt_metacast(_clname);
}

MainApplicationWrapper::~MainApplicationWrapper()
{
    SbkObject *wrapper = Shiboken::BindingManager::instance().retrieveWrapper(this);
    Shiboken::Object::destroy(wrapper, this);
}

// Target ---------------------------------------------------------

extern "C" {
static PyObject *Sbk_MainApplicationFunc_addNewTab(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = static_cast<MainApplicationWrapper *>(reinterpret_cast< ::MainApplication *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_MAINAPPLICATION_IDX], reinterpret_cast<SbkObject *>(self))));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PyFalkon.MainApplication.addNewTab";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths
    errInfo.reset(Shiboken::checkInvalidArgumentCount(numArgs, 0, 1));
    if (!errInfo.isNull())
        return Shiboken::returnWrongArguments(args, fullName, errInfo);

    if (PyArg_ParseTuple(args, "|O:addNewTab", &(pyArgs[0])) == 0)
        return {};


    // Overloaded function decisor
    // 0: MainApplication::addNewTab(QUrl)
    if (numArgs == 0) {
        overloadId = 0; // addNewTab(QUrl)
    } else if (numArgs >= 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(SbkPySide6_QtCoreTypes[SBK_QURL_IDX], (pyArgs[0])))) {
        overloadId = 0; // addNewTab(QUrl)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(args, fullName, errInfo);

    // Call function/method
    {
        if (kwds && PyDict_Size(kwds) > 0) {
            PyObject *value{};
            Shiboken::AutoDecRef kwds_dup(PyDict_Copy(kwds));
            static PyObject *const key_url = Shiboken::String::createStaticString("url");
            if (PyDict_Contains(kwds, key_url) != 0) {
                value = PyDict_GetItem(kwds, key_url);
                if (value != nullptr && pyArgs[0] != nullptr ) {
                    errInfo.reset(key_url);
                    Py_INCREF(errInfo.object());
                    return Shiboken::returnWrongArguments(args, fullName, errInfo);
                }
                if (value != nullptr) {
                    pyArgs[0] = value;
                    if (!(pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(SbkPySide6_QtCoreTypes[SBK_QURL_IDX], (pyArgs[0]))))
                        return Shiboken::returnWrongArguments(args, fullName, errInfo);
                }
                PyDict_DelItem(kwds_dup, key_url);
            }
            if (PyDict_Size(kwds_dup) > 0) {
                errInfo.reset(kwds_dup.release());
                return Shiboken::returnWrongArguments(args, fullName, errInfo);
            }
        }
        if (!Shiboken::Object::isValid(pyArgs[0]))
            return {};
        ::QUrl cppArg0_local = QUrl();
        ::QUrl *cppArg0 = &cppArg0_local;
        if (pythonToCpp[0]) {
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);
            }

        if (Shiboken::Errors::occurred() == nullptr) {
            // addNewTab(QUrl)
            cppSelf->addNewTab(*cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_MainApplicationFunc_afterLaunch(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = static_cast<MainApplicationWrapper *>(reinterpret_cast< ::MainApplication *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_MAINAPPLICATION_IDX], reinterpret_cast<SbkObject *>(self))));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PyFalkon.MainApplication.afterLaunch";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // afterLaunch()const
            MainApplication::AfterLaunch cppResult = MainApplication::AfterLaunch(const_cast<const ::MainApplicationWrapper *>(cppSelf)->afterLaunch());
            pyResult = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(SbkPyFalkonTypes[SBK_MAINAPPLICATION_AFTERLAUNCH_IDX]))->converter, &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_MainApplicationFunc_autoFill(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = static_cast<MainApplicationWrapper *>(reinterpret_cast< ::MainApplication *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_MAINAPPLICATION_IDX], reinterpret_cast<SbkObject *>(self))));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PyFalkon.MainApplication.autoFill";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // autoFill()
            AutoFill * cppResult = cppSelf->autoFill();
            pyResult = Shiboken::Conversions::pointerToPython(SbkPyFalkonTypes[SBK_AUTOFILL_IDX], cppResult);
            // Ownership transferences (return value heuristics).
            Shiboken::Object::setParent(self, pyResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_MainApplicationFunc_bookmarks(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = static_cast<MainApplicationWrapper *>(reinterpret_cast< ::MainApplication *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_MAINAPPLICATION_IDX], reinterpret_cast<SbkObject *>(self))));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PyFalkon.MainApplication.bookmarks";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // bookmarks()
            Bookmarks * cppResult = cppSelf->bookmarks();
            pyResult = Shiboken::Conversions::pointerToPython(SbkPyFalkonTypes[SBK_BOOKMARKS_IDX], cppResult);
            // Ownership transferences (return value heuristics).
            Shiboken::Object::setParent(self, pyResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_MainApplicationFunc_changeOccurred(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = static_cast<MainApplicationWrapper *>(reinterpret_cast< ::MainApplication *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_MAINAPPLICATION_IDX], reinterpret_cast<SbkObject *>(self))));
    SBK_UNUSED(cppSelf)
    static const char fullName[] = "PyFalkon.MainApplication.changeOccurred";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // changeOccurred()
            cppSelf->changeOccurred();
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_MainApplicationFunc_cookieJar(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = static_cast<MainApplicationWrapper *>(reinterpret_cast< ::MainApplication *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_MAINAPPLICATION_IDX], reinterpret_cast<SbkObject *>(self))));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PyFalkon.MainApplication.cookieJar";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // cookieJar()
            CookieJar * cppResult = cppSelf->cookieJar();
            pyResult = Shiboken::Conversions::pointerToPython(SbkPyFalkonTypes[SBK_COOKIEJAR_IDX], cppResult);
            // Ownership transferences (return value heuristics).
            Shiboken::Object::setParent(self, pyResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_MainApplicationFunc_createWindow(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = static_cast<MainApplicationWrapper *>(reinterpret_cast< ::MainApplication *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_MAINAPPLICATION_IDX], reinterpret_cast<SbkObject *>(self))));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PyFalkon.MainApplication.createWindow";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[2];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr, nullptr};

    // invalid argument lengths
    errInfo.reset(Shiboken::checkInvalidArgumentCount(numArgs, 1, 2));
    if (!errInfo.isNull())
        return Shiboken::returnWrongArguments(args, fullName, errInfo);

    if (PyArg_ParseTuple(args, "|OO:createWindow", &(pyArgs[0]), &(pyArgs[1])) == 0)
        return {};


    // Overloaded function decisor
    // 0: MainApplication::createWindow(Qz::BrowserWindowType,QUrl)->BrowserWindow*
    if (numArgs >= 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(SbkPyFalkonTypes[SBK_QZ_BROWSERWINDOWTYPE_IDX]))->converter, (pyArgs[0])))) {
        if (numArgs == 1) {
            overloadId = 0; // createWindow(Qz::BrowserWindowType,QUrl)
        } else if (numArgs >= 2
            && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppReferenceConversion(SbkPySide6_QtCoreTypes[SBK_QURL_IDX], (pyArgs[1])))) {
            overloadId = 0; // createWindow(Qz::BrowserWindowType,QUrl)
        }
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(args, fullName, errInfo);

    // Call function/method
    {
        if (kwds && PyDict_Size(kwds) > 0) {
            PyObject *value{};
            Shiboken::AutoDecRef kwds_dup(PyDict_Copy(kwds));
            static PyObject *const key_startUrl = Shiboken::String::createStaticString("startUrl");
            if (PyDict_Contains(kwds, key_startUrl) != 0) {
                value = PyDict_GetItem(kwds, key_startUrl);
                if (value != nullptr && pyArgs[1] != nullptr ) {
                    errInfo.reset(key_startUrl);
                    Py_INCREF(errInfo.object());
                    return Shiboken::returnWrongArguments(args, fullName, errInfo);
                }
                if (value != nullptr) {
                    pyArgs[1] = value;
                    if (!(pythonToCpp[1] = Shiboken::Conversions::pythonToCppReferenceConversion(SbkPySide6_QtCoreTypes[SBK_QURL_IDX], (pyArgs[1]))))
                        return Shiboken::returnWrongArguments(args, fullName, errInfo);
                }
                PyDict_DelItem(kwds_dup, key_startUrl);
            }
            if (PyDict_Size(kwds_dup) > 0) {
                errInfo.reset(kwds_dup.release());
                return Shiboken::returnWrongArguments(args, fullName, errInfo);
            }
        }
        ::Qz::BrowserWindowType cppArg0{Qz::BW_FirstAppWindow};
        pythonToCpp[0](pyArgs[0], &cppArg0);
        if (!Shiboken::Object::isValid(pyArgs[1]))
            return {};
        ::QUrl cppArg1_local = QUrl();
        ::QUrl *cppArg1 = &cppArg1_local;
        if (pythonToCpp[1]) {
            if (pythonToCpp[1].isValue())
                pythonToCpp[1](pyArgs[1], &cppArg1_local);
            else
                pythonToCpp[1](pyArgs[1], &cppArg1);
            }

        if (Shiboken::Errors::occurred() == nullptr) {
            // createWindow(Qz::BrowserWindowType,QUrl)
            BrowserWindow * cppResult = cppSelf->createWindow(cppArg0, *cppArg1);
            pyResult = Shiboken::Conversions::pointerToPython(SbkPyFalkonTypes[SBK_BROWSERWINDOW_IDX], cppResult);
            // Ownership transferences (return value heuristics).
            Shiboken::Object::setParent(self, pyResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_MainApplicationFunc_desktopNotifications(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = static_cast<MainApplicationWrapper *>(reinterpret_cast< ::MainApplication *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_MAINAPPLICATION_IDX], reinterpret_cast<SbkObject *>(self))));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PyFalkon.MainApplication.desktopNotifications";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // desktopNotifications()
            DesktopNotificationsFactory * cppResult = cppSelf->desktopNotifications();
            pyResult = Shiboken::Conversions::pointerToPython(SbkPyFalkonTypes[SBK_DESKTOPNOTIFICATIONSFACTORY_IDX], cppResult);
            // Ownership transferences (return value heuristics).
            Shiboken::Object::setParent(self, pyResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_MainApplicationFunc_destroyRestoreManager(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = static_cast<MainApplicationWrapper *>(reinterpret_cast< ::MainApplication *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_MAINAPPLICATION_IDX], reinterpret_cast<SbkObject *>(self))));
    SBK_UNUSED(cppSelf)
    static const char fullName[] = "PyFalkon.MainApplication.destroyRestoreManager";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // destroyRestoreManager()
            cppSelf->destroyRestoreManager();
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_MainApplicationFunc_downloadManager(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = static_cast<MainApplicationWrapper *>(reinterpret_cast< ::MainApplication *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_MAINAPPLICATION_IDX], reinterpret_cast<SbkObject *>(self))));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PyFalkon.MainApplication.downloadManager";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // downloadManager()
            DownloadManager * cppResult = cppSelf->downloadManager();
            pyResult = Shiboken::Conversions::pointerToPython(SbkPyFalkonTypes[SBK_DOWNLOADMANAGER_IDX], cppResult);
            // Ownership transferences (return value heuristics).
            Shiboken::Object::setParent(self, pyResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_MainApplicationFunc_getWindow(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = static_cast<MainApplicationWrapper *>(reinterpret_cast< ::MainApplication *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_MAINAPPLICATION_IDX], reinterpret_cast<SbkObject *>(self))));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PyFalkon.MainApplication.getWindow";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // getWindow()const
            BrowserWindow * cppResult = const_cast<const ::MainApplicationWrapper *>(cppSelf)->getWindow();
            pyResult = Shiboken::Conversions::pointerToPython(SbkPyFalkonTypes[SBK_BROWSERWINDOW_IDX], cppResult);
            // Ownership transferences (return value heuristics).
            Shiboken::Object::setParent(self, pyResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_MainApplicationFunc_history(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = static_cast<MainApplicationWrapper *>(reinterpret_cast< ::MainApplication *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_MAINAPPLICATION_IDX], reinterpret_cast<SbkObject *>(self))));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PyFalkon.MainApplication.history";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // history()
            History * cppResult = cppSelf->history();
            pyResult = Shiboken::Conversions::pointerToPython(SbkPyFalkonTypes[SBK_HISTORY_IDX], cppResult);
            // Ownership transferences (return value heuristics).
            Shiboken::Object::setParent(self, pyResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_MainApplicationFunc_instance(PyObject *self)
{
    SBK_UNUSED(self)
    PyObject *pyResult{};
    static const char fullName[] = "PyFalkon.MainApplication.instance";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // instance()
            // Begin code injection
            // ========================================================================
            // START of custom code block [file: ../glue/qtcore.cpp (qcoreapplication-instance)]
            PyObject *pyApp = Py_None;
            if (qApp) {
                pyApp = reinterpret_cast<PyObject *>(
                    Shiboken::BindingManager::instance().retrieveWrapper(qApp));
                if (!pyApp)
                    pyApp = Shiboken::Conversions::pointerToPython(SbkPySide6_QtCoreTypes[SBK_QCOREAPPLICATION_IDX], qApp);
                    // this will keep app live after python exit (extra ref)
            }
            // PYSIDE-571: make sure that we return the singleton "None"
            if (Py_TYPE(pyApp) == Py_TYPE(Py_None))
                Py_DECREF(MakeQAppWrapper(nullptr));
            pyResult = pyApp;
            Py_XINCREF(pyResult);
            // END of custom code block [file: ../glue/qtcore.cpp (qcoreapplication-instance)]
            // ========================================================================
            // End of code injection

        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_MainApplicationFunc_isClosing(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = static_cast<MainApplicationWrapper *>(reinterpret_cast< ::MainApplication *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_MAINAPPLICATION_IDX], reinterpret_cast<SbkObject *>(self))));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PyFalkon.MainApplication.isClosing";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // isClosing()const
            bool cppResult = const_cast<const ::MainApplicationWrapper *>(cppSelf)->isClosing();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_MainApplicationFunc_isPortable(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = static_cast<MainApplicationWrapper *>(reinterpret_cast< ::MainApplication *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_MAINAPPLICATION_IDX], reinterpret_cast<SbkObject *>(self))));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PyFalkon.MainApplication.isPortable";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // isPortable()const
            bool cppResult = const_cast<const ::MainApplicationWrapper *>(cppSelf)->isPortable();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_MainApplicationFunc_isPrivate(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = static_cast<MainApplicationWrapper *>(reinterpret_cast< ::MainApplication *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_MAINAPPLICATION_IDX], reinterpret_cast<SbkObject *>(self))));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PyFalkon.MainApplication.isPrivate";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // isPrivate()const
            bool cppResult = const_cast<const ::MainApplicationWrapper *>(cppSelf)->isPrivate();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_MainApplicationFunc_isStartingAfterCrash(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = static_cast<MainApplicationWrapper *>(reinterpret_cast< ::MainApplication *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_MAINAPPLICATION_IDX], reinterpret_cast<SbkObject *>(self))));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PyFalkon.MainApplication.isStartingAfterCrash";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // isStartingAfterCrash()const
            bool cppResult = const_cast<const ::MainApplicationWrapper *>(cppSelf)->isStartingAfterCrash();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_MainApplicationFunc_isTestModeEnabled(PyObject *self)
{
    SBK_UNUSED(self)
    PyObject *pyResult{};
    static const char fullName[] = "PyFalkon.MainApplication.isTestModeEnabled";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // isTestModeEnabled()
            bool cppResult = ::MainApplication::isTestModeEnabled();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_MainApplicationFunc_messageReceived(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = static_cast<MainApplicationWrapper *>(reinterpret_cast< ::MainApplication *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_MAINAPPLICATION_IDX], reinterpret_cast<SbkObject *>(self))));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PyFalkon.MainApplication.messageReceived";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QtSingleApplication::messageReceived(QString)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QSTRING_IDX], (pyArg)))) {
        overloadId = 0; // messageReceived(QString)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        Shiboken::Errors::setPrivateMethod("messageReceived(const QString & message)");
        return {};
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_MainApplicationFunc_networkManager(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = static_cast<MainApplicationWrapper *>(reinterpret_cast< ::MainApplication *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_MAINAPPLICATION_IDX], reinterpret_cast<SbkObject *>(self))));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PyFalkon.MainApplication.networkManager";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // networkManager()
            NetworkManager * cppResult = cppSelf->networkManager();
            pyResult = Shiboken::Conversions::pointerToPython(SbkPyFalkonTypes[SBK_NETWORKMANAGER_IDX], cppResult);
            // Ownership transferences (return value heuristics).
            Shiboken::Object::setParent(self, pyResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_MainApplicationFunc_plugins(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = static_cast<MainApplicationWrapper *>(reinterpret_cast< ::MainApplication *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_MAINAPPLICATION_IDX], reinterpret_cast<SbkObject *>(self))));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PyFalkon.MainApplication.plugins";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // plugins()
            PluginProxy * cppResult = cppSelf->plugins();
            pyResult = Shiboken::Conversions::pointerToPython(SbkPyFalkonTypes[SBK_PLUGINPROXY_IDX], cppResult);
            // Ownership transferences (return value heuristics).
            Shiboken::Object::setParent(self, pyResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_MainApplicationFunc_quitApplication(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = static_cast<MainApplicationWrapper *>(reinterpret_cast< ::MainApplication *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_MAINAPPLICATION_IDX], reinterpret_cast<SbkObject *>(self))));
    SBK_UNUSED(cppSelf)
    static const char fullName[] = "PyFalkon.MainApplication.quitApplication";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // quitApplication()
            cppSelf->quitApplication();
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_MainApplicationFunc_reloadSettings(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = static_cast<MainApplicationWrapper *>(reinterpret_cast< ::MainApplication *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_MAINAPPLICATION_IDX], reinterpret_cast<SbkObject *>(self))));
    SBK_UNUSED(cppSelf)
    static const char fullName[] = "PyFalkon.MainApplication.reloadSettings";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // reloadSettings()
            cppSelf->reloadSettings();
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_MainApplicationFunc_reloadUserStyleSheet(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = static_cast<MainApplicationWrapper *>(reinterpret_cast< ::MainApplication *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_MAINAPPLICATION_IDX], reinterpret_cast<SbkObject *>(self))));
    SBK_UNUSED(cppSelf)
    static const char fullName[] = "PyFalkon.MainApplication.reloadUserStyleSheet";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // reloadUserStyleSheet()
            cppSelf->reloadUserStyleSheet();
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_MainApplicationFunc_restoreOverrideCursor(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = static_cast<MainApplicationWrapper *>(reinterpret_cast< ::MainApplication *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_MAINAPPLICATION_IDX], reinterpret_cast<SbkObject *>(self))));
    SBK_UNUSED(cppSelf)
    static const char fullName[] = "PyFalkon.MainApplication.restoreOverrideCursor";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // restoreOverrideCursor()
            cppSelf->restoreOverrideCursor();
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_MainApplicationFunc_saveState(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = static_cast<MainApplicationWrapper *>(reinterpret_cast< ::MainApplication *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_MAINAPPLICATION_IDX], reinterpret_cast<SbkObject *>(self))));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PyFalkon.MainApplication.saveState";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // saveState()const
            QByteArray cppResult = const_cast<const ::MainApplicationWrapper *>(cppSelf)->saveState();
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypes[SBK_QBYTEARRAY_IDX], &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_MainApplicationFunc_searchEnginesManager(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = static_cast<MainApplicationWrapper *>(reinterpret_cast< ::MainApplication *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_MAINAPPLICATION_IDX], reinterpret_cast<SbkObject *>(self))));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PyFalkon.MainApplication.searchEnginesManager";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // searchEnginesManager()
            SearchEnginesManager * cppResult = cppSelf->searchEnginesManager();
            pyResult = Shiboken::Conversions::pointerToPython(SbkPyFalkonTypes[SBK_SEARCHENGINESMANAGER_IDX], cppResult);
            // Ownership transferences (return value heuristics).
            Shiboken::Object::setParent(self, pyResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_MainApplicationFunc_setTestModeEnabled(PyObject *self, PyObject *pyArg)
{
    SBK_UNUSED(self)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PyFalkon.MainApplication.setTestModeEnabled";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: static MainApplication::setTestModeEnabled(bool)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), (pyArg)))) {
        overloadId = 0; // setTestModeEnabled(bool)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        bool cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // setTestModeEnabled(bool)
            ::MainApplication::setTestModeEnabled(cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_MainApplicationFunc_startPrivateBrowsing(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = static_cast<MainApplicationWrapper *>(reinterpret_cast< ::MainApplication *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_MAINAPPLICATION_IDX], reinterpret_cast<SbkObject *>(self))));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PyFalkon.MainApplication.startPrivateBrowsing";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths
    errInfo.reset(Shiboken::checkInvalidArgumentCount(numArgs, 0, 1));
    if (!errInfo.isNull())
        return Shiboken::returnWrongArguments(args, fullName, errInfo);

    if (PyArg_ParseTuple(args, "|O:startPrivateBrowsing", &(pyArgs[0])) == 0)
        return {};


    // Overloaded function decisor
    // 0: MainApplication::startPrivateBrowsing(QUrl)
    if (numArgs == 0) {
        overloadId = 0; // startPrivateBrowsing(QUrl)
    } else if (numArgs >= 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(SbkPySide6_QtCoreTypes[SBK_QURL_IDX], (pyArgs[0])))) {
        overloadId = 0; // startPrivateBrowsing(QUrl)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(args, fullName, errInfo);

    // Call function/method
    {
        if (kwds && PyDict_Size(kwds) > 0) {
            PyObject *value{};
            Shiboken::AutoDecRef kwds_dup(PyDict_Copy(kwds));
            static PyObject *const key_startUrl = Shiboken::String::createStaticString("startUrl");
            if (PyDict_Contains(kwds, key_startUrl) != 0) {
                value = PyDict_GetItem(kwds, key_startUrl);
                if (value != nullptr && pyArgs[0] != nullptr ) {
                    errInfo.reset(key_startUrl);
                    Py_INCREF(errInfo.object());
                    return Shiboken::returnWrongArguments(args, fullName, errInfo);
                }
                if (value != nullptr) {
                    pyArgs[0] = value;
                    if (!(pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(SbkPySide6_QtCoreTypes[SBK_QURL_IDX], (pyArgs[0]))))
                        return Shiboken::returnWrongArguments(args, fullName, errInfo);
                }
                PyDict_DelItem(kwds_dup, key_startUrl);
            }
            if (PyDict_Size(kwds_dup) > 0) {
                errInfo.reset(kwds_dup.release());
                return Shiboken::returnWrongArguments(args, fullName, errInfo);
            }
        }
        if (!Shiboken::Object::isValid(pyArgs[0]))
            return {};
        ::QUrl cppArg0_local = QUrl();
        ::QUrl *cppArg0 = &cppArg0_local;
        if (pythonToCpp[0]) {
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);
            }

        if (Shiboken::Errors::occurred() == nullptr) {
            // startPrivateBrowsing(QUrl)
            cppSelf->startPrivateBrowsing(*cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_MainApplicationFunc_styleName(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = static_cast<MainApplicationWrapper *>(reinterpret_cast< ::MainApplication *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_MAINAPPLICATION_IDX], reinterpret_cast<SbkObject *>(self))));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PyFalkon.MainApplication.styleName";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // styleName()const
            QString cppResult = const_cast<const ::MainApplicationWrapper *>(cppSelf)->styleName();
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QSTRING_IDX], &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_MainApplicationFunc_webProfile(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = static_cast<MainApplicationWrapper *>(reinterpret_cast< ::MainApplication *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_MAINAPPLICATION_IDX], reinterpret_cast<SbkObject *>(self))));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PyFalkon.MainApplication.webProfile";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // webProfile()const
            QWebEngineProfile * cppResult = const_cast<const ::MainApplicationWrapper *>(cppSelf)->webProfile();
            pyResult = Shiboken::Conversions::pointerToPython(SbkPySide6_QtWebEngineCoreTypes[SBK_QWEBENGINEPROFILE_IDX], cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_MainApplicationFunc_webSettings(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = static_cast<MainApplicationWrapper *>(reinterpret_cast< ::MainApplication *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_MAINAPPLICATION_IDX], reinterpret_cast<SbkObject *>(self))));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PyFalkon.MainApplication.webSettings";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // webSettings()const
            QWebEngineSettings * cppResult = const_cast<const ::MainApplicationWrapper *>(cppSelf)->webSettings();
            pyResult = Shiboken::Conversions::pointerToPython(SbkPySide6_QtWebEngineCoreTypes[SBK_QWEBENGINESETTINGS_IDX], cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_MainApplicationFunc_windowCount(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = static_cast<MainApplicationWrapper *>(reinterpret_cast< ::MainApplication *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_MAINAPPLICATION_IDX], reinterpret_cast<SbkObject *>(self))));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PyFalkon.MainApplication.windowCount";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // windowCount()const
            int cppResult = const_cast<const ::MainApplicationWrapper *>(cppSelf)->windowCount();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<int>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_MainApplicationFunc_windows(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = static_cast<MainApplicationWrapper *>(reinterpret_cast< ::MainApplication *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_MAINAPPLICATION_IDX], reinterpret_cast<SbkObject *>(self))));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PyFalkon.MainApplication.windows";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // windows()const
            QList<BrowserWindow*> cppResult = const_cast<const ::MainApplicationWrapper *>(cppSelf)->windows();
            pyResult = Shiboken::Conversions::copyToPython(SbkPyFalkonTypeConverters[SBK_PYFALKON_QLIST_BROWSERWINDOWPTR_IDX], &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_MainApplicationFunc_wmClass(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = static_cast<MainApplicationWrapper *>(reinterpret_cast< ::MainApplication *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_MAINAPPLICATION_IDX], reinterpret_cast<SbkObject *>(self))));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PyFalkon.MainApplication.wmClass";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // wmClass()const
            QByteArray cppResult = const_cast<const ::MainApplicationWrapper *>(cppSelf)->wmClass();
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypes[SBK_QBYTEARRAY_IDX], &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_MainApplication_PropertyStrings[] = {
    nullptr // Sentinel
};

static const char *Sbk_MainApplication_EnumFlagInfo[] = {
    "AfterLaunch:IntEnum",
    "PostLaunchAction:IntEnum",
    nullptr // Sentinel
};

static PyMethodDef Sbk_MainApplication_methods[] = {
    {"addNewTab", reinterpret_cast<PyCFunction>(Sbk_MainApplicationFunc_addNewTab), METH_VARARGS|METH_KEYWORDS, nullptr},
    {"afterLaunch", reinterpret_cast<PyCFunction>(Sbk_MainApplicationFunc_afterLaunch), METH_NOARGS, nullptr},
    {"autoFill", reinterpret_cast<PyCFunction>(Sbk_MainApplicationFunc_autoFill), METH_NOARGS, nullptr},
    {"bookmarks", reinterpret_cast<PyCFunction>(Sbk_MainApplicationFunc_bookmarks), METH_NOARGS, nullptr},
    {"changeOccurred", reinterpret_cast<PyCFunction>(Sbk_MainApplicationFunc_changeOccurred), METH_NOARGS, nullptr},
    {"cookieJar", reinterpret_cast<PyCFunction>(Sbk_MainApplicationFunc_cookieJar), METH_NOARGS, nullptr},
    {"createWindow", reinterpret_cast<PyCFunction>(Sbk_MainApplicationFunc_createWindow), METH_VARARGS|METH_KEYWORDS, nullptr},
    {"desktopNotifications", reinterpret_cast<PyCFunction>(Sbk_MainApplicationFunc_desktopNotifications), METH_NOARGS, nullptr},
    {"destroyRestoreManager", reinterpret_cast<PyCFunction>(Sbk_MainApplicationFunc_destroyRestoreManager), METH_NOARGS, nullptr},
    {"downloadManager", reinterpret_cast<PyCFunction>(Sbk_MainApplicationFunc_downloadManager), METH_NOARGS, nullptr},
    {"getWindow", reinterpret_cast<PyCFunction>(Sbk_MainApplicationFunc_getWindow), METH_NOARGS, nullptr},
    {"history", reinterpret_cast<PyCFunction>(Sbk_MainApplicationFunc_history), METH_NOARGS, nullptr},
    {"instance", reinterpret_cast<PyCFunction>(Sbk_MainApplicationFunc_instance), METH_NOARGS|METH_STATIC, nullptr},
    {"isClosing", reinterpret_cast<PyCFunction>(Sbk_MainApplicationFunc_isClosing), METH_NOARGS, nullptr},
    {"isPortable", reinterpret_cast<PyCFunction>(Sbk_MainApplicationFunc_isPortable), METH_NOARGS, nullptr},
    {"isPrivate", reinterpret_cast<PyCFunction>(Sbk_MainApplicationFunc_isPrivate), METH_NOARGS, nullptr},
    {"isStartingAfterCrash", reinterpret_cast<PyCFunction>(Sbk_MainApplicationFunc_isStartingAfterCrash), METH_NOARGS, nullptr},
    {"isTestModeEnabled", reinterpret_cast<PyCFunction>(Sbk_MainApplicationFunc_isTestModeEnabled), METH_NOARGS|METH_STATIC, nullptr},
    {"messageReceived", reinterpret_cast<PyCFunction>(Sbk_MainApplicationFunc_messageReceived), METH_O, nullptr},
    {"networkManager", reinterpret_cast<PyCFunction>(Sbk_MainApplicationFunc_networkManager), METH_NOARGS, nullptr},
    {"plugins", reinterpret_cast<PyCFunction>(Sbk_MainApplicationFunc_plugins), METH_NOARGS, nullptr},
    {"quitApplication", reinterpret_cast<PyCFunction>(Sbk_MainApplicationFunc_quitApplication), METH_NOARGS, nullptr},
    {"reloadSettings", reinterpret_cast<PyCFunction>(Sbk_MainApplicationFunc_reloadSettings), METH_NOARGS, nullptr},
    {"reloadUserStyleSheet", reinterpret_cast<PyCFunction>(Sbk_MainApplicationFunc_reloadUserStyleSheet), METH_NOARGS, nullptr},
    {"restoreOverrideCursor", reinterpret_cast<PyCFunction>(Sbk_MainApplicationFunc_restoreOverrideCursor), METH_NOARGS, nullptr},
    {"saveState", reinterpret_cast<PyCFunction>(Sbk_MainApplicationFunc_saveState), METH_NOARGS, nullptr},
    {"searchEnginesManager", reinterpret_cast<PyCFunction>(Sbk_MainApplicationFunc_searchEnginesManager), METH_NOARGS, nullptr},
    {"setTestModeEnabled", reinterpret_cast<PyCFunction>(Sbk_MainApplicationFunc_setTestModeEnabled), METH_O|METH_STATIC, nullptr},
    {"startPrivateBrowsing", reinterpret_cast<PyCFunction>(Sbk_MainApplicationFunc_startPrivateBrowsing), METH_VARARGS|METH_KEYWORDS, nullptr},
    {"styleName", reinterpret_cast<PyCFunction>(Sbk_MainApplicationFunc_styleName), METH_NOARGS, nullptr},
    {"webProfile", reinterpret_cast<PyCFunction>(Sbk_MainApplicationFunc_webProfile), METH_NOARGS, nullptr},
    {"webSettings", reinterpret_cast<PyCFunction>(Sbk_MainApplicationFunc_webSettings), METH_NOARGS, nullptr},
    {"windowCount", reinterpret_cast<PyCFunction>(Sbk_MainApplicationFunc_windowCount), METH_NOARGS, nullptr},
    {"windows", reinterpret_cast<PyCFunction>(Sbk_MainApplicationFunc_windows), METH_NOARGS, nullptr},
    {"wmClass", reinterpret_cast<PyCFunction>(Sbk_MainApplicationFunc_wmClass), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

static int Sbk_MainApplication_setattro(PyObject *self, PyObject *name, PyObject *value)
{
    PySide::Feature::Select(self);
    if (value != nullptr && PyCallable_Check(value) != 0) {
        auto plain_inst = reinterpret_cast< ::MainApplication *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_MAINAPPLICATION_IDX], reinterpret_cast<SbkObject *>(self)));
        auto *inst = dynamic_cast<MainApplicationWrapper *>(plain_inst);
        if (inst != nullptr)
            inst->resetPyMethodCache();
    }
    Shiboken::AutoDecRef pp(reinterpret_cast<PyObject *>(PySide::Property::getObject(self, name)));
    if (!pp.isNull())
        return PySide::Property::setValue(reinterpret_cast<PySideProperty *>(pp.object()), self, value);
    return PyObject_GenericSetAttr(self, name, value);
}

} // extern "C"

static int Sbk_MainApplication_traverse(PyObject *self, visitproc visit, void *arg)
{
    return SbkObject_TypeF()->tp_traverse(self, visit, arg);
}
static int Sbk_MainApplication_clear(PyObject *self)
{
    return reinterpret_cast<PyTypeObject *>(SbkObject_TypeF())->tp_clear(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_MainApplication_Type = nullptr;
static PyTypeObject *Sbk_MainApplication_TypeF(void)
{
    return _Sbk_MainApplication_Type;
}

static PyType_Slot Sbk_MainApplication_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocQAppWrapper)},
    {Py_tp_setattro,    reinterpret_cast<void *>(Sbk_MainApplication_setattro)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_MainApplication_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_MainApplication_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_MainApplication_methods)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkQApp_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_MainApplication_spec = {
    "1:PyFalkon.MainApplication",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_MainApplication_slots
};

} //extern "C"

static void *Sbk_MainApplication_typeDiscovery(void *cptr, PyTypeObject *instanceType)
{
    SBK_UNUSED(cptr)
    SBK_UNUSED(instanceType)
    if (instanceType == Shiboken::SbkType< ::QObject >())
        return dynamic_cast< ::MainApplication *>(reinterpret_cast< ::QObject *>(cptr));
    return {};
}


// Type conversion functions.

// Python to C++ enum conversion.
static void MainApplication_AfterLaunch_PythonToCpp_MainApplication_AfterLaunch(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::MainApplication::AfterLaunch>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::MainApplication::AfterLaunch *>(cppOut) = value;

}
static PythonToCppFunc is_MainApplication_AfterLaunch_PythonToCpp_MainApplication_AfterLaunch_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, SbkPyFalkonTypes[SBK_MAINAPPLICATION_AFTERLAUNCH_IDX]))
        return MainApplication_AfterLaunch_PythonToCpp_MainApplication_AfterLaunch;
    return {};
}
static PyObject *MainApplication_AfterLaunch_CppToPython_MainApplication_AfterLaunch(const void *cppIn)
{
    const int castCppIn = int(*reinterpret_cast<const ::MainApplication::AfterLaunch *>(cppIn));
    return Shiboken::Enum::newItem(SbkPyFalkonTypes[SBK_MAINAPPLICATION_AFTERLAUNCH_IDX], castCppIn);

}

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void MainApplication_PythonToCpp_MainApplication_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_MainApplication_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_MainApplication_PythonToCpp_MainApplication_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_MainApplication_TypeF()))
        return MainApplication_PythonToCpp_MainApplication_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *MainApplication_PTR_CppToPython_MainApplication(const void *cppIn)
{
    return PySide::getWrapperForQObject(reinterpret_cast<::MainApplication *>(const_cast<void *>(cppIn)), Sbk_MainApplication_TypeF());

}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *MainApplication_SignatureStrings[] = {
    "PyFalkon.MainApplication.addNewTab(self,url:typing.Union[PySide6.QtCore.QUrl, QString]=QUrl())",
    "PyFalkon.MainApplication.afterLaunch(self)->PyFalkon.MainApplication.AfterLaunch",
    "PyFalkon.MainApplication.autoFill(self)->PyFalkon.AutoFill",
    "PyFalkon.MainApplication.bookmarks(self)->PyFalkon.Bookmarks",
    "PyFalkon.MainApplication.changeOccurred(self)",
    "PyFalkon.MainApplication.cookieJar(self)->PyFalkon.CookieJar",
    "PyFalkon.MainApplication.createWindow(self,type:PyFalkon.Qz.BrowserWindowType,startUrl:typing.Union[PySide6.QtCore.QUrl, QString]=QUrl())->PyFalkon.BrowserWindow",
    "PyFalkon.MainApplication.desktopNotifications(self)->PyFalkon.DesktopNotificationsFactory",
    "PyFalkon.MainApplication.destroyRestoreManager(self)",
    "PyFalkon.MainApplication.downloadManager(self)->PyFalkon.DownloadManager",
    "PyFalkon.MainApplication.getWindow(self)->PyFalkon.BrowserWindow",
    "PyFalkon.MainApplication.history(self)->PyFalkon.History",
    "PyFalkon.MainApplication.instance()->Optional[PySide6.QtCore.QCoreApplication]",
    "PyFalkon.MainApplication.isClosing(self)->bool",
    "PyFalkon.MainApplication.isPortable(self)->bool",
    "PyFalkon.MainApplication.isPrivate(self)->bool",
    "PyFalkon.MainApplication.isStartingAfterCrash(self)->bool",
    "PyFalkon.MainApplication.isTestModeEnabled()->bool",
    "PyFalkon.MainApplication.messageReceived(self,message:QString)",
    "PyFalkon.MainApplication.networkManager(self)->PyFalkon.NetworkManager",
    "PyFalkon.MainApplication.plugins(self)->PyFalkon.PluginProxy",
    "PyFalkon.MainApplication.quitApplication(self)",
    "PyFalkon.MainApplication.reloadSettings(self)",
    "PyFalkon.MainApplication.reloadUserStyleSheet(self)",
    "PyFalkon.MainApplication.restoreOverrideCursor(self)",
    "PyFalkon.MainApplication.saveState(self)->PySide6.QtCore.QByteArray",
    "PyFalkon.MainApplication.searchEnginesManager(self)->PyFalkon.SearchEnginesManager",
    "PyFalkon.MainApplication.setTestModeEnabled(enabled:bool)",
    "PyFalkon.MainApplication.startPrivateBrowsing(self,startUrl:typing.Union[PySide6.QtCore.QUrl, QString]=QUrl())",
    "PyFalkon.MainApplication.styleName(self)->QString",
    "PyFalkon.MainApplication.webProfile(self)->PySide6.QtWebEngineCore.QWebEngineProfile",
    "PyFalkon.MainApplication.webSettings(self)->PySide6.QtWebEngineCore.QWebEngineSettings",
    "PyFalkon.MainApplication.windowCount(self)->int",
    "PyFalkon.MainApplication.windows(self)->QList[PyFalkon.BrowserWindow]",
    "PyFalkon.MainApplication.wmClass(self)->PySide6.QtCore.QByteArray",
    nullptr}; // Sentinel

void init_MainApplication(PyObject *module)
{
    _Sbk_MainApplication_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "MainApplication",
        "MainApplication*",
        &Sbk_MainApplication_spec,
        &Shiboken::callCppDestructor< ::MainApplication >,
        SbkPyFalkonTypes[SBK_QTSINGLEAPPLICATION_IDX],
        0,
        0);
    auto *pyType = Sbk_MainApplication_TypeF(); // references _Sbk_MainApplication_Type
    InitSignatureStrings(pyType, MainApplication_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_MainApplication_PropertyStrings);
    SbkPyFalkonTypes[SBK_MAINAPPLICATION_IDX] = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        MainApplication_PythonToCpp_MainApplication_PTR,
        is_MainApplication_PythonToCpp_MainApplication_PTR_Convertible,
        MainApplication_PTR_CppToPython_MainApplication);

    Shiboken::Conversions::registerConverterName(converter, "MainApplication");
    Shiboken::Conversions::registerConverterName(converter, "MainApplication*");
    Shiboken::Conversions::registerConverterName(converter, "MainApplication&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::MainApplication).name());
    Shiboken::Conversions::registerConverterName(converter, typeid(::MainApplicationWrapper).name());

    Shiboken::ObjectType::setTypeDiscoveryFunctionV2(
        Sbk_MainApplication_TypeF(), &Sbk_MainApplication_typeDiscovery);

    // Pass the ..._EnumFlagInfo to the class.
    SbkObjectType_SetEnumFlagInfo(pyType, Sbk_MainApplication_EnumFlagInfo);

    // Initialization of enums.
    Shiboken::AutoDecRef tpDict{};
    PyTypeObject *EType{};

    // Initialization of enum 'AfterLaunch'.
    const char *AfterLaunch_Initializer[] = {
        "OpenBlankPage",
        "OpenHomePage",
        "OpenSpeedDial",
        "RestoreSession",
        "SelectSession",
        nullptr};
    // "uint8_t" used instead of "unsigned int"
    constexpr uint8_t AfterLaunch_InitializerValues[] = {
        uint8_t(MainApplication::AfterLaunch::OpenBlankPage),  //  0x00  0
        uint8_t(MainApplication::AfterLaunch::OpenHomePage),   //  0x01  1
        uint8_t(MainApplication::AfterLaunch::OpenSpeedDial),  //  0x02  2
        uint8_t(MainApplication::AfterLaunch::RestoreSession), //  0x03  3
        uint8_t(MainApplication::AfterLaunch::SelectSession)   //  0x04  4
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_MainApplication_TypeF(),
        "1:PyFalkon.MainApplication.AfterLaunch",
        AfterLaunch_Initializer, AfterLaunch_InitializerValues);
    SbkPyFalkonTypes[SBK_MAINAPPLICATION_AFTERLAUNCH_IDX] = EType;
    // Register converter for enum 'MainApplication::AfterLaunch'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            MainApplication_AfterLaunch_CppToPython_MainApplication_AfterLaunch);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            MainApplication_AfterLaunch_PythonToCpp_MainApplication_AfterLaunch,
            is_MainApplication_AfterLaunch_PythonToCpp_MainApplication_AfterLaunch_Convertible);
        Shiboken::Enum::setTypeConverter(EType, converter);
        Shiboken::Conversions::registerConverterName(converter, "MainApplication::AfterLaunch");
        Shiboken::Conversions::registerConverterName(converter, "AfterLaunch");
    }
    // End of 'AfterLaunch' enum.

    PySide::Signal::registerSignals(pyType, &::MainApplication::staticMetaObject);
    MainApplicationWrapper::pysideInitQtMetaTypes();
    Shiboken::ObjectType::setSubTypeInitHook(pyType, &PySide::initQObjectSubType);
    PySide::initDynamicMetaObject(pyType, &::MainApplication::staticMetaObject, sizeof(MainApplicationWrapper));
}
