#ifndef SBK_NETWORKMANAGERWRAPPER_H
#define SBK_NETWORKMANAGERWRAPPER_H

#include <networkmanager.h>


// Argument includes
#include <QList>
#include <QString>
#include <QStringList>
#include <qbytearray.h>
#include <qcoreevent.h>
#include <qhstspolicy.h>
#include <qiodevice.h>
#include <qmetaobject.h>
#include <qnetworkaccessmanager.h>
#include <qnetworkreply.h>
#include <qnetworkrequest.h>
#include <qobject.h>
#include <qobjectdefs.h>
#include <qsslconfiguration.h>
#include <qsslerror.h>
#include <qsslpresharedkeyauthenticator.h>
#include <qurl.h>
#include <qwebenginecertificateerror.h>
#include <qwidget.h>
#include <schemehandlers/extensionschemehandler.h>
#include <urlinterceptor.h>
namespace PySide { class DynamicQMetaObject; }

class NetworkManagerWrapper : public NetworkManager
{
public:
    NetworkManagerWrapper(const NetworkManagerWrapper &) = delete;
    NetworkManagerWrapper& operator=(const NetworkManagerWrapper &) = delete;
    NetworkManagerWrapper(NetworkManagerWrapper &&) = delete;
    NetworkManagerWrapper& operator=(NetworkManagerWrapper &&) = delete;

    NetworkManagerWrapper(::QObject * parent = nullptr);
    inline void childEvent_protected(::QChildEvent * event) { QObject::childEvent(event); }
    void childEvent(::QChildEvent * event) override;
    inline void connectNotify_protected(const ::QMetaMethod & signal) { QObject::connectNotify(signal); }
    void connectNotify(const ::QMetaMethod & signal) override;
    inline ::QNetworkReply * createRequest_protected(::QNetworkAccessManager::Operation op, const ::QNetworkRequest & request, ::QIODevice * outgoingData) { return NetworkManager::createRequest(QNetworkAccessManager::Operation(op), request, outgoingData); }
    ::QNetworkReply * createRequest(::QNetworkAccessManager::Operation op, const ::QNetworkRequest & request, ::QIODevice * outgoingData) override;
    inline void customEvent_protected(::QEvent * event) { QObject::customEvent(event); }
    void customEvent(::QEvent * event) override;
    inline void disconnectNotify_protected(const ::QMetaMethod & signal) { QObject::disconnectNotify(signal); }
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    const ::QMetaObject * metaObject() const override;
    ::QStringList supportedSchemes() const override;
    inline ::QStringList supportedSchemesImplementation_protected() const { return QNetworkAccessManager::supportedSchemesImplementation(); }
    inline void timerEvent_protected(::QTimerEvent * event) { QObject::timerEvent(event); }
    void timerEvent(::QTimerEvent * event) override;
    ~NetworkManagerWrapper() override;
public:
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[9];
};

#  ifndef SBK_QNETWORKACCESSMANAGERWRAPPER_H
#  define SBK_QNETWORKACCESSMANAGERWRAPPER_H

// Inherited base class:
class QNetworkAccessManagerWrapper : public QNetworkAccessManager
{
public:
    QNetworkAccessManagerWrapper(const QNetworkAccessManagerWrapper &) = delete;
    QNetworkAccessManagerWrapper& operator=(const QNetworkAccessManagerWrapper &) = delete;
    QNetworkAccessManagerWrapper(QNetworkAccessManagerWrapper &&) = delete;
    QNetworkAccessManagerWrapper& operator=(QNetworkAccessManagerWrapper &&) = delete;

    QNetworkAccessManagerWrapper(::QObject * parent = nullptr);
    inline void childEvent_protected(::QChildEvent * event) { QObject::childEvent(event); }
    void childEvent(::QChildEvent * event) override;
    inline void connectNotify_protected(const ::QMetaMethod & signal) { QObject::connectNotify(signal); }
    void connectNotify(const ::QMetaMethod & signal) override;
    inline ::QNetworkReply * createRequest_protected(::QNetworkAccessManager::Operation op, const ::QNetworkRequest & request, ::QIODevice * outgoingData = nullptr) { return QNetworkAccessManager::createRequest(QNetworkAccessManager::Operation(op), request, outgoingData); }
    ::QNetworkReply * createRequest(::QNetworkAccessManager::Operation op, const ::QNetworkRequest & request, ::QIODevice * outgoingData = nullptr) override;
    inline void customEvent_protected(::QEvent * event) { QObject::customEvent(event); }
    void customEvent(::QEvent * event) override;
    inline void disconnectNotify_protected(const ::QMetaMethod & signal) { QObject::disconnectNotify(signal); }
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    inline bool isSignalConnected_protected(const ::QMetaMethod & signal) const { return QObject::isSignalConnected(signal); }
    const ::QMetaObject * metaObject() const override;
    inline int receivers_protected(const char * signal) const { return QObject::receivers(signal); }
    inline ::QObject * sender_protected() const { return QObject::sender(); }
    inline int senderSignalIndex_protected() const { return QObject::senderSignalIndex(); }
    ::QStringList supportedSchemes() const override;
    inline ::QStringList supportedSchemesImplementation_protected() const { return QNetworkAccessManager::supportedSchemesImplementation(); }
    inline void timerEvent_protected(::QTimerEvent * event) { QObject::timerEvent(event); }
    void timerEvent(::QTimerEvent * event) override;
    ~QNetworkAccessManagerWrapper() override;
public:
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[9];
};

#  endif // SBK_QNETWORKACCESSMANAGERWRAPPER_H

#  ifndef SBK_QOBJECTWRAPPER_H
#  define SBK_QOBJECTWRAPPER_H

// Inherited base class:
class QObjectWrapper : public QObject
{
public:
    QObjectWrapper(const QObjectWrapper &) = delete;
    QObjectWrapper& operator=(const QObjectWrapper &) = delete;
    QObjectWrapper(QObjectWrapper &&) = delete;
    QObjectWrapper& operator=(QObjectWrapper &&) = delete;

    QObjectWrapper(::QObject * parent = nullptr);
    inline void childEvent_protected(::QChildEvent * event) { QObject::childEvent(event); }
    void childEvent(::QChildEvent * event) override;
    inline void connectNotify_protected(const ::QMetaMethod & signal) { QObject::connectNotify(signal); }
    void connectNotify(const ::QMetaMethod & signal) override;
    inline void customEvent_protected(::QEvent * event) { QObject::customEvent(event); }
    void customEvent(::QEvent * event) override;
    inline void disconnectNotify_protected(const ::QMetaMethod & signal) { QObject::disconnectNotify(signal); }
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    inline bool isSignalConnected_protected(const ::QMetaMethod & signal) const { return QObject::isSignalConnected(signal); }
    const ::QMetaObject * metaObject() const override;
    inline int receivers_protected(const char * signal) const { return QObject::receivers(signal); }
    inline ::QObject * sender_protected() const { return QObject::sender(); }
    inline int senderSignalIndex_protected() const { return QObject::senderSignalIndex(); }
    inline void timerEvent_protected(::QTimerEvent * event) { QObject::timerEvent(event); }
    void timerEvent(::QTimerEvent * event) override;
    ~QObjectWrapper() override;
public:
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[7];
};

#  endif // SBK_QOBJECTWRAPPER_H

#endif // SBK_NETWORKMANAGERWRAPPER_H

