#ifndef SBK_PASSWORDBACKENDWRAPPER_H
#define SBK_PASSWORDBACKENDWRAPPER_H

#include <passwordbackends/passwordbackend.h>


// Argument includes
#include <QList>
#include <QString>
#include <QStringList>
#include <passwordmanager.h>
#include <qurl.h>
#include <qwidget.h>
class PasswordBackendWrapper : public PasswordBackend
{
public:
    PasswordBackendWrapper(const PasswordBackendWrapper &) = delete;
    PasswordBackendWrapper& operator=(const PasswordBackendWrapper &) = delete;
    PasswordBackendWrapper(PasswordBackendWrapper &&) = delete;
    PasswordBackendWrapper& operator=(PasswordBackendWrapper &&) = delete;

    PasswordBackendWrapper();
    void addEntry(const ::PasswordEntry & entry) override;
    ::QList<PasswordEntry> getAllEntries() override;
    ::QList<PasswordEntry> getEntries(const ::QUrl & url) override;
    ::QStringList getUsernames(const ::QUrl & url) override;
    bool hasSettings() const override;
    ::QString name() const override;
    void removeAll() override;
    void removeEntry(const ::PasswordEntry & entry) override;
    void setActive(bool active) override;
    void showSettings(::QWidget * parent) override;
    bool updateEntry(const ::PasswordEntry & entry) override;
    void updateLastUsed(::PasswordEntry & entry) override;
    ~PasswordBackendWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[12];
};

#endif // SBK_PASSWORDBACKENDWRAPPER_H

