
// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyfalkon_python.h"

// main header
#include "passwordentry_wrapper.h"

// Argument includes
#include <passwordmanager.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_PasswordEntry_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::PasswordEntry >()))
        return -1;

    ::PasswordEntry *cptr{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PyFalkon.PasswordEntry.__init__";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "PasswordEntry", 0, 1, &(pyArgs[0])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: PasswordEntry::PasswordEntry()
    // 1: PasswordEntry::PasswordEntry(PasswordEntry)
    if (numArgs == 0) {
        overloadId = 0; // PasswordEntry()
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(SbkPyFalkonTypes[SBK_PASSWORDENTRY_IDX], (pyArgs[0])))) {
        overloadId = 1; // PasswordEntry(PasswordEntry)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, fullName);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // PasswordEntry()
        {

            if (Shiboken::Errors::occurred() == nullptr) {
                // PasswordEntry()
                cptr = new ::PasswordEntry();
            }
            break;
        }
        case 1: // PasswordEntry(const PasswordEntry & PasswordEntry)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::PasswordEntry cppArg0_local;
            ::PasswordEntry *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // PasswordEntry(PasswordEntry)
                cptr = new ::PasswordEntry(*cppArg0);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::PasswordEntry >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_PasswordEntryFunc_isValid(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::PasswordEntry *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_PASSWORDENTRY_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PyFalkon.PasswordEntry.isValid";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // isValid()const
            bool cppResult = const_cast<const ::PasswordEntry *>(cppSelf)->isValid();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_PasswordEntry__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::PasswordEntry *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_PASSWORDENTRY_IDX], reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(SbkPyFalkonTypes[SBK_PASSWORDENTRY_IDX], &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_PasswordEntry_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_PasswordEntry_methods[] = {
    {"isValid", reinterpret_cast<PyCFunction>(Sbk_PasswordEntryFunc_isValid), METH_NOARGS, nullptr},
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_PasswordEntry__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

// Rich comparison
static PyObject * Sbk_PasswordEntry_richcompare(PyObject *self, PyObject *pyArg, int op)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::PasswordEntry *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_PASSWORDENTRY_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    switch (op) {
        case Py_LT:
            if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(SbkPyFalkonTypes[SBK_PASSWORDENTRY_IDX], (pyArg)))) {
                // operator<(const PasswordEntry & other) const
                if (!Shiboken::Object::isValid(pyArg))
                    return {};
                ::PasswordEntry cppArg0_local;
                ::PasswordEntry *cppArg0 = &cppArg0_local;
                if (pythonToCpp.isValue())
                    pythonToCpp(pyArg, &cppArg0_local);
                else
                    pythonToCpp(pyArg, &cppArg0);

                bool cppResult = cppSelf < (*cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
            } else {
                return Shiboken::returnFromRichCompare(pyResult);
            }

            break;
        case Py_EQ:
            if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(SbkPyFalkonTypes[SBK_PASSWORDENTRY_IDX], (pyArg)))) {
                // operator==(const PasswordEntry & other) const
                if (!Shiboken::Object::isValid(pyArg))
                    return {};
                ::PasswordEntry cppArg0_local;
                ::PasswordEntry *cppArg0 = &cppArg0_local;
                if (pythonToCpp.isValue())
                    pythonToCpp(pyArg, &cppArg0_local);
                else
                    pythonToCpp(pyArg, &cppArg0);

                bool cppResult = cppSelf == (*cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
            } else {
                pyResult = Py_False;
                Py_INCREF(pyResult);
            }

            break;
        default:
            // PYSIDE-74: By default, we redirect to object's tp_richcompare (which is `==`, `!=`).
            return FallbackRichCompare(self, pyArg, op);
    }

    return Shiboken::returnFromRichCompare(pyResult);
}

static PyObject *Sbk_PasswordEntry_get_id(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::PasswordEntry *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_PASSWORDENTRY_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QVARIANT_IDX], &cppSelf->id);
    return pyOut;
}
static int Sbk_PasswordEntry_set_id(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::PasswordEntry *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_PASSWORDENTRY_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("id");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QVARIANT_IDX], (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("id", "QVariant");
        return -1;
    }

    auto &cppOut_ptr = cppSelf->id;
    pythonToCpp(pyIn, &cppOut_ptr);

    return 0;
}

static PyObject *Sbk_PasswordEntry_get_host(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::PasswordEntry *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_PASSWORDENTRY_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QSTRING_IDX], &cppSelf->host);
    return pyOut;
}
static int Sbk_PasswordEntry_set_host(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::PasswordEntry *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_PASSWORDENTRY_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("host");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QSTRING_IDX], (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("host", "QString");
        return -1;
    }

    auto &cppOut_ptr = cppSelf->host;
    pythonToCpp(pyIn, &cppOut_ptr);

    return 0;
}

static PyObject *Sbk_PasswordEntry_get_username(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::PasswordEntry *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_PASSWORDENTRY_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QSTRING_IDX], &cppSelf->username);
    return pyOut;
}
static int Sbk_PasswordEntry_set_username(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::PasswordEntry *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_PASSWORDENTRY_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("username");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QSTRING_IDX], (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("username", "QString");
        return -1;
    }

    auto &cppOut_ptr = cppSelf->username;
    pythonToCpp(pyIn, &cppOut_ptr);

    return 0;
}

static PyObject *Sbk_PasswordEntry_get_password(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::PasswordEntry *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_PASSWORDENTRY_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QSTRING_IDX], &cppSelf->password);
    return pyOut;
}
static int Sbk_PasswordEntry_set_password(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::PasswordEntry *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_PASSWORDENTRY_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("password");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QSTRING_IDX], (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("password", "QString");
        return -1;
    }

    auto &cppOut_ptr = cppSelf->password;
    pythonToCpp(pyIn, &cppOut_ptr);

    return 0;
}

static PyObject *Sbk_PasswordEntry_get_data(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::PasswordEntry *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_PASSWORDENTRY_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyOut = {};
    if (reinterpret_cast<void *>(&(cppSelf->data)) == reinterpret_cast<void *>(cppSelf)) {
        pyOut = reinterpret_cast<PyObject *>(Shiboken::Object::findColocatedChild(reinterpret_cast<SbkObject *>(self), SbkPySide6_QtCoreTypes[SBK_QBYTEARRAY_IDX]));
        if (pyOut != nullptr) {
            Py_IncRef(pyOut);
            return pyOut;
        }
    } else if (Shiboken::BindingManager::instance().hasWrapper(&(cppSelf->data))) {
        pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(&(cppSelf->data)));
        Py_IncRef(pyOut);
        return pyOut;
    }
    pyOut = Shiboken::Object::newObject(SbkPySide6_QtCoreTypes[SBK_QBYTEARRAY_IDX], &(cppSelf->data), false, true);
    Shiboken::Object::setParent(self, pyOut);
    return pyOut;
}
static int Sbk_PasswordEntry_set_data(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::PasswordEntry *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_PASSWORDENTRY_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("data");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppValueConversion(SbkPySide6_QtCoreTypes[SBK_QBYTEARRAY_IDX], (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("data", "QByteArray");
        return -1;
    }

    auto &cppOut_ptr = cppSelf->data;
    pythonToCpp(pyIn, &cppOut_ptr);

    return 0;
}

static PyObject *Sbk_PasswordEntry_get_updated(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::PasswordEntry *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_PASSWORDENTRY_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    int cppOut_local = cppSelf->updated;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<int>(), &cppOut_local);
    return pyOut;
}
static int Sbk_PasswordEntry_set_updated(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::PasswordEntry *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_PASSWORDENTRY_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("updated");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("updated", "int");
        return -1;
    }

    auto cppOut_local = cppSelf->updated;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->updated = cppOut_local;

    return 0;
}

// Getters and Setters for PasswordEntry
static PyGetSetDef Sbk_PasswordEntry_getsetlist[] = {
    {const_cast<char *>("id"), Sbk_PasswordEntry_get_id, Sbk_PasswordEntry_set_id, nullptr, nullptr},
    {const_cast<char *>("host"), Sbk_PasswordEntry_get_host, Sbk_PasswordEntry_set_host, nullptr, nullptr},
    {const_cast<char *>("username"), Sbk_PasswordEntry_get_username, Sbk_PasswordEntry_set_username, nullptr, nullptr},
    {const_cast<char *>("password"), Sbk_PasswordEntry_get_password, Sbk_PasswordEntry_set_password, nullptr, nullptr},
    {const_cast<char *>("data"), Sbk_PasswordEntry_get_data, Sbk_PasswordEntry_set_data, nullptr, nullptr},
    {const_cast<char *>("updated"), Sbk_PasswordEntry_get_updated, Sbk_PasswordEntry_set_updated, nullptr, nullptr},
    {nullptr, nullptr, nullptr, nullptr, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_PasswordEntry_traverse(PyObject *self, visitproc visit, void *arg)
{
    return SbkObject_TypeF()->tp_traverse(self, visit, arg);
}
static int Sbk_PasswordEntry_clear(PyObject *self)
{
    return reinterpret_cast<PyTypeObject *>(SbkObject_TypeF())->tp_clear(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_PasswordEntry_Type = nullptr;
static PyTypeObject *Sbk_PasswordEntry_TypeF(void)
{
    return _Sbk_PasswordEntry_Type;
}

static PyType_Slot Sbk_PasswordEntry_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_PasswordEntry_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_PasswordEntry_clear)},
    {Py_tp_richcompare, reinterpret_cast<void *>(Sbk_PasswordEntry_richcompare)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_PasswordEntry_methods)},
    {Py_tp_getset,      reinterpret_cast<void *>(Sbk_PasswordEntry_getsetlist)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_PasswordEntry_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_PasswordEntry_spec = {
    "1:PyFalkon.PasswordEntry",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_PasswordEntry_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void PasswordEntry_PythonToCpp_PasswordEntry_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_PasswordEntry_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_PasswordEntry_PythonToCpp_PasswordEntry_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_PasswordEntry_TypeF()))
        return PasswordEntry_PythonToCpp_PasswordEntry_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *PasswordEntry_PTR_CppToPython_PasswordEntry(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    bool changedTypeName = false;
    auto *tCppIn = reinterpret_cast<const ::PasswordEntry *>(cppIn);
    const char *typeName = typeid(*tCppIn).name();
    auto *sbkType = Shiboken::ObjectType::typeForTypeName(typeName);
    if (sbkType != nullptr && Shiboken::ObjectType::hasSpecialCastFunction(sbkType)) {
        typeName = Shiboken::typeNameOf(typeid(*tCppIn).name());
        changedTypeName = true;
    }
    PyObject *result = Shiboken::Object::newObject(Sbk_PasswordEntry_TypeF(), const_cast<void *>(cppIn), false, /* exactType */ changedTypeName, typeName);
    if (changedTypeName)
        delete [] typeName;
    return result;
}

// C++ to Python copy conversion.
static PyObject *PasswordEntry_COPY_CppToPython_PasswordEntry(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::PasswordEntry *>(cppIn);
    return Shiboken::Object::newObject(Sbk_PasswordEntry_TypeF(), new ::PasswordEntry(*source), true, true);
}

// Python to C++ copy conversion.
static void PasswordEntry_PythonToCpp_PasswordEntry_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::PasswordEntry *>(cppOut) = *reinterpret_cast< ::PasswordEntry *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_PASSWORDENTRY_IDX], reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_PasswordEntry_PythonToCpp_PasswordEntry_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_PasswordEntry_TypeF()))
        return PasswordEntry_PythonToCpp_PasswordEntry_COPY;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *PasswordEntry_SignatureStrings[] = {
    "1:PyFalkon.PasswordEntry(self)",
    "0:PyFalkon.PasswordEntry(self,PasswordEntry:PyFalkon.PasswordEntry)",
    "PyFalkon.PasswordEntry.isValid(self)->bool",
    "PyFalkon.PasswordEntry.__copy__()",
    nullptr}; // Sentinel

void init_PasswordEntry(PyObject *module)
{
    _Sbk_PasswordEntry_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "PasswordEntry",
        "PasswordEntry",
        &Sbk_PasswordEntry_spec,
        &Shiboken::callCppDestructor< ::PasswordEntry >,
        nullptr,
        0,
        0);
    auto *pyType = Sbk_PasswordEntry_TypeF(); // references _Sbk_PasswordEntry_Type
    InitSignatureStrings(pyType, PasswordEntry_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_PasswordEntry_PropertyStrings);
    SbkPyFalkonTypes[SBK_PASSWORDENTRY_IDX] = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        PasswordEntry_PythonToCpp_PasswordEntry_PTR,
        is_PasswordEntry_PythonToCpp_PasswordEntry_PTR_Convertible,
        PasswordEntry_PTR_CppToPython_PasswordEntry,
        PasswordEntry_COPY_CppToPython_PasswordEntry);

    Shiboken::Conversions::registerConverterName(converter, "PasswordEntry");
    Shiboken::Conversions::registerConverterName(converter, "PasswordEntry*");
    Shiboken::Conversions::registerConverterName(converter, "PasswordEntry&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::PasswordEntry).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        PasswordEntry_PythonToCpp_PasswordEntry_COPY,
        is_PasswordEntry_PythonToCpp_PasswordEntry_COPY_Convertible);

    qRegisterMetaType< ::PasswordEntry >("PasswordEntry");
}
