#ifndef SBK_PLUGININTERFACEWRAPPER_H
#define SBK_PLUGININTERFACEWRAPPER_H

#include <plugininterface.h>


// Argument includes
#include <QString>
#include <plugininterface.h>
#include <qevent.h>
#include <qmenu.h>
#include <qobject.h>
#include <qurl.h>
#include <qwebenginepage.h>
#include <qwidget.h>
#include <qzcommon.h>
#include <webhittestresult.h>
#include <webpage.h>
#include <webview.h>
class PluginInterfaceWrapper : public PluginInterface
{
public:
    PluginInterfaceWrapper(const PluginInterfaceWrapper &) = delete;
    PluginInterfaceWrapper& operator=(const PluginInterfaceWrapper &) = delete;
    PluginInterfaceWrapper(PluginInterfaceWrapper &&) = delete;
    PluginInterfaceWrapper& operator=(PluginInterfaceWrapper &&) = delete;

    PluginInterfaceWrapper();
    bool acceptNavigationRequest(::WebPage * page, const ::QUrl & url, ::QWebEnginePage::NavigationType type, bool isMainFrame) override;
    void init(::PluginInterface::InitState state, const ::QString & settingsPath) override;
    bool keyPress(::Qz::ObjectName type, ::QObject * obj, ::QKeyEvent * event) override;
    bool keyRelease(::Qz::ObjectName type, ::QObject * obj, ::QKeyEvent * event) override;
    bool mouseDoubleClick(::Qz::ObjectName type, ::QObject * obj, ::QMouseEvent * event) override;
    bool mouseMove(::Qz::ObjectName type, ::QObject * obj, ::QMouseEvent * event) override;
    bool mousePress(::Qz::ObjectName type, ::QObject * obj, ::QMouseEvent * event) override;
    bool mouseRelease(::Qz::ObjectName type, ::QObject * obj, ::QMouseEvent * event) override;
    void populateExtensionsMenu(::QMenu * menu) override;
    void populateWebViewMenu(::QMenu * menu, ::WebView * view, const ::WebHitTestResult & r) override;
    void showSettings(::QWidget * parent = nullptr) override;
    bool testPlugin() override;
    void unload() override;
    bool wheelEvent(::Qz::ObjectName type, ::QObject * obj, ::QWheelEvent * event) override;
    ~PluginInterfaceWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[14];
};

#endif // SBK_PLUGININTERFACEWRAPPER_H

