
// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyfalkon_python.h"

// main header
#include "pluginspec_wrapper.h"

// Argument includes
#include <plugins.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_PluginSpec_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::PluginSpec >()))
        return -1;

    ::PluginSpec *cptr{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PyFalkon.PluginSpec.__init__";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "PluginSpec", 0, 1, &(pyArgs[0])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: PluginSpec::PluginSpec()
    // 1: PluginSpec::PluginSpec(PluginSpec)
    if (numArgs == 0) {
        overloadId = 0; // PluginSpec()
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(SbkPyFalkonTypes[SBK_PLUGINSPEC_IDX], (pyArgs[0])))) {
        overloadId = 1; // PluginSpec(PluginSpec)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, fullName);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // PluginSpec()
        {

            if (Shiboken::Errors::occurred() == nullptr) {
                // PluginSpec()
                cptr = new ::PluginSpec();
            }
            break;
        }
        case 1: // PluginSpec(const PluginSpec & PluginSpec)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::PluginSpec cppArg0_local;
            ::PluginSpec *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // PluginSpec(PluginSpec)
                cptr = new ::PluginSpec(*cppArg0);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::PluginSpec >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_PluginSpec__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::PluginSpec *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_PLUGINSPEC_IDX], reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(SbkPyFalkonTypes[SBK_PLUGINSPEC_IDX], &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_PluginSpec_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_PluginSpec_methods[] = {
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_PluginSpec__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

// Rich comparison
static PyObject * Sbk_PluginSpec_richcompare(PyObject *self, PyObject *pyArg, int op)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::PluginSpec *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_PLUGINSPEC_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    switch (op) {
        case Py_EQ:
            if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(SbkPyFalkonTypes[SBK_PLUGINSPEC_IDX], (pyArg)))) {
                // operator==(const PluginSpec & other) const
                if (!Shiboken::Object::isValid(pyArg))
                    return {};
                ::PluginSpec cppArg0_local;
                ::PluginSpec *cppArg0 = &cppArg0_local;
                if (pythonToCpp.isValue())
                    pythonToCpp(pyArg, &cppArg0_local);
                else
                    pythonToCpp(pyArg, &cppArg0);

                bool cppResult = cppSelf == (*cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
            } else {
                pyResult = Py_False;
                Py_INCREF(pyResult);
            }

            break;
        default:
            // PYSIDE-74: By default, we redirect to object's tp_richcompare (which is `==`, `!=`).
            return FallbackRichCompare(self, pyArg, op);
    }

    return Shiboken::returnFromRichCompare(pyResult);
}

static PyObject *Sbk_PluginSpec_get_name(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::PluginSpec *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_PLUGINSPEC_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QSTRING_IDX], &cppSelf->name);
    return pyOut;
}
static int Sbk_PluginSpec_set_name(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::PluginSpec *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_PLUGINSPEC_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("name");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QSTRING_IDX], (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("name", "QString");
        return -1;
    }

    auto &cppOut_ptr = cppSelf->name;
    pythonToCpp(pyIn, &cppOut_ptr);

    return 0;
}

static PyObject *Sbk_PluginSpec_get_description(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::PluginSpec *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_PLUGINSPEC_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QSTRING_IDX], &cppSelf->description);
    return pyOut;
}
static int Sbk_PluginSpec_set_description(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::PluginSpec *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_PLUGINSPEC_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("description");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QSTRING_IDX], (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("description", "QString");
        return -1;
    }

    auto &cppOut_ptr = cppSelf->description;
    pythonToCpp(pyIn, &cppOut_ptr);

    return 0;
}

static PyObject *Sbk_PluginSpec_get_author(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::PluginSpec *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_PLUGINSPEC_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QSTRING_IDX], &cppSelf->author);
    return pyOut;
}
static int Sbk_PluginSpec_set_author(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::PluginSpec *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_PLUGINSPEC_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("author");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QSTRING_IDX], (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("author", "QString");
        return -1;
    }

    auto &cppOut_ptr = cppSelf->author;
    pythonToCpp(pyIn, &cppOut_ptr);

    return 0;
}

static PyObject *Sbk_PluginSpec_get_version(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::PluginSpec *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_PLUGINSPEC_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QSTRING_IDX], &cppSelf->version);
    return pyOut;
}
static int Sbk_PluginSpec_set_version(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::PluginSpec *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_PLUGINSPEC_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("version");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QSTRING_IDX], (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("version", "QString");
        return -1;
    }

    auto &cppOut_ptr = cppSelf->version;
    pythonToCpp(pyIn, &cppOut_ptr);

    return 0;
}

static PyObject *Sbk_PluginSpec_get_icon(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::PluginSpec *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_PLUGINSPEC_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyOut = {};
    if (reinterpret_cast<void *>(&(cppSelf->icon)) == reinterpret_cast<void *>(cppSelf)) {
        pyOut = reinterpret_cast<PyObject *>(Shiboken::Object::findColocatedChild(reinterpret_cast<SbkObject *>(self), SbkPySide6_QtGuiTypes[SBK_QPIXMAP_IDX]));
        if (pyOut != nullptr) {
            Py_IncRef(pyOut);
            return pyOut;
        }
    } else if (Shiboken::BindingManager::instance().hasWrapper(&(cppSelf->icon))) {
        pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(&(cppSelf->icon)));
        Py_IncRef(pyOut);
        return pyOut;
    }
    pyOut = Shiboken::Object::newObject(SbkPySide6_QtGuiTypes[SBK_QPIXMAP_IDX], &(cppSelf->icon), false, true);
    Shiboken::Object::setParent(self, pyOut);
    return pyOut;
}
static int Sbk_PluginSpec_set_icon(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::PluginSpec *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_PLUGINSPEC_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("icon");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppValueConversion(SbkPySide6_QtGuiTypes[SBK_QPIXMAP_IDX], (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("icon", "QPixmap");
        return -1;
    }

    auto &cppOut_ptr = cppSelf->icon;
    pythonToCpp(pyIn, &cppOut_ptr);

    return 0;
}

static PyObject *Sbk_PluginSpec_get_hasSettings(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::PluginSpec *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_PLUGINSPEC_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    bool cppOut_local = cppSelf->hasSettings;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppOut_local);
    return pyOut;
}
static int Sbk_PluginSpec_set_hasSettings(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::PluginSpec *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_PLUGINSPEC_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("hasSettings");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("hasSettings", "bool");
        return -1;
    }

    auto cppOut_local = cppSelf->hasSettings;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->hasSettings = cppOut_local;

    return 0;
}

// Getters and Setters for PluginSpec
static PyGetSetDef Sbk_PluginSpec_getsetlist[] = {
    {const_cast<char *>("name"), Sbk_PluginSpec_get_name, Sbk_PluginSpec_set_name, nullptr, nullptr},
    {const_cast<char *>("description"), Sbk_PluginSpec_get_description, Sbk_PluginSpec_set_description, nullptr, nullptr},
    {const_cast<char *>("author"), Sbk_PluginSpec_get_author, Sbk_PluginSpec_set_author, nullptr, nullptr},
    {const_cast<char *>("version"), Sbk_PluginSpec_get_version, Sbk_PluginSpec_set_version, nullptr, nullptr},
    {const_cast<char *>("icon"), Sbk_PluginSpec_get_icon, Sbk_PluginSpec_set_icon, nullptr, nullptr},
    {const_cast<char *>("hasSettings"), Sbk_PluginSpec_get_hasSettings, Sbk_PluginSpec_set_hasSettings, nullptr, nullptr},
    {nullptr, nullptr, nullptr, nullptr, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_PluginSpec_traverse(PyObject *self, visitproc visit, void *arg)
{
    return SbkObject_TypeF()->tp_traverse(self, visit, arg);
}
static int Sbk_PluginSpec_clear(PyObject *self)
{
    return reinterpret_cast<PyTypeObject *>(SbkObject_TypeF())->tp_clear(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_PluginSpec_Type = nullptr;
static PyTypeObject *Sbk_PluginSpec_TypeF(void)
{
    return _Sbk_PluginSpec_Type;
}

static PyType_Slot Sbk_PluginSpec_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_PluginSpec_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_PluginSpec_clear)},
    {Py_tp_richcompare, reinterpret_cast<void *>(Sbk_PluginSpec_richcompare)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_PluginSpec_methods)},
    {Py_tp_getset,      reinterpret_cast<void *>(Sbk_PluginSpec_getsetlist)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_PluginSpec_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_PluginSpec_spec = {
    "1:PyFalkon.PluginSpec",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_PluginSpec_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void PluginSpec_PythonToCpp_PluginSpec_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_PluginSpec_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_PluginSpec_PythonToCpp_PluginSpec_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_PluginSpec_TypeF()))
        return PluginSpec_PythonToCpp_PluginSpec_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *PluginSpec_PTR_CppToPython_PluginSpec(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    bool changedTypeName = false;
    auto *tCppIn = reinterpret_cast<const ::PluginSpec *>(cppIn);
    const char *typeName = typeid(*tCppIn).name();
    auto *sbkType = Shiboken::ObjectType::typeForTypeName(typeName);
    if (sbkType != nullptr && Shiboken::ObjectType::hasSpecialCastFunction(sbkType)) {
        typeName = Shiboken::typeNameOf(typeid(*tCppIn).name());
        changedTypeName = true;
    }
    PyObject *result = Shiboken::Object::newObject(Sbk_PluginSpec_TypeF(), const_cast<void *>(cppIn), false, /* exactType */ changedTypeName, typeName);
    if (changedTypeName)
        delete [] typeName;
    return result;
}

// C++ to Python copy conversion.
static PyObject *PluginSpec_COPY_CppToPython_PluginSpec(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::PluginSpec *>(cppIn);
    return Shiboken::Object::newObject(Sbk_PluginSpec_TypeF(), new ::PluginSpec(*source), true, true);
}

// Python to C++ copy conversion.
static void PluginSpec_PythonToCpp_PluginSpec_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::PluginSpec *>(cppOut) = *reinterpret_cast< ::PluginSpec *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_PLUGINSPEC_IDX], reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_PluginSpec_PythonToCpp_PluginSpec_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_PluginSpec_TypeF()))
        return PluginSpec_PythonToCpp_PluginSpec_COPY;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *PluginSpec_SignatureStrings[] = {
    "1:PyFalkon.PluginSpec(self)",
    "0:PyFalkon.PluginSpec(self,PluginSpec:PyFalkon.PluginSpec)",
    "PyFalkon.PluginSpec.__copy__()",
    nullptr}; // Sentinel

void init_PluginSpec(PyObject *module)
{
    _Sbk_PluginSpec_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "PluginSpec",
        "PluginSpec",
        &Sbk_PluginSpec_spec,
        &Shiboken::callCppDestructor< ::PluginSpec >,
        nullptr,
        0,
        0);
    auto *pyType = Sbk_PluginSpec_TypeF(); // references _Sbk_PluginSpec_Type
    InitSignatureStrings(pyType, PluginSpec_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_PluginSpec_PropertyStrings);
    SbkPyFalkonTypes[SBK_PLUGINSPEC_IDX] = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        PluginSpec_PythonToCpp_PluginSpec_PTR,
        is_PluginSpec_PythonToCpp_PluginSpec_PTR_Convertible,
        PluginSpec_PTR_CppToPython_PluginSpec,
        PluginSpec_COPY_CppToPython_PluginSpec);

    Shiboken::Conversions::registerConverterName(converter, "PluginSpec");
    Shiboken::Conversions::registerConverterName(converter, "PluginSpec*");
    Shiboken::Conversions::registerConverterName(converter, "PluginSpec&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::PluginSpec).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        PluginSpec_PythonToCpp_PluginSpec_COPY,
        is_PluginSpec_PythonToCpp_PluginSpec_COPY_Convertible);

    qRegisterMetaType< ::PluginSpec >("PluginSpec");
}
