#ifndef SBK_QTSINGLEAPPLICATIONWRAPPER_H
#define SBK_QTSINGLEAPPLICATIONWRAPPER_H

#include <qtsingleapplication/qtsingleapplication.h>


// Argument includes
#include <QList>
#include <QString>
#include <qcoreevent.h>
#include <qfont.h>
#include <qfontmetrics.h>
#include <qmetaobject.h>
#include <qnamespace.h>
#include <qobject.h>
#include <qobjectdefs.h>
#include <qpalette.h>
#include <qpoint.h>
#include <qstyle.h>
#include <qwidget.h>
namespace PySide { class DynamicQMetaObject; }

class QtSingleApplicationWrapper : public QtSingleApplication
{
public:
    QtSingleApplicationWrapper(const QtSingleApplicationWrapper &) = delete;
    QtSingleApplicationWrapper& operator=(const QtSingleApplicationWrapper &) = delete;
    QtSingleApplicationWrapper(QtSingleApplicationWrapper &&) = delete;
    QtSingleApplicationWrapper& operator=(QtSingleApplicationWrapper &&) = delete;

    inline void childEvent_protected(::QChildEvent * event) { QObject::childEvent(event); }
    void childEvent(::QChildEvent * event) override;
    inline void connectNotify_protected(const ::QMetaMethod & signal) { QObject::connectNotify(signal); }
    void connectNotify(const ::QMetaMethod & signal) override;
    inline void customEvent_protected(::QEvent * event) { QObject::customEvent(event); }
    void customEvent(::QEvent * event) override;
    inline void disconnectNotify_protected(const ::QMetaMethod & signal) { QObject::disconnectNotify(signal); }
    void disconnectNotify(const ::QMetaMethod & signal) override;
    inline bool event_protected(::QEvent * arg__1) { return QApplication::event(arg__1); }
    bool event(::QEvent * arg__1) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    const ::QMetaObject * metaObject() const override;
    bool notify(::QObject * arg__1, ::QEvent * arg__2) override;
    inline void * resolveInterface_protected(const char * name, int revision) const { return QApplication::resolveInterface(name, revision); }
    inline void timerEvent_protected(::QTimerEvent * event) { QObject::timerEvent(event); }
    void timerEvent(::QTimerEvent * event) override;
    ~QtSingleApplicationWrapper() override;
public:
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[8];
};

#  ifndef SBK_QAPPLICATIONWRAPPER_H
#  define SBK_QAPPLICATIONWRAPPER_H

// Inherited base class:
class QApplicationWrapper : public QApplication
{
public:
    QApplicationWrapper(const QApplicationWrapper &) = delete;
    QApplicationWrapper& operator=(const QApplicationWrapper &) = delete;
    QApplicationWrapper(QApplicationWrapper &&) = delete;
    QApplicationWrapper& operator=(QApplicationWrapper &&) = delete;

    QApplicationWrapper(int & argc, char ** argv, int arg__3 = QCoreApplication::ApplicationFlags);
    inline void childEvent_protected(::QChildEvent * event) { QObject::childEvent(event); }
    void childEvent(::QChildEvent * event) override;
    inline void connectNotify_protected(const ::QMetaMethod & signal) { QObject::connectNotify(signal); }
    void connectNotify(const ::QMetaMethod & signal) override;
    inline void customEvent_protected(::QEvent * event) { QObject::customEvent(event); }
    void customEvent(::QEvent * event) override;
    inline void disconnectNotify_protected(const ::QMetaMethod & signal) { QObject::disconnectNotify(signal); }
    void disconnectNotify(const ::QMetaMethod & signal) override;
    inline bool event_protected(::QEvent * arg__1) { return QApplication::event(arg__1); }
    bool event(::QEvent * arg__1) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    const ::QMetaObject * metaObject() const override;
    bool notify(::QObject * arg__1, ::QEvent * arg__2) override;
    inline void * resolveInterface_protected(const char * name, int revision) const { return QApplication::resolveInterface(name, revision); }
    inline void timerEvent_protected(::QTimerEvent * event) { QObject::timerEvent(event); }
    void timerEvent(::QTimerEvent * event) override;
    ~QApplicationWrapper() override;
public:
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[8];
};

#  endif // SBK_QAPPLICATIONWRAPPER_H

#  ifndef SBK_QGUIAPPLICATIONWRAPPER_H
#  define SBK_QGUIAPPLICATIONWRAPPER_H

// Inherited base class:
class QGuiApplicationWrapper : public QGuiApplication
{
public:
    QGuiApplicationWrapper(const QGuiApplicationWrapper &) = delete;
    QGuiApplicationWrapper& operator=(const QGuiApplicationWrapper &) = delete;
    QGuiApplicationWrapper(QGuiApplicationWrapper &&) = delete;
    QGuiApplicationWrapper& operator=(QGuiApplicationWrapper &&) = delete;

    QGuiApplicationWrapper(int & argc, char ** argv, int arg__3 = QCoreApplication::ApplicationFlags);
    inline void childEvent_protected(::QChildEvent * event) { QObject::childEvent(event); }
    void childEvent(::QChildEvent * event) override;
    inline void connectNotify_protected(const ::QMetaMethod & signal) { QObject::connectNotify(signal); }
    void connectNotify(const ::QMetaMethod & signal) override;
    inline void customEvent_protected(::QEvent * event) { QObject::customEvent(event); }
    void customEvent(::QEvent * event) override;
    inline void disconnectNotify_protected(const ::QMetaMethod & signal) { QObject::disconnectNotify(signal); }
    void disconnectNotify(const ::QMetaMethod & signal) override;
    inline bool event_protected(::QEvent * arg__1) { return QGuiApplication::event(arg__1); }
    bool event(::QEvent * arg__1) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    const ::QMetaObject * metaObject() const override;
    bool notify(::QObject * arg__1, ::QEvent * arg__2) override;
    inline void * resolveInterface_protected(const char * name, int revision) const { return QGuiApplication::resolveInterface(name, revision); }
    inline void timerEvent_protected(::QTimerEvent * event) { QObject::timerEvent(event); }
    void timerEvent(::QTimerEvent * event) override;
    ~QGuiApplicationWrapper() override;
public:
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[8];
};

#  endif // SBK_QGUIAPPLICATIONWRAPPER_H

#  ifndef SBK_QCOREAPPLICATIONWRAPPER_H
#  define SBK_QCOREAPPLICATIONWRAPPER_H

// Inherited base class:
class QCoreApplicationWrapper : public QCoreApplication
{
public:
    QCoreApplicationWrapper(const QCoreApplicationWrapper &) = delete;
    QCoreApplicationWrapper& operator=(const QCoreApplicationWrapper &) = delete;
    QCoreApplicationWrapper(QCoreApplicationWrapper &&) = delete;
    QCoreApplicationWrapper& operator=(QCoreApplicationWrapper &&) = delete;

    QCoreApplicationWrapper(int & argc, char ** argv, int arg__3 = QCoreApplication::ApplicationFlags);
    inline void childEvent_protected(::QChildEvent * event) { QObject::childEvent(event); }
    void childEvent(::QChildEvent * event) override;
    inline void connectNotify_protected(const ::QMetaMethod & signal) { QObject::connectNotify(signal); }
    void connectNotify(const ::QMetaMethod & signal) override;
    inline void customEvent_protected(::QEvent * event) { QObject::customEvent(event); }
    void customEvent(::QEvent * event) override;
    inline void disconnectNotify_protected(const ::QMetaMethod & signal) { QObject::disconnectNotify(signal); }
    void disconnectNotify(const ::QMetaMethod & signal) override;
    inline bool event_protected(::QEvent * arg__1) { return QCoreApplication::event(arg__1); }
    bool event(::QEvent * arg__1) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    inline bool isSignalConnected_protected(const ::QMetaMethod & signal) const { return QObject::isSignalConnected(signal); }
    const ::QMetaObject * metaObject() const override;
    bool notify(::QObject * arg__1, ::QEvent * arg__2) override;
    inline int receivers_protected(const char * signal) const { return QObject::receivers(signal); }
    inline void * resolveInterface_protected(const char * name, int revision) const { return QCoreApplication::resolveInterface(name, revision); }
    inline ::QObject * sender_protected() const { return QObject::sender(); }
    inline int senderSignalIndex_protected() const { return QObject::senderSignalIndex(); }
    inline void timerEvent_protected(::QTimerEvent * event) { QObject::timerEvent(event); }
    void timerEvent(::QTimerEvent * event) override;
    ~QCoreApplicationWrapper() override;
public:
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[8];
};

#  endif // SBK_QCOREAPPLICATIONWRAPPER_H

#  ifndef SBK_QOBJECTWRAPPER_H
#  define SBK_QOBJECTWRAPPER_H

// Inherited base class:
class QObjectWrapper : public QObject
{
public:
    QObjectWrapper(const QObjectWrapper &) = delete;
    QObjectWrapper& operator=(const QObjectWrapper &) = delete;
    QObjectWrapper(QObjectWrapper &&) = delete;
    QObjectWrapper& operator=(QObjectWrapper &&) = delete;

    QObjectWrapper(::QObject * parent = nullptr);
    inline void childEvent_protected(::QChildEvent * event) { QObject::childEvent(event); }
    void childEvent(::QChildEvent * event) override;
    inline void connectNotify_protected(const ::QMetaMethod & signal) { QObject::connectNotify(signal); }
    void connectNotify(const ::QMetaMethod & signal) override;
    inline void customEvent_protected(::QEvent * event) { QObject::customEvent(event); }
    void customEvent(::QEvent * event) override;
    inline void disconnectNotify_protected(const ::QMetaMethod & signal) { QObject::disconnectNotify(signal); }
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    inline bool isSignalConnected_protected(const ::QMetaMethod & signal) const { return QObject::isSignalConnected(signal); }
    const ::QMetaObject * metaObject() const override;
    inline int receivers_protected(const char * signal) const { return QObject::receivers(signal); }
    inline ::QObject * sender_protected() const { return QObject::sender(); }
    inline int senderSignalIndex_protected() const { return QObject::senderSignalIndex(); }
    inline void timerEvent_protected(::QTimerEvent * event) { QObject::timerEvent(event); }
    void timerEvent(::QTimerEvent * event) override;
    ~QObjectWrapper() override;
public:
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[7];
};

#  endif // SBK_QOBJECTWRAPPER_H

#endif // SBK_QTSINGLEAPPLICATIONWRAPPER_H

