
// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyfalkon_python.h"

// main header
#include "qzsettings_wrapper.h"

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QzSettings_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(args)
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QzSettings >()))
        return -1;

    ::QzSettings *cptr{};
    static const char fullName[] = "PyFalkon.QzSettings.__init__";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, fullName);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // QzSettings()
            cptr = new ::QzSettings();
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QzSettings >(), cptr)) {
        delete cptr;
        return -1;
    }
    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QzSettingsFunc_loadSettings(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QzSettings *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_QZSETTINGS_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    static const char fullName[] = "PyFalkon.QzSettings.loadSettings";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // loadSettings()
            cppSelf->loadSettings();
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QzSettingsFunc_saveSettings(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QzSettings *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_QZSETTINGS_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    static const char fullName[] = "PyFalkon.QzSettings.saveSettings";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // saveSettings()
            cppSelf->saveSettings();
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}


static const char *Sbk_QzSettings_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_QzSettings_methods[] = {
    {"loadSettings", reinterpret_cast<PyCFunction>(Sbk_QzSettingsFunc_loadSettings), METH_NOARGS, nullptr},
    {"saveSettings", reinterpret_cast<PyCFunction>(Sbk_QzSettingsFunc_saveSettings), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

static PyObject *Sbk_QzSettings_get_selectAllOnDoubleClick(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QzSettings *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_QZSETTINGS_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    bool cppOut_local = cppSelf->selectAllOnDoubleClick;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppOut_local);
    return pyOut;
}
static int Sbk_QzSettings_set_selectAllOnDoubleClick(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QzSettings *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_QZSETTINGS_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("selectAllOnDoubleClick");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("selectAllOnDoubleClick", "bool");
        return -1;
    }

    auto cppOut_local = cppSelf->selectAllOnDoubleClick;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->selectAllOnDoubleClick = cppOut_local;

    return 0;
}

static PyObject *Sbk_QzSettings_get_selectAllOnClick(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QzSettings *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_QZSETTINGS_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    bool cppOut_local = cppSelf->selectAllOnClick;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppOut_local);
    return pyOut;
}
static int Sbk_QzSettings_set_selectAllOnClick(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QzSettings *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_QZSETTINGS_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("selectAllOnClick");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("selectAllOnClick", "bool");
        return -1;
    }

    auto cppOut_local = cppSelf->selectAllOnClick;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->selectAllOnClick = cppOut_local;

    return 0;
}

static PyObject *Sbk_QzSettings_get_showLoadingProgress(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QzSettings *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_QZSETTINGS_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    bool cppOut_local = cppSelf->showLoadingProgress;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppOut_local);
    return pyOut;
}
static int Sbk_QzSettings_set_showLoadingProgress(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QzSettings *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_QZSETTINGS_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("showLoadingProgress");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("showLoadingProgress", "bool");
        return -1;
    }

    auto cppOut_local = cppSelf->showLoadingProgress;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->showLoadingProgress = cppOut_local;

    return 0;
}

static PyObject *Sbk_QzSettings_get_showLocationSuggestions(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QzSettings *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_QZSETTINGS_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    int cppOut_local = cppSelf->showLocationSuggestions;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<int>(), &cppOut_local);
    return pyOut;
}
static int Sbk_QzSettings_set_showLocationSuggestions(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QzSettings *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_QZSETTINGS_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("showLocationSuggestions");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("showLocationSuggestions", "int");
        return -1;
    }

    auto cppOut_local = cppSelf->showLocationSuggestions;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->showLocationSuggestions = cppOut_local;

    return 0;
}

static PyObject *Sbk_QzSettings_get_showSwitchTab(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QzSettings *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_QZSETTINGS_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    bool cppOut_local = cppSelf->showSwitchTab;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppOut_local);
    return pyOut;
}
static int Sbk_QzSettings_set_showSwitchTab(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QzSettings *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_QZSETTINGS_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("showSwitchTab");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("showSwitchTab", "bool");
        return -1;
    }

    auto cppOut_local = cppSelf->showSwitchTab;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->showSwitchTab = cppOut_local;

    return 0;
}

static PyObject *Sbk_QzSettings_get_alwaysShowGoIcon(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QzSettings *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_QZSETTINGS_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    bool cppOut_local = cppSelf->alwaysShowGoIcon;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppOut_local);
    return pyOut;
}
static int Sbk_QzSettings_set_alwaysShowGoIcon(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QzSettings *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_QZSETTINGS_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("alwaysShowGoIcon");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("alwaysShowGoIcon", "bool");
        return -1;
    }

    auto cppOut_local = cppSelf->alwaysShowGoIcon;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->alwaysShowGoIcon = cppOut_local;

    return 0;
}

static PyObject *Sbk_QzSettings_get_useInlineCompletion(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QzSettings *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_QZSETTINGS_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    bool cppOut_local = cppSelf->useInlineCompletion;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppOut_local);
    return pyOut;
}
static int Sbk_QzSettings_set_useInlineCompletion(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QzSettings *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_QZSETTINGS_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("useInlineCompletion");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("useInlineCompletion", "bool");
        return -1;
    }

    auto cppOut_local = cppSelf->useInlineCompletion;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->useInlineCompletion = cppOut_local;

    return 0;
}

static PyObject *Sbk_QzSettings_get_showZoomLabel(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QzSettings *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_QZSETTINGS_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    bool cppOut_local = cppSelf->showZoomLabel;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppOut_local);
    return pyOut;
}
static int Sbk_QzSettings_set_showZoomLabel(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QzSettings *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_QZSETTINGS_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("showZoomLabel");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("showZoomLabel", "bool");
        return -1;
    }

    auto cppOut_local = cppSelf->showZoomLabel;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->showZoomLabel = cppOut_local;

    return 0;
}

static PyObject *Sbk_QzSettings_get_completionPopupExpandToWindow(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QzSettings *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_QZSETTINGS_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    bool cppOut_local = cppSelf->completionPopupExpandToWindow;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppOut_local);
    return pyOut;
}
static int Sbk_QzSettings_set_completionPopupExpandToWindow(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QzSettings *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_QZSETTINGS_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("completionPopupExpandToWindow");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("completionPopupExpandToWindow", "bool");
        return -1;
    }

    auto cppOut_local = cppSelf->completionPopupExpandToWindow;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->completionPopupExpandToWindow = cppOut_local;

    return 0;
}

static PyObject *Sbk_QzSettings_get_searchOnEngineChange(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QzSettings *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_QZSETTINGS_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    bool cppOut_local = cppSelf->searchOnEngineChange;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppOut_local);
    return pyOut;
}
static int Sbk_QzSettings_set_searchOnEngineChange(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QzSettings *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_QZSETTINGS_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("searchOnEngineChange");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("searchOnEngineChange", "bool");
        return -1;
    }

    auto cppOut_local = cppSelf->searchOnEngineChange;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->searchOnEngineChange = cppOut_local;

    return 0;
}

static PyObject *Sbk_QzSettings_get_searchFromAddressBar(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QzSettings *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_QZSETTINGS_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    bool cppOut_local = cppSelf->searchFromAddressBar;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppOut_local);
    return pyOut;
}
static int Sbk_QzSettings_set_searchFromAddressBar(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QzSettings *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_QZSETTINGS_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("searchFromAddressBar");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("searchFromAddressBar", "bool");
        return -1;
    }

    auto cppOut_local = cppSelf->searchFromAddressBar;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->searchFromAddressBar = cppOut_local;

    return 0;
}

static PyObject *Sbk_QzSettings_get_searchWithDefaultEngine(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QzSettings *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_QZSETTINGS_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    bool cppOut_local = cppSelf->searchWithDefaultEngine;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppOut_local);
    return pyOut;
}
static int Sbk_QzSettings_set_searchWithDefaultEngine(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QzSettings *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_QZSETTINGS_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("searchWithDefaultEngine");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("searchWithDefaultEngine", "bool");
        return -1;
    }

    auto cppOut_local = cppSelf->searchWithDefaultEngine;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->searchWithDefaultEngine = cppOut_local;

    return 0;
}

static PyObject *Sbk_QzSettings_get_showABSearchSuggestions(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QzSettings *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_QZSETTINGS_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    bool cppOut_local = cppSelf->showABSearchSuggestions;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppOut_local);
    return pyOut;
}
static int Sbk_QzSettings_set_showABSearchSuggestions(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QzSettings *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_QZSETTINGS_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("showABSearchSuggestions");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("showABSearchSuggestions", "bool");
        return -1;
    }

    auto cppOut_local = cppSelf->showABSearchSuggestions;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->showABSearchSuggestions = cppOut_local;

    return 0;
}

static PyObject *Sbk_QzSettings_get_showWSBSearchSuggestions(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QzSettings *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_QZSETTINGS_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    bool cppOut_local = cppSelf->showWSBSearchSuggestions;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppOut_local);
    return pyOut;
}
static int Sbk_QzSettings_set_showWSBSearchSuggestions(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QzSettings *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_QZSETTINGS_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("showWSBSearchSuggestions");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("showWSBSearchSuggestions", "bool");
        return -1;
    }

    auto cppOut_local = cppSelf->showWSBSearchSuggestions;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->showWSBSearchSuggestions = cppOut_local;

    return 0;
}

static PyObject *Sbk_QzSettings_get_defaultZoomLevel(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QzSettings *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_QZSETTINGS_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    int cppOut_local = cppSelf->defaultZoomLevel;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<int>(), &cppOut_local);
    return pyOut;
}
static int Sbk_QzSettings_set_defaultZoomLevel(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QzSettings *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_QZSETTINGS_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("defaultZoomLevel");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("defaultZoomLevel", "int");
        return -1;
    }

    auto cppOut_local = cppSelf->defaultZoomLevel;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->defaultZoomLevel = cppOut_local;

    return 0;
}

static PyObject *Sbk_QzSettings_get_loadTabsOnActivation(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QzSettings *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_QZSETTINGS_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    bool cppOut_local = cppSelf->loadTabsOnActivation;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppOut_local);
    return pyOut;
}
static int Sbk_QzSettings_set_loadTabsOnActivation(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QzSettings *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_QZSETTINGS_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("loadTabsOnActivation");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("loadTabsOnActivation", "bool");
        return -1;
    }

    auto cppOut_local = cppSelf->loadTabsOnActivation;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->loadTabsOnActivation = cppOut_local;

    return 0;
}

static PyObject *Sbk_QzSettings_get_autoOpenProtocols(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QzSettings *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_QZSETTINGS_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QSTRINGLIST_IDX], &cppSelf->autoOpenProtocols);
    return pyOut;
}
static int Sbk_QzSettings_set_autoOpenProtocols(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QzSettings *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_QZSETTINGS_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("autoOpenProtocols");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QSTRINGLIST_IDX], (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("autoOpenProtocols", "QStringList");
        return -1;
    }

    auto &cppOut_ptr = cppSelf->autoOpenProtocols;
    pythonToCpp(pyIn, &cppOut_ptr);

    return 0;
}

static PyObject *Sbk_QzSettings_get_blockedProtocols(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QzSettings *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_QZSETTINGS_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QSTRINGLIST_IDX], &cppSelf->blockedProtocols);
    return pyOut;
}
static int Sbk_QzSettings_set_blockedProtocols(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QzSettings *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_QZSETTINGS_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("blockedProtocols");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QSTRINGLIST_IDX], (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("blockedProtocols", "QStringList");
        return -1;
    }

    auto &cppOut_ptr = cppSelf->blockedProtocols;
    pythonToCpp(pyIn, &cppOut_ptr);

    return 0;
}

static PyObject *Sbk_QzSettings_get_allowedSchemes(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QzSettings *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_QZSETTINGS_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QSTRINGLIST_IDX], &cppSelf->allowedSchemes);
    return pyOut;
}
static int Sbk_QzSettings_set_allowedSchemes(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QzSettings *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_QZSETTINGS_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("allowedSchemes");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QSTRINGLIST_IDX], (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("allowedSchemes", "QStringList");
        return -1;
    }

    auto &cppOut_ptr = cppSelf->allowedSchemes;
    pythonToCpp(pyIn, &cppOut_ptr);

    return 0;
}

static PyObject *Sbk_QzSettings_get_blockedSchemes(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QzSettings *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_QZSETTINGS_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QSTRINGLIST_IDX], &cppSelf->blockedSchemes);
    return pyOut;
}
static int Sbk_QzSettings_set_blockedSchemes(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QzSettings *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_QZSETTINGS_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("blockedSchemes");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QSTRINGLIST_IDX], (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("blockedSchemes", "QStringList");
        return -1;
    }

    auto &cppOut_ptr = cppSelf->blockedSchemes;
    pythonToCpp(pyIn, &cppOut_ptr);

    return 0;
}

static PyObject *Sbk_QzSettings_get_newTabPosition(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QzSettings *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_QZSETTINGS_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(SbkPyFalkonTypes[SBK_QFLAGS_QZ_NEWTABPOSITIONFLAG_IDX]))->converter, &cppSelf->newTabPosition);
    return pyOut;
}
static int Sbk_QzSettings_set_newTabPosition(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QzSettings *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_QZSETTINGS_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("newTabPosition");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(SbkPyFalkonTypes[SBK_QFLAGS_QZ_NEWTABPOSITIONFLAG_IDX]))->converter, (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("newTabPosition", "NewTabPositionFlags");
        return -1;
    }

    auto cppOut_local = cppSelf->newTabPosition;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->newTabPosition = cppOut_local;

    return 0;
}

static PyObject *Sbk_QzSettings_get_tabsOnTop(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QzSettings *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_QZSETTINGS_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    bool cppOut_local = cppSelf->tabsOnTop;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppOut_local);
    return pyOut;
}
static int Sbk_QzSettings_set_tabsOnTop(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QzSettings *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_QZSETTINGS_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("tabsOnTop");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("tabsOnTop", "bool");
        return -1;
    }

    auto cppOut_local = cppSelf->tabsOnTop;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->tabsOnTop = cppOut_local;

    return 0;
}

static PyObject *Sbk_QzSettings_get_openPopupsInTabs(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QzSettings *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_QZSETTINGS_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    bool cppOut_local = cppSelf->openPopupsInTabs;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppOut_local);
    return pyOut;
}
static int Sbk_QzSettings_set_openPopupsInTabs(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QzSettings *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_QZSETTINGS_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("openPopupsInTabs");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("openPopupsInTabs", "bool");
        return -1;
    }

    auto cppOut_local = cppSelf->openPopupsInTabs;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->openPopupsInTabs = cppOut_local;

    return 0;
}

static PyObject *Sbk_QzSettings_get_alwaysSwitchTabsWithWheel(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QzSettings *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_QZSETTINGS_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    bool cppOut_local = cppSelf->alwaysSwitchTabsWithWheel;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppOut_local);
    return pyOut;
}
static int Sbk_QzSettings_set_alwaysSwitchTabsWithWheel(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QzSettings *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_QZSETTINGS_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("alwaysSwitchTabsWithWheel");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("alwaysSwitchTabsWithWheel", "bool");
        return -1;
    }

    auto cppOut_local = cppSelf->alwaysSwitchTabsWithWheel;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->alwaysSwitchTabsWithWheel = cppOut_local;

    return 0;
}

// Getters and Setters for QzSettings
static PyGetSetDef Sbk_QzSettings_getsetlist[] = {
    {const_cast<char *>("selectAllOnDoubleClick"), Sbk_QzSettings_get_selectAllOnDoubleClick, Sbk_QzSettings_set_selectAllOnDoubleClick, nullptr, nullptr},
    {const_cast<char *>("selectAllOnClick"), Sbk_QzSettings_get_selectAllOnClick, Sbk_QzSettings_set_selectAllOnClick, nullptr, nullptr},
    {const_cast<char *>("showLoadingProgress"), Sbk_QzSettings_get_showLoadingProgress, Sbk_QzSettings_set_showLoadingProgress, nullptr, nullptr},
    {const_cast<char *>("showLocationSuggestions"), Sbk_QzSettings_get_showLocationSuggestions, Sbk_QzSettings_set_showLocationSuggestions, nullptr, nullptr},
    {const_cast<char *>("showSwitchTab"), Sbk_QzSettings_get_showSwitchTab, Sbk_QzSettings_set_showSwitchTab, nullptr, nullptr},
    {const_cast<char *>("alwaysShowGoIcon"), Sbk_QzSettings_get_alwaysShowGoIcon, Sbk_QzSettings_set_alwaysShowGoIcon, nullptr, nullptr},
    {const_cast<char *>("useInlineCompletion"), Sbk_QzSettings_get_useInlineCompletion, Sbk_QzSettings_set_useInlineCompletion, nullptr, nullptr},
    {const_cast<char *>("showZoomLabel"), Sbk_QzSettings_get_showZoomLabel, Sbk_QzSettings_set_showZoomLabel, nullptr, nullptr},
    {const_cast<char *>("completionPopupExpandToWindow"), Sbk_QzSettings_get_completionPopupExpandToWindow, Sbk_QzSettings_set_completionPopupExpandToWindow, nullptr, nullptr},
    {const_cast<char *>("searchOnEngineChange"), Sbk_QzSettings_get_searchOnEngineChange, Sbk_QzSettings_set_searchOnEngineChange, nullptr, nullptr},
    {const_cast<char *>("searchFromAddressBar"), Sbk_QzSettings_get_searchFromAddressBar, Sbk_QzSettings_set_searchFromAddressBar, nullptr, nullptr},
    {const_cast<char *>("searchWithDefaultEngine"), Sbk_QzSettings_get_searchWithDefaultEngine, Sbk_QzSettings_set_searchWithDefaultEngine, nullptr, nullptr},
    {const_cast<char *>("showABSearchSuggestions"), Sbk_QzSettings_get_showABSearchSuggestions, Sbk_QzSettings_set_showABSearchSuggestions, nullptr, nullptr},
    {const_cast<char *>("showWSBSearchSuggestions"), Sbk_QzSettings_get_showWSBSearchSuggestions, Sbk_QzSettings_set_showWSBSearchSuggestions, nullptr, nullptr},
    {const_cast<char *>("defaultZoomLevel"), Sbk_QzSettings_get_defaultZoomLevel, Sbk_QzSettings_set_defaultZoomLevel, nullptr, nullptr},
    {const_cast<char *>("loadTabsOnActivation"), Sbk_QzSettings_get_loadTabsOnActivation, Sbk_QzSettings_set_loadTabsOnActivation, nullptr, nullptr},
    {const_cast<char *>("autoOpenProtocols"), Sbk_QzSettings_get_autoOpenProtocols, Sbk_QzSettings_set_autoOpenProtocols, nullptr, nullptr},
    {const_cast<char *>("blockedProtocols"), Sbk_QzSettings_get_blockedProtocols, Sbk_QzSettings_set_blockedProtocols, nullptr, nullptr},
    {const_cast<char *>("allowedSchemes"), Sbk_QzSettings_get_allowedSchemes, Sbk_QzSettings_set_allowedSchemes, nullptr, nullptr},
    {const_cast<char *>("blockedSchemes"), Sbk_QzSettings_get_blockedSchemes, Sbk_QzSettings_set_blockedSchemes, nullptr, nullptr},
    {const_cast<char *>("newTabPosition"), Sbk_QzSettings_get_newTabPosition, Sbk_QzSettings_set_newTabPosition, nullptr, nullptr},
    {const_cast<char *>("tabsOnTop"), Sbk_QzSettings_get_tabsOnTop, Sbk_QzSettings_set_tabsOnTop, nullptr, nullptr},
    {const_cast<char *>("openPopupsInTabs"), Sbk_QzSettings_get_openPopupsInTabs, Sbk_QzSettings_set_openPopupsInTabs, nullptr, nullptr},
    {const_cast<char *>("alwaysSwitchTabsWithWheel"), Sbk_QzSettings_get_alwaysSwitchTabsWithWheel, Sbk_QzSettings_set_alwaysSwitchTabsWithWheel, nullptr, nullptr},
    {nullptr, nullptr, nullptr, nullptr, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_QzSettings_traverse(PyObject *self, visitproc visit, void *arg)
{
    return SbkObject_TypeF()->tp_traverse(self, visit, arg);
}
static int Sbk_QzSettings_clear(PyObject *self)
{
    return reinterpret_cast<PyTypeObject *>(SbkObject_TypeF())->tp_clear(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QzSettings_Type = nullptr;
static PyTypeObject *Sbk_QzSettings_TypeF(void)
{
    return _Sbk_QzSettings_Type;
}

static PyType_Slot Sbk_QzSettings_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QzSettings_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QzSettings_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QzSettings_methods)},
    {Py_tp_getset,      reinterpret_cast<void *>(Sbk_QzSettings_getsetlist)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QzSettings_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QzSettings_spec = {
    "1:PyFalkon.QzSettings",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QzSettings_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void QzSettings_PythonToCpp_QzSettings_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QzSettings_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_QzSettings_PythonToCpp_QzSettings_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QzSettings_TypeF()))
        return QzSettings_PythonToCpp_QzSettings_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *QzSettings_PTR_CppToPython_QzSettings(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    bool changedTypeName = false;
    auto *tCppIn = reinterpret_cast<const ::QzSettings *>(cppIn);
    const char *typeName = typeid(*tCppIn).name();
    auto *sbkType = Shiboken::ObjectType::typeForTypeName(typeName);
    if (sbkType != nullptr && Shiboken::ObjectType::hasSpecialCastFunction(sbkType)) {
        typeName = Shiboken::typeNameOf(typeid(*tCppIn).name());
        changedTypeName = true;
    }
    PyObject *result = Shiboken::Object::newObject(Sbk_QzSettings_TypeF(), const_cast<void *>(cppIn), false, /* exactType */ changedTypeName, typeName);
    if (changedTypeName)
        delete [] typeName;
    return result;
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *QzSettings_SignatureStrings[] = {
    "PyFalkon.QzSettings(self)",
    "PyFalkon.QzSettings.loadSettings(self)",
    "PyFalkon.QzSettings.saveSettings(self)",
    nullptr}; // Sentinel

void init_QzSettings(PyObject *module)
{
    _Sbk_QzSettings_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QzSettings",
        "QzSettings*",
        &Sbk_QzSettings_spec,
        &Shiboken::callCppDestructor< ::QzSettings >,
        nullptr,
        0,
        0);
    auto *pyType = Sbk_QzSettings_TypeF(); // references _Sbk_QzSettings_Type
    InitSignatureStrings(pyType, QzSettings_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QzSettings_PropertyStrings);
    SbkPyFalkonTypes[SBK_QZSETTINGS_IDX] = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        QzSettings_PythonToCpp_QzSettings_PTR,
        is_QzSettings_PythonToCpp_QzSettings_PTR_Convertible,
        QzSettings_PTR_CppToPython_QzSettings);

    Shiboken::Conversions::registerConverterName(converter, "QzSettings");
    Shiboken::Conversions::registerConverterName(converter, "QzSettings*");
    Shiboken::Conversions::registerConverterName(converter, "QzSettings&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QzSettings).name());

    qRegisterMetaType< ::QzSettings *>();
}
