
// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyfalkon_python.h"

// main header
#include "tabicon_data_wrapper.h"

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_TabIcon_Data_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::TabIcon::Data >()))
        return -1;

    ::TabIcon::Data *cptr{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PyFalkon.TabIcon.Data.__init__";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "Data", 0, 1, &(pyArgs[0])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: Data::Data()
    // 1: Data::Data(TabIcon::Data)
    if (numArgs == 0) {
        overloadId = 0; // Data()
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(SbkPyFalkonTypes[SBK_TABICON_DATA_IDX], (pyArgs[0])))) {
        overloadId = 1; // Data(TabIcon::Data)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, fullName);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // Data()
        {

            if (Shiboken::Errors::occurred() == nullptr) {
                // Data()
                cptr = new ::TabIcon::Data();
            }
            break;
        }
        case 1: // Data(const TabIcon::Data & Data)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::TabIcon::Data cppArg0_local;
            ::TabIcon::Data *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // Data(TabIcon::Data)
                cptr = new ::TabIcon::Data(*cppArg0);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::TabIcon::Data >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_TabIcon_Data__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::TabIcon::Data *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_TABICON_DATA_IDX], reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(SbkPyFalkonTypes[SBK_TABICON_DATA_IDX], &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_TabIcon_Data_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_TabIcon_Data_methods[] = {
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_TabIcon_Data__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

static PyObject *Sbk_TabIcon_Data_get_framesCount(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::TabIcon::Data *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_TABICON_DATA_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    int cppOut_local = cppSelf->framesCount;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<int>(), &cppOut_local);
    return pyOut;
}
static int Sbk_TabIcon_Data_set_framesCount(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::TabIcon::Data *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_TABICON_DATA_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("framesCount");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("framesCount", "int");
        return -1;
    }

    auto cppOut_local = cppSelf->framesCount;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->framesCount = cppOut_local;

    return 0;
}

static PyObject *Sbk_TabIcon_Data_get_animationInterval(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::TabIcon::Data *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_TABICON_DATA_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    int cppOut_local = cppSelf->animationInterval;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<int>(), &cppOut_local);
    return pyOut;
}
static int Sbk_TabIcon_Data_set_animationInterval(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::TabIcon::Data *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_TABICON_DATA_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("animationInterval");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("animationInterval", "int");
        return -1;
    }

    auto cppOut_local = cppSelf->animationInterval;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->animationInterval = cppOut_local;

    return 0;
}

static PyObject *Sbk_TabIcon_Data_get_animationPixmap(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::TabIcon::Data *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_TABICON_DATA_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyOut = {};
    if (reinterpret_cast<void *>(&(cppSelf->animationPixmap)) == reinterpret_cast<void *>(cppSelf)) {
        pyOut = reinterpret_cast<PyObject *>(Shiboken::Object::findColocatedChild(reinterpret_cast<SbkObject *>(self), SbkPySide6_QtGuiTypes[SBK_QPIXMAP_IDX]));
        if (pyOut != nullptr) {
            Py_IncRef(pyOut);
            return pyOut;
        }
    } else if (Shiboken::BindingManager::instance().hasWrapper(&(cppSelf->animationPixmap))) {
        pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(&(cppSelf->animationPixmap)));
        Py_IncRef(pyOut);
        return pyOut;
    }
    pyOut = Shiboken::Object::newObject(SbkPySide6_QtGuiTypes[SBK_QPIXMAP_IDX], &(cppSelf->animationPixmap), false, true);
    Shiboken::Object::setParent(self, pyOut);
    return pyOut;
}
static int Sbk_TabIcon_Data_set_animationPixmap(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::TabIcon::Data *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_TABICON_DATA_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("animationPixmap");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppValueConversion(SbkPySide6_QtGuiTypes[SBK_QPIXMAP_IDX], (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("animationPixmap", "QPixmap");
        return -1;
    }

    auto &cppOut_ptr = cppSelf->animationPixmap;
    pythonToCpp(pyIn, &cppOut_ptr);

    return 0;
}

static PyObject *Sbk_TabIcon_Data_get_audioPlayingPixmap(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::TabIcon::Data *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_TABICON_DATA_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyOut = {};
    if (reinterpret_cast<void *>(&(cppSelf->audioPlayingPixmap)) == reinterpret_cast<void *>(cppSelf)) {
        pyOut = reinterpret_cast<PyObject *>(Shiboken::Object::findColocatedChild(reinterpret_cast<SbkObject *>(self), SbkPySide6_QtGuiTypes[SBK_QPIXMAP_IDX]));
        if (pyOut != nullptr) {
            Py_IncRef(pyOut);
            return pyOut;
        }
    } else if (Shiboken::BindingManager::instance().hasWrapper(&(cppSelf->audioPlayingPixmap))) {
        pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(&(cppSelf->audioPlayingPixmap)));
        Py_IncRef(pyOut);
        return pyOut;
    }
    pyOut = Shiboken::Object::newObject(SbkPySide6_QtGuiTypes[SBK_QPIXMAP_IDX], &(cppSelf->audioPlayingPixmap), false, true);
    Shiboken::Object::setParent(self, pyOut);
    return pyOut;
}
static int Sbk_TabIcon_Data_set_audioPlayingPixmap(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::TabIcon::Data *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_TABICON_DATA_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("audioPlayingPixmap");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppValueConversion(SbkPySide6_QtGuiTypes[SBK_QPIXMAP_IDX], (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("audioPlayingPixmap", "QPixmap");
        return -1;
    }

    auto &cppOut_ptr = cppSelf->audioPlayingPixmap;
    pythonToCpp(pyIn, &cppOut_ptr);

    return 0;
}

static PyObject *Sbk_TabIcon_Data_get_audioMutedPixmap(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::TabIcon::Data *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_TABICON_DATA_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyOut = {};
    if (reinterpret_cast<void *>(&(cppSelf->audioMutedPixmap)) == reinterpret_cast<void *>(cppSelf)) {
        pyOut = reinterpret_cast<PyObject *>(Shiboken::Object::findColocatedChild(reinterpret_cast<SbkObject *>(self), SbkPySide6_QtGuiTypes[SBK_QPIXMAP_IDX]));
        if (pyOut != nullptr) {
            Py_IncRef(pyOut);
            return pyOut;
        }
    } else if (Shiboken::BindingManager::instance().hasWrapper(&(cppSelf->audioMutedPixmap))) {
        pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(&(cppSelf->audioMutedPixmap)));
        Py_IncRef(pyOut);
        return pyOut;
    }
    pyOut = Shiboken::Object::newObject(SbkPySide6_QtGuiTypes[SBK_QPIXMAP_IDX], &(cppSelf->audioMutedPixmap), false, true);
    Shiboken::Object::setParent(self, pyOut);
    return pyOut;
}
static int Sbk_TabIcon_Data_set_audioMutedPixmap(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::TabIcon::Data *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_TABICON_DATA_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("audioMutedPixmap");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppValueConversion(SbkPySide6_QtGuiTypes[SBK_QPIXMAP_IDX], (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("audioMutedPixmap", "QPixmap");
        return -1;
    }

    auto &cppOut_ptr = cppSelf->audioMutedPixmap;
    pythonToCpp(pyIn, &cppOut_ptr);

    return 0;
}

// Getters and Setters for Data
static PyGetSetDef Sbk_TabIcon_Data_getsetlist[] = {
    {const_cast<char *>("framesCount"), Sbk_TabIcon_Data_get_framesCount, Sbk_TabIcon_Data_set_framesCount, nullptr, nullptr},
    {const_cast<char *>("animationInterval"), Sbk_TabIcon_Data_get_animationInterval, Sbk_TabIcon_Data_set_animationInterval, nullptr, nullptr},
    {const_cast<char *>("animationPixmap"), Sbk_TabIcon_Data_get_animationPixmap, Sbk_TabIcon_Data_set_animationPixmap, nullptr, nullptr},
    {const_cast<char *>("audioPlayingPixmap"), Sbk_TabIcon_Data_get_audioPlayingPixmap, Sbk_TabIcon_Data_set_audioPlayingPixmap, nullptr, nullptr},
    {const_cast<char *>("audioMutedPixmap"), Sbk_TabIcon_Data_get_audioMutedPixmap, Sbk_TabIcon_Data_set_audioMutedPixmap, nullptr, nullptr},
    {nullptr, nullptr, nullptr, nullptr, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_TabIcon_Data_traverse(PyObject *self, visitproc visit, void *arg)
{
    return SbkObject_TypeF()->tp_traverse(self, visit, arg);
}
static int Sbk_TabIcon_Data_clear(PyObject *self)
{
    return reinterpret_cast<PyTypeObject *>(SbkObject_TypeF())->tp_clear(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_TabIcon_Data_Type = nullptr;
static PyTypeObject *Sbk_TabIcon_Data_TypeF(void)
{
    return _Sbk_TabIcon_Data_Type;
}

static PyType_Slot Sbk_TabIcon_Data_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_TabIcon_Data_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_TabIcon_Data_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_TabIcon_Data_methods)},
    {Py_tp_getset,      reinterpret_cast<void *>(Sbk_TabIcon_Data_getsetlist)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_TabIcon_Data_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_TabIcon_Data_spec = {
    "1:PyFalkon.TabIcon.Data",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_TabIcon_Data_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void Data_PythonToCpp_Data_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_TabIcon_Data_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_Data_PythonToCpp_Data_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_TabIcon_Data_TypeF()))
        return Data_PythonToCpp_Data_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *Data_PTR_CppToPython_Data(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    bool changedTypeName = false;
    auto *tCppIn = reinterpret_cast<const ::TabIcon::Data *>(cppIn);
    const char *typeName = typeid(*tCppIn).name();
    auto *sbkType = Shiboken::ObjectType::typeForTypeName(typeName);
    if (sbkType != nullptr && Shiboken::ObjectType::hasSpecialCastFunction(sbkType)) {
        typeName = Shiboken::typeNameOf(typeid(*tCppIn).name());
        changedTypeName = true;
    }
    PyObject *result = Shiboken::Object::newObject(Sbk_TabIcon_Data_TypeF(), const_cast<void *>(cppIn), false, /* exactType */ changedTypeName, typeName);
    if (changedTypeName)
        delete [] typeName;
    return result;
}

// C++ to Python copy conversion.
static PyObject *Data_COPY_CppToPython_Data(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::TabIcon::Data *>(cppIn);
    return Shiboken::Object::newObject(Sbk_TabIcon_Data_TypeF(), new ::TabIcon::Data(*source), true, true);
}

// Python to C++ copy conversion.
static void Data_PythonToCpp_Data_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::TabIcon::Data *>(cppOut) = *reinterpret_cast< ::TabIcon::Data *>(Shiboken::Conversions::cppPointer(SbkPyFalkonTypes[SBK_TABICON_DATA_IDX], reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_Data_PythonToCpp_Data_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_TabIcon_Data_TypeF()))
        return Data_PythonToCpp_Data_COPY;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *TabIcon_Data_SignatureStrings[] = {
    "1:PyFalkon.TabIcon.Data(self)",
    "0:PyFalkon.TabIcon.Data(self,Data:PyFalkon.TabIcon.Data)",
    "PyFalkon.TabIcon.Data.__copy__()",
    nullptr}; // Sentinel

void init_TabIcon_Data(PyObject *enclosingClass)
{
    _Sbk_TabIcon_Data_Type = Shiboken::ObjectType::introduceWrapperType(
        enclosingClass,
        "Data",
        "TabIcon::Data",
        &Sbk_TabIcon_Data_spec,
        &Shiboken::callCppDestructor< ::TabIcon::Data >,
        nullptr,
        0,
        Shiboken::ObjectType::WrapperFlags::InnerClass);
    auto *pyType = Sbk_TabIcon_Data_TypeF(); // references _Sbk_TabIcon_Data_Type
    InitSignatureStrings(pyType, TabIcon_Data_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_TabIcon_Data_PropertyStrings);
    SbkPyFalkonTypes[SBK_TABICON_DATA_IDX] = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        Data_PythonToCpp_Data_PTR,
        is_Data_PythonToCpp_Data_PTR_Convertible,
        Data_PTR_CppToPython_Data,
        Data_COPY_CppToPython_Data);

    Shiboken::Conversions::registerConverterName(converter, "TabIcon::Data");
    Shiboken::Conversions::registerConverterName(converter, "TabIcon::Data*");
    Shiboken::Conversions::registerConverterName(converter, "TabIcon::Data&");
    Shiboken::Conversions::registerConverterName(converter, "Data");
    Shiboken::Conversions::registerConverterName(converter, "Data*");
    Shiboken::Conversions::registerConverterName(converter, "Data&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::TabIcon::Data).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        Data_PythonToCpp_Data_COPY,
        is_Data_PythonToCpp_Data_COPY_Convertible);

    qRegisterMetaType< ::TabIcon::Data >("Data");
    qRegisterMetaType< ::TabIcon::Data >("TabIcon::Data");
}
